var __arf_timeout_handle;
window.arf_set_value_of_applied = [];
window.arf_is_submitting_form = false;
function calculate_rule(rule_field_id, rule_field_type, rule_operator, rule_value, form_key, form_data_id, field_key) {
    if( window.arf_is_submitting_form == true ){
        return false;
    }
    
    var value2 = rule_value;

    if (rule_field_type == 'checkbox') {
        var chk = 0;
        jQuery('#arf_fieldset_' + form_data_id + ' input[name="item_meta[' + rule_field_id + '][]"]:checked').each(function(i) {
            var value1 = jQuery(this).val();
            if (match_rule(value1, value2, rule_operator)) {
                chk++;
            }
        });
        var chk_ret;
        if (chk > 0) {
            chk_ret = true;
        } else {
            chk_ret = false;
        }
        if( chk_ret == false ){
            if( jQuery('#arf_fieldset_' + form_data_id + ' input[name="item_meta[' + rule_field_id + '][]"]:checked').length == 0 ){
                if(match_rule('', value2, rule_operator)){
                    chk_ret = true;
                }
            }
        }
        return chk_ret;

    } else if (rule_field_type == 'arf_multiselect') {
        var mulsel = 0;
        var multiinput = jQuery('input#field_' + field_key + '_' + form_data_id).val();
        if (multiinput != null) {
            selected_val_arr = multiinput.toString().split(",");
            for (var i=0; i < selected_val_arr.length; i++) {
                var value1 = selected_val_arr[i];
                if (match_rule(value1, value2, rule_operator)) {
                    mulsel++;
                }    
            }
            var mulsel_ret;
            if (mulsel > 0) {
                mulsel_ret = true;
            } else {
                mulsel_ret = false;
            }
        }
        
        if( jQuery('input#field_' + field_key + '_' + form_data_id).val() == null ){
            if(match_rule('', value2, rule_operator)){
                mulsel_ret = true;
            }
        }
        
        return mulsel_ret;

    } else {
        var value1 = '';
        if (rule_field_type == 'radio' || rule_field_type == 'like' || rule_field_type == 'arf_smiley') {
            var value1 = jQuery('#arf_fieldset_' + form_data_id + ' input[name="item_meta[' + rule_field_id + ']"]:checked').val();
        } else if (rule_field_type == 'select') {
            var value1 = jQuery('input#field_' + field_key + '_' + form_data_id).val();
        } else if (rule_field_type == 'textarea') {
            var value1 = jQuery('textarea#field_' + field_key + '_' + form_data_id).val();
        } else if (rule_field_type == 'scale') {
            var checkedLength = jQuery('input[name="item_meta[' + rule_field_id + ']"]:checked').length;
            var value1 = 0;
            if (checkedLength > 0) {
                value1 = jQuery('input[name="item_meta[' + rule_field_id + ']"]:checked').val();
            }
            if (value1 == 0) {
                value1 = '';
            }
        } else if (rule_field_type == 'arf_switch') {
            var chk = 0;
            jQuery('#arf_fieldset_' + form_data_id + ' input[name="item_meta[' + rule_field_id + ']"]').each(function(i) {
                var value1 = jQuery(this).val();
                if (match_rule(value1, value2, rule_operator)) {
                    chk++;
                }
            });
            if (chk > 0) {
                return true;
            } else {
                return false;
            }
        } else if (rule_field_type == 'date') {
            var el = jQuery('input[name="item_meta[' + rule_field_id + ']"]');
            value1 = el.val();
            if( value2 == '' ){
                if (rule_operator == 'is') {
                    rule_operator = 'equals';
                }
                switch (rule_operator) {
                    case 'equals':
                        return value1 === value2;
                        break;
                    case 'not equals':
                        return value1 !== value2;
                        break;
                    case 'greater than':
                        return value1 > value2;
                        break;
                    case 'less than':
                        return value1 < value2;
                        break;
                    default:
                        return false;
                        break;
                }
            }

            var format = el.attr('data-format');
            var value_temp = moment(value1,format);
            
            var date1 = new Date(value_temp._d);
            var date2 = new Date(value2);
            
            var final_date1 = date1.getFullYear() + '/' + ("0" + (date1.getMonth() + 1)).slice(-2) + '/' + ("0" + date1.getDate()).slice(-2)
            
            var final_date2 = date2.getFullYear() + '/' + ("0" + (date2.getMonth() + 1)).slice(-2) + '/' + ("0" + date2.getDate()).slice(-2)
            
            value1 = final_date1;
            value2 = final_date2;

            var new_value1 = new Date(value1).getTime();
            var new_value2 = new Date(value2).getTime();

            if (rule_operator == 'is') {
                rule_operator = 'equals';
            }
            switch (rule_operator) {
                case 'equals':
                    return new_value1 === new_value2;
                    break;
                case 'not equals':
                    return new_value1 !== new_value2;
                    break;
                case 'greater than':
                    return new_value1 > new_value2;
                    break;
                case 'less than':
                    return new_value1 < new_value2;
                    break;
                default:
                    return false;
                    break;
            }
        } else if (rule_field_type == 'time') {
            var el = jQuery('input[name="item_meta[' + rule_field_id + ']"]');
            var value1 = el.val();

            if( value2 == '' ){
                switch (rule_operator) {
                    case 'equals':
                        return value1 === value2;
                        break;
                    case 'not equals':
                        return value1 !== value2;
                        break;
                    case 'greater than':
                        return value1 > value2;
                        break;
                    case 'less than':
                        return value1 < value2;
                        break;
                }    
            }

            var date = new Date();
            var dd = date.getDate();
            var mm = date.getMonth() + 1;
            var yyyy = date.getFullYear();
            var time = new Date(mm + '/' + dd + '/' + yyyy + ' ' + value1);
            var time2 = new Date(mm + '/' + dd + '/' + yyyy + ' ' + value2);
            time = time.getTime();
            time2 = time2.getTime();
            switch (rule_operator) {
                case 'equals':
                    return time === time2;
                    break;
                case 'not equals':
                    return time !== time2;
                    break;
                case 'greater than':
                    return time > time2;
                    break;
                case 'less than':
                    return time < time2;
                    break;
            }
        } else if ( rule_field_type == 'html' ){
            var value1 = jQuery('input[data-id="field_' + field_key + '_' + form_data_id + '"]' ).val();
        } else {
            var value1 = jQuery('input#field_' + field_key + '_' + form_data_id).val();
            
            if( rule_field_type == 'hidden'){
                var value1 = jQuery('input[name="item_meta[' + rule_field_id + ']"]').val();
            }
            
            if( rule_field_type == 'arf_autocomplete' ){
                if( jQuery("input#field_value_" + field_key + '_' + form_data_id ).length > 0 ){
                    var value1 =jQuery("input#field_value_" + field_key + '_' + form_data_id ).val();
                }
            }
        }
        return match_rule(value1, value2, rule_operator);
    }
    return false;
}

function match_rule(value1, value2, operator) {
    value1 = value1 ? (isNaN(value1) ? value1.toLowerCase() : value1) : ((value1 == '0') ? 0 : "");
    value2 = value2 ? (isNaN(value2) ? value2.toLowerCase() : value2) : ((value2 == '0') ? 0 : "");
    value1 = value1 ? jQuery.trim(value1) : ((value1 == '0') ? 0 : "");
    value2 = value2 ? jQuery.trim(value2) : ((value2 == '0') ? 0 : "");

    var decimal_seperator = jQuery('input[name="arfdecimal_separator"]').val();

    if (decimal_seperator == ',') {
        value1 = value1.replace(/,/g, '.');
        value2 = value2.replace(/,/g, '.');
    }
    
    if (operator == 'equals') {
        operator = 'is';
    }
    if (operator == 'not equals') {
        operator = 'is not';
    }
    switch (operator) {
        case 'is':
            return value1 == value2;
            break;
        case 'is not':
            return value1 != value2;
            break;
        case 'greater than':
            value1 = jQuery.isNumeric(value1) ? parseFloat(value1) : 0;
            value2 = jQuery.isNumeric(value2) ? parseFloat(value2) : 0;
            return value1 > value2;
            break;
        case 'less than':
            value1 = jQuery.isNumeric(value1) ? parseFloat(value1) : 0;
            value2 = jQuery.isNumeric(value2) ? parseFloat(value2) : 0;
            return value1 < value2;
            break;
        case 'contains':
            if (value1 != '' && value2 == '') {
                return false;
            } else if (value1 == '' && value2 != '') {
                return false;
            } else if (value1 == '' && value2 == '') {
                return true;
            } else if (value1 != '' && value2 != '') {
                return (value1.indexOf(value2) >= 0) ? true : false;
            }
            break;
        case 'not contains':
            if (value1 != '' && value2 == '') {
                return true;
            } else if (value1 == '' && value2 != '') {
                return true;
            } else if (value1 == '' && value2 == '') {
                return false;
            } else if (value1 != '' && value2 != '') {
                return (value1.indexOf(value2) >= 0) ? false : true;
            }
            break;
    }
    return false;
}

function apply_rule_on_field(object, f_id, get_display, f_type, page_no, f_data_id) {
    if (f_type == 'break') {
        var form_id = jQuery(object).find('input[name="form_id"]').val();
        var data_hide = jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val();
        page_no = page_no ? page_no : 1;
        page_nav = parseInt(page_no) + 1

        if (get_display == 'show') {
            var data_string = '';
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {} else {
                    data_hide = data_hide.replace(page_no + ',', '');
                }
            } else {
                data_hide = ',';
            }
            data_hide = (data_hide == '') ? ',' : data_hide;
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').show();
                jQuery(object).find('[data-id="previous_last"]').show();
                jQuery(object).find('#page_last').hide();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).hide();
                    jQuery(object).find('[data-id="previous_last"]').show();
                    jQuery(object).find('#page_last').show();
                    jQuery(object).find('#page_last .arf_submit_div').show();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id +'"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
            }

            setTimeout(function(){
                var display_summary_length = jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                }
            },1001);
            var data_id = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-val');
            var data_id = parseInt(data_id) - parseInt(1);
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).show();
            jQuery(object).find('#page_nav_arrow_' + page_nav).show();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }
            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number); 
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        } else if (get_display == 'hide') {
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {
                    data_hide = data_hide + page_no + ',';
                }
            } else {
                data_hide = page_no + ',';
            }
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').hide();
                jQuery(object).find('[data-id="previous_last"]').hide();
                jQuery(object).find('#page_last').show();
                jQuery(object).find('#page_last .arf_submit_div').show();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).show();
                    jQuery(object).find('[data-id="previous_last"]').hide();
                    jQuery(object).find('#page_last').hide();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    var total_hide = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
            }

            setTimeout(function(){
                var display_summary_length = jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                }
            },1001);
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).hide();
            jQuery(object).find('#page_nav_arrow_' + page_nav).hide();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }
            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
            jQuery('.arf_js_colorpicker:not(.arfcolorvalue)').remove();
        }
    }  else if( 'arf_repeater' == f_type ){
        if (get_display == 'show') {
            jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"]').parents('.arf_repeater_field_wrapper').slideDown('slow');
            setTimeout(function(){
                var display_summary_length = jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                }
            },1001);
            if (typeof arf_change_slider != "function") {
                return;
            }
            arf_change_slider(object, f_id, 1);
        } else if (get_display == 'hide') {
            jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"]').parents('.arf_repeater_field_wrapper').slideUp('slow');
            setTimeout(function(){
                var display_summary_length = jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                }
            },1001);
        }
    } else {
        if (f_type == 'submit') {
            if (get_display == 'show') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', false);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').removeClass('arfsubmitdisabled');
            } else if (get_display == 'hide') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', true);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').addClass('arfsubmitdisabled');
            }
        } else if (f_type == 'divider' || 'section' == f_type) {
            if (get_display == 'show') {
                jQuery(object).find('#heading_' + f_id).slideDown('slow');
                setTimeout(function(){
                    var display_summary_length = jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').length;
                    if( display_summary_length > 0 ){
                        jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                    }
                },1001);
                if (typeof arf_change_slider != "function") {
                    return;
                }
                arf_change_slider(object, f_id, 1);
            } else if (get_display == 'hide') {
                jQuery(object).find('#heading_' + f_id).slideUp('slow');
                setTimeout(function(){
                    var display_summary_length = jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').length;
                    if( display_summary_length > 0 ){
                        jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                    }
                },1001);
            }
        } else {
            
            var isChildField = false;
            if( jQuery(".arfformfield.arf_field_" + f_id ).hasClass('arf_child_field' ) ){
                isChildField = true;
            }
            
            if (get_display == 'show') {
                var field_temp_id = '#arf_field_' + f_id + '_' + f_data_id + '_container';
                if( isChildField ){
                    var field_temp_id = 'div[id^="arf_field_' + f_id + '_' + f_data_id + '_container"]';
                }
                jQuery(field_temp_id).slideDown('slow');
                jQuery(field_temp_id).next('div').slideDown('slow');
                if (f_type == 'email') {
                    jQuery('.arf_confirm_email_field_' + f_id).slideDown('slow');
                    jQuery('.arf_confirm_email_field_' + f_id).next('div').slideDown('slow');
                }
                if (f_type == 'password') {
                    jQuery('.arf_confirm_password_field_' + f_id).next('div').slideDown('slow');
                }
                if (f_type == 'arfslider') {
                    if (typeof arf_change_slider != "function") {
                        return;
                    }
                    arf_change_slider(object, f_id, 0);
                }
            } else if (get_display == 'hide') {
                var field_temp_id = '#arf_field_' + f_id + '_' + f_data_id + '_container';
                if( isChildField ){
                    var field_temp_id = 'div[id^="arf_field_' + f_id + '_' + f_data_id + '_container"]';
                }
                jQuery(field_temp_id).slideUp('slow');
                jQuery(field_temp_id).next('div').slideUp('slow');
                if (f_type == 'email') {
                    jQuery('.arf_confirm_email_field_' + f_id).slideUp('slow');
                    jQuery('.arf_confirm_email_field_' + f_id).next('div').slideUp('slow');
                }
                if (f_type == 'password') {
                    jQuery('.arf_confirm_password_field_' + f_id).slideUp('slow');
                    jQuery('.arf_confirm_password_field_' + f_id).next('div').slideUp('slow');
                }
                if (f_type == 'arfslider') {
                    if (typeof arf_change_slider != "function") {
                        return;
                    }
                    arf_change_slider(object, f_id, 0);
                }
                if (f_type == 'file') {
                    var f_upload_field_key = jQuery('[data-id="'+f_id+'"]').attr('id');
                    if(f_upload_field_key!='' && f_upload_field_key!=null)
                    {
                        f_upload_field_key = f_upload_field_key.replace('div_','');
                    }
                    var is_ajax_submission = jQuery(object).find('[data-id="form_submit_type"]').val() == 1 ? 1 : 0;
                    if (is_ajax_submission) {
                        jQuery('#arf_multi_file_uploader_' + f_upload_field_key).find('.ajax-file-remove').each(function() {
                            jQuery(this).trigger('click');
                        });
                    }
                    jQuery('#field_' + f_upload_field_key).val("");
                }
                jQuery('.arf_js_colorpicker:not(.arfcolorvalue)').remove();
            } else if (get_display == 'enable') {
                arf_field_enable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
                if (f_type == 'email') {
                    arf_field_enable(jQuery('.arf_confirm_email_field_' + f_id), 'confirm_email');
                }
                if (f_type == 'password') {
                    arf_field_enable(jQuery('.arf_confirm_password_field_' + f_id), 'confirm_password');
                }
            } else if (get_display == 'disable') {
                if (f_type == 'file') {
                    var f_upload_field_key = jQuery('[data-id="'+f_id+'"]').attr('id');
                    if(f_upload_field_key!='' && f_upload_field_key!=null)
                    {
                        f_upload_field_key = f_upload_field_key.replace('div_','');
                    }
                    var is_ajax_submission = jQuery(object).find('[data-id="form_submit_type"]').val() == 1 ? 1 : 0;
                    if (is_ajax_submission) {
                        
                        jQuery('#arf_multi_file_uploader_' + f_upload_field_key).find('.ajax-file-remove').each(function() {
                            jQuery(this).trigger('click');
                        });
                    }
                    jQuery('#field_' + f_upload_field_key).val("");
                }
                arf_field_disable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
                if (f_type == 'email') {
                    arf_field_disable(jQuery('.arf_confirm_email_field_' + f_id), 'confirm_email');
                }
                if (f_type == 'password') {
                    arf_field_disable(jQuery('.arf_confirm_password_field_' + f_id), 'confirm_password');
                }
            } else if (get_display == 'set_value_of') {}
        }
    }
}

function apply_default_field(object, f_id, get_display, f_type, page_no, f_data_id) {
    if (f_type == 'break') {
        var form_id = jQuery(object).find('input[name="form_id"]').val();
        var data_hide = jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val();
        page_no = page_no ? page_no : 1;
        page_nav = parseInt(page_no) + 1;
        if (get_display == 'hide') {
            var data_string = '';
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {} else {
                    data_hide = data_hide.replace(page_no + ',', '');
                }
            } else {
                data_hide = '';
            }
            data_hide = (data_hide == '') ? ',' : data_hide;
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').show();
                jQuery(object).find('[data-id="previous_last"]').show();
                jQuery(object).find('#page_last').hide();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).hide();
                    jQuery(object).find('[data-id="previous_last"]').show();
                    jQuery(object).find('#page_last').show();
                    jQuery(object).find('#page_last .arf_submit_div').show();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
            }
            var data_id = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-val');
            var data_id = parseInt(data_id) - parseInt(1);
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).show();
            jQuery(object).find('#page_nav_arrow_' + page_nav).show();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }
            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        } else if (get_display == 'show') {
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {
                    data_hide = data_hide + page_no + ',';
                }
            } else {
                data_hide = page_no + ',';
            }
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').hide();
                jQuery(object).find('[data-id="previous_last"]').hide();
                jQuery(object).find('#page_last').show();
                jQuery(object).find('#page_last .arf_submit_div').show();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                arf_clear_page_break_fields('page_' + (parseInt(current_pages) + 1), form_id);
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).show();
                    jQuery(object).find('[data-id="previous_last"]').hide();
                    jQuery(object).find('#page_last').hide();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    var total_hide = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
                arf_clear_page_break_fields('page_' + (parseInt(current_pages) + 1), form_id);
            }
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).hide();
            jQuery(object).find('#page_nav_arrow_' + page_nav).hide();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }
            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        }
    } else {
        if (f_type == 'submit') {
            if (get_display == 'show') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', true);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').addClass('arfsubmitdisabled');
            } else if (get_display == 'hide') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', false);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').removeClass('arfsubmitdisabled');
            }
        } else if (f_type == 'divider' || 'section' == f_type) {
            if (get_display == 'show') {
                jQuery(object).find('#heading_' + f_id).slideUp('slow');
                if (typeof arf_change_slider != "function") {
                    return;
                }
                arf_change_slider(object, f_id, 1);
            } else if (get_display == 'hide') {
                jQuery(object).find('#heading_' + f_id).slideDown('slow');
            }
            var form_id = jQuery(object).find('input[name="form_id"]').val();
            arf_clear_page_break_fields('heading_' + f_id, form_id);
        } else {
            if (get_display == 'show') {
                var form_key = jQuery(object).attr('id');
                form_key = form_key.replace('form_', '');
                form_key = form_key.replace('form_', '');
                var field_key = window['arf_cl'][form_key][f_id]['field_key'];
                var default_value = window['arf_cl'][form_key][f_id]['default_value'];
                arf_set_field_default_value(field_key, default_value, f_type, f_id, object);
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').slideUp('slow');
                jQuery('.arf_js_colorpicker:not(.arfcolorvalue)').remove();
            } else if (get_display == 'hide') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').slideDown('slow');
                if (f_type == 'slider') {
                    if (typeof arf_change_slider != "function") {
                        return;
                    }
                    arf_change_slider(object, f_id, 0);
                }
            } else if (get_display == 'enable') {
                arf_field_disable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
            } else if (get_display == 'disable') {
                arf_field_enable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
            } else if (get_display == 'set_value_of') {}
        }
    }
}

function arf_rule_apply_bulk(form_key, f_data_id) {
    var object = jQuery("form.arfshowmainform[data-id='" + f_data_id + "']");
    var arf_logic = window['arf_conditional_logic'][f_data_id];
    if( arf_logic == null ){
        return false;
    }
    var arf_cl = arf_logic.logic;

    var logics = Object.keys(arf_cl);

    var totalConditions = logics.length;

    var arf_new_cl_rule = [];

    for( var x = 0; x < totalConditions; x++ ){
        var key = logics[x];
        var cl = arf_cl[key];
        var fields = cl.fields;
        for( var f in fields ){
            var rules = fields[f].rules;
            for( var r in rules ){
                arf_new_cl_rule.push(rules[r].fieldId);
            }
        }
    }
    arf_new_cl_rule = arf_find_Unique(arf_new_cl_rule);
    if( arf_new_cl_rule != null ){
        var pattern = /(.*?)(arf_cl_apply_v3\((.*?)\)\;)(\}\,(\d+)(.*))/g;
        var total = arf_new_cl_rule.length;
        for( var i = 0; i < total; i++ ){
            var fid = arf_new_cl_rule[i];
            var field = jQuery(object).find('[name="item_meta['+fid+']"]');
            if( field.length > 0 ){
                if( field.attr('type') == 'radio'){
                    var onChange = field.attr('onchange');
                } else {
                    var onChange = field.attr('onkeyup');
                }
            } else {
                var field = jQuery(object).find('[name="item_meta['+fid+'][]"]');
                var onChange = field.attr('onchange');
            }
            if( typeof onChange == 'undefined' || onChange == null ){
                continue;
            }
            var newOnchanage = onChange.replace(pattern,'$2');
            (function(onchangefunc){
                setTimeout(function(){
                    eval( onchangefunc );
                },100);
            })(newOnchanage)
        }
    }

}

function apply_rule_on_field_bulk(object, f_id, get_display, f_type, page_no, f_data_id) {

    if (f_type == 'break') {
        var form_id = jQuery(object).find('input[name="form_id"]').val();
        var data_hide = jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val();
        page_no = page_no ? page_no : 1;
        page_nav = parseInt(page_no) + 1
        if (get_display == 'show') {
            var data_string = '';
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {} else {
                    data_hide = data_hide.replace(page_no + ',', '');
                }
            } else {
                data_hide = ',';
            }
            data_hide = (data_hide == '') ? ',' : data_hide;
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').show();
                jQuery(object).find('[data-id="previous_last"]').show();
                jQuery(object).find('#page_last').hide();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).hide();
                    jQuery(object).find('[data-id="previous_last"]').show();
                    jQuery(object).find('#page_last').show();
                    jQuery(object).find('#page_last .arf_submit_div').show();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
            }
            var data_id = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-val');
            var data_id = parseInt(data_id) - parseInt(1);
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).show();
            jQuery(object).find('#page_nav_arrow_' + page_nav).show();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }

            setTimeout(function(){
                var display_summary_length = jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                }
            },1001);

            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        } else if (get_display == 'hide') {
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {
                    data_hide = data_hide + page_no + ',';
                }
            } else {
                data_hide = page_no + ',';
            }
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').hide();
                jQuery(object).find('[data-id="previous_last"]').hide();
                jQuery(object).find('#page_last').show();
                jQuery(object).find('#page_last .arf_submit_div').show();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).show();
                    jQuery(object).find('[data-id="previous_last"]').hide();
                    jQuery(object).find('#page_last').hide();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    var total_hide = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
            }
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).hide();
            jQuery(object).find('#page_nav_arrow_' + page_nav).hide();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }
            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }

            setTimeout(function(){
                var display_summary_length = jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                }
            },1001);

            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        }
    } else {
        if (f_type == 'submit') {
            if (get_display == 'show') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', false);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').removeClass('arfsubmitdisabled');
            } else if (get_display == 'hide') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', true);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').addClass('arfsubmitdisabled');
            }
        } else if (f_type == 'divider' || 'section' == f_type) {

            if (get_display == 'show') {
                jQuery(object).find('#heading_' + f_id).removeClass('arf_error');
                jQuery(object).find('#heading_' + f_id).show();
                setTimeout(function(){
                    var display_summary_length = jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').length;
                    if( display_summary_length > 0 ){
                        jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                    }
                },1001);
            } else if (get_display == 'hide') {
                jQuery(object).find('#heading_' + f_id).removeClass('arf_error');
                jQuery(object).find('#heading_' + f_id).hide();
                setTimeout(function(){
                    var display_summary_length = jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').length;
                    if( display_summary_length > 0 ){
                        jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                    }
                },1001);
            }
        } else {
            if (get_display == 'show') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').removeClass('arf_error');
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').show();
            } else if (get_display == 'hide') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').removeClass('arf_error');
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').hide();
            } else if (get_display == 'enable') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').removeClass('arf_error');
                arf_field_enable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
            } else if (get_display == 'disable') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').removeClass('arf_error');
                arf_field_disable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
            } else if (get_display == 'set_value_of') {}
        }
    }
}

function apply_default_field_bulk(object, f_id, get_display, f_type, page_no, f_data_id) {
    
    if (f_type == 'break') {
        
        var form_id = jQuery(object).find('input[name="form_id"]').val();
        var data_hide = jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val();
        page_no = page_no ? page_no : 1;
        page_nav = parseInt(page_no) + 1

        if (get_display == 'hide') {
            var data_string = '';
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {} else {
                    data_hide = data_hide.replace(page_no + ',', '');
                }
            } else {
                data_hide = '';
            }
            data_hide = (data_hide == '') ? ',' : data_hide;
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
            
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').show();
                jQuery(object).find('[data-id="previous_last"]').show();
                jQuery(object).find('#page_last').hide();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).hide();
                    jQuery(object).find('[data-id="previous_last"]').show();
                    jQuery(object).find('#page_last').show();
                    jQuery(object).find('#page_last .arf_submit_div').show();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                    }
                }
            }
            var data_id = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-val');
            var data_id = parseInt(data_id) - parseInt(1);
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).show();
            jQuery(object).find('#page_nav_arrow_' + page_nav).show();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }
            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            setTimeout(function(){
                var display_summary_length = jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                }
            },1001);
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        } else if (get_display == 'show') {
            if (data_hide != '') {
                var data_arr = data_hide.split(',');
                if (jQuery.inArray(page_no.toString(), data_arr) == -1) {
                    data_hide = data_hide + page_no + ',';
                }
            } else {
                data_hide = page_no + ',';
            }
            var total_pages = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var current_pages = jQuery(object).find('.page_break:visible').attr('id');
        
            if(current_pages == undefined){
                if (jQuery(object).find('.page_break').css('display') != 'none'){
                    current_pages = jQuery(object).find('.page_break').attr('id');                   
                }
            }
            current_pages = current_pages.replace('page_', '');
            var page_page_no = page_no;
            if (total_pages == 1) {
                jQuery(object).find('#arf_submit_div_0').hide();
                jQuery(object).find('[data-id="previous_last"]').hide();
                jQuery(object).find('#page_last').show();
                jQuery(object).find('#page_last .arf_submit_div').show();
                jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
            } else {
                if (total_pages == page_page_no && page_page_no == current_pages) {
                    jQuery(object).find('#arf_submit_div_' + page_no).show();
                    jQuery(object).find('[data-id="previous_last"]').hide();
                    jQuery(object).find('#page_last').hide();
                    jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                } else {
                    var default_hide_pages = data_hide;
                    var page_page_no_new_i = page_page_no;
                    var total_hide = page_page_no;
                    for (i = 0; i <= total_pages; i++) {
                        if (default_hide_pages.indexOf(',' + i + ',') >= 0) {
                            continue;
                        } else {
                            page_page_no_new_i = i;
                        }
                    }
                    jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val(page_page_no_new_i);
                    var page_prev_no = parseInt(page_page_no_new_i) - parseInt(1);
                    if (page_page_no_new_i == current_pages && page_page_no_new_i == 0) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else if (page_page_no_new_i == current_pages) {
                        jQuery(object).find('#arf_submit_div_' + current_pages).hide();
                        jQuery(object).find('[data-id="previous_last"]').show();
                        jQuery(object).find('#page_last').show();
                        jQuery(object).find('#page_last .arf_submit_div').show();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('0');
                    } else {
                        jQuery(object).find('#arf_submit_div_' + current_pages).show();
                        jQuery(object).find('[data-id="previous_last"]').hide();
                        jQuery(object).find('#page_last').hide();
                        jQuery(object).find('[data-id="submit_form_' + form_id + '"]').val('1');
                        jQuery(".arfsubmitbutton.arf_submit_div:not(#arf_submit_div_" + current_pages + ")").hide();
                    }
                }
            }
            jQuery(object).find('[data-id="get_hidden_pages_' + form_id + '"]').val(data_hide);
            jQuery(object).find('#page_nav_' + page_nav).hide();
            jQuery(object).find('#page_nav_arrow_' + page_nav).hide();
            var last_show_page = jQuery(object).find('[data-id="last_show_page_' + form_id + '"]').val();
            last_show_page = parseInt(last_show_page) + parseInt(1);
            if (last_show_page > 1) {
                jQuery(object).find('.page_break_nav').removeClass('arf_page_last');
                jQuery(object).find('#page_nav_' + last_show_page).addClass('arf_page_last');
            }

            setTimeout(function(){
                var display_summary_length = jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find("#page_"+page_no).find('.arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                }
            },1001);

            var max_page_no = jQuery(object).find('[data-id="submit_form_' + form_id + '"]').attr('data-max');
            var total_page_number = max_page_no;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {
                    total_page_number = parseInt(total_page_number) - parseInt(1);
                } else {}
            }
            total_page_number = parseInt(total_page_number) + parseInt(1);
            jQuery(object).find('.total_survey_page').html(total_page_number);
            var current_i = 0;
            var current_page_number = jQuery(object).find('.current_survey_page').html();
            current_page_number = (current_page_number !== undefined) ? current_page_number : current_pages;
            for (pi = 0; pi <= max_page_no; pi++) {
                if (data_hide.indexOf(',' + pi + ',') >= 0) {} else {
                    current_i = parseInt(current_i) + parseInt(1);
                    if (current_pages == pi) {
                        current_page_number = current_i;
                    }
                }
            }
            jQuery(object).find('.current_survey_page').html(current_page_number);
            if (current_page_number != '' && current_page_number != 'undefined') {
                if (typeof arf_change_progressbar != "function") {
                    return;
                }
                arf_change_progressbar(object, current_page_number, total_page_number);
            }
            if (current_page_number != '' && current_page_number != 'undefined') {
                arf_change_pagenavigation(object, current_page_number, total_page_number);
            }
        }
    } else if( 'arf_repeater' == f_type ){
        if (get_display == 'show') {
            jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"]').removeClass('arf_error');
            jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"]').parents('.arf_repeater_field_wrapper').slideUp('slow');
            setTimeout(function(){
                var display_summary_length = jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                }
            },1001);

        } else if (get_display == 'hide') {
            jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"]').removeClass('arf_error');
            jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"]').parents('.arf_repeater_field_wrapper').slideDown('slow');
            
            setTimeout(function(){
                var display_summary_length = jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').length;
                if( display_summary_length > 0 ){
                    jQuery(object).find('div[id^="arf_field_'+f_id+'_'+f_data_id+'_container"].arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                }
            },1001);
        }
    } else {
        if (f_type == 'submit') {
            if (get_display == 'show') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', true);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').addClass('arfsubmitdisabled');
            } else if (get_display == 'hide') {
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').attr('disabled', false);
                jQuery(object).find('.arf_submit_btn:not(.arf_print_summary)').removeClass('arfsubmitdisabled');
            }
        } else if (f_type == 'divider' || 'section' == f_type) {
            if (get_display == 'show') {
                jQuery(object).find('#heading_' + f_id).removeClass('arf_error');
                jQuery(object).find('#heading_' + f_id).slideUp('slow');
                setTimeout(function(){
                    var display_summary_length = jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').length;
                    if( display_summary_length > 0 ){
                        jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').addClass('arf_exclude_from_summary');
                    }
                },1001);

            } else if (get_display == 'hide') {
                jQuery(object).find('#heading_' + f_id).removeClass('arf_error');
                jQuery(object).find('#heading_' + f_id).slideDown('slow');
                
                setTimeout(function(){
                    var display_summary_length = jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').length;
                    if( display_summary_length > 0 ){
                        jQuery(object).find('#heading_' + f_id).find('.arf_display_to_confirmation_summary').removeClass('arf_exclude_from_summary');
                    }
                },1001);
            }
        } else {
            
            var isChildField = false;
            if( jQuery(".arfformfield.arf_field_" + f_id ).hasClass('arf_child_field' ) ){
                isChildField = true;
            }
            if (get_display == 'show') {
                var field_temp_id = '#arf_field_' + f_id + '_' + f_data_id + '_container';
                if( isChildField ){
                    var field_temp_id = 'div[id^="arf_field_' + f_id + '_' + f_data_id + '_container"]';
                }
                
                jQuery(field_temp_id).removeClass('arf_error');
                jQuery(field_temp_id).slideUp('slow');
                jQuery(field_temp_id).next('div').slideUp('slow');
                var onChange = jQuery(field_temp_id).find('.controls input').attr('onchange');
                if( typeof onChange == 'undefined' ){
                    var onChange = jQuery(field_temp_id).find('.controls textarea').attr('onchange');
                }
                if( typeof onChange != 'undefined' ){
                    (function(onchangefunc){
                        setTimeout(function(){
                            eval( onchangefunc );
                        },100);
                    })(onChange);
                }
                
                if (f_type == 'email') {
                    jQuery('.arf_confirm_email_field_' + f_id).removeClass('arf_error');
                    jQuery('.arf_confirm_email_field_' + f_id).hide();
                }
                if (f_type == 'password') {
                    jQuery('.arf_confirm_password_field_' + f_id).removeClass('arf_error');
                    jQuery('.arf_confirm_password_field_' + f_id).hide();
                }
            } else if (get_display == 'hide') {
                var field_temp_id = '#arf_field_' + f_id + '_' + f_data_id + '_container';
                if( isChildField ){
                    var field_temp_id = 'div[id^="arf_field_' + f_id + '_' + f_data_id + '_container"]';
                }
                jQuery(field_temp_id).slideDown('slow');
                jQuery(field_temp_id).next('div').slideDown('slow');
                if( typeof onChange == 'undefined' ){
                    var onChange = jQuery(field_temp_id).find('.controls textarea').attr('onchange');
                }
                if( typeof onChange != 'undefined' ){
                    (function(onchangefunc){
                        setTimeout(function(){
                            eval( onchangefunc );
                        },100);
                    })(onChange);
                }
                if (f_type == 'email') {
                    jQuery('.arf_confirm_email_field_' + f_id).removeClass('arf_error');
                    jQuery('.arf_confirm_email_field_' + f_id).show();
                }
                if (f_type == 'password') {
                    jQuery('.arf_confirm_password_field_' + f_id).removeClass('arf_error');
                    jQuery('.arf_confirm_password_field_' + f_id).show();
                }
            } else if (get_display == 'enable') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').removeClass('arf_error');
                arf_field_disable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
                if (f_type == 'email') {
                    jQuery('.arf_confirm_email_field_' + f_id).removeClass('arf_error');
                    arf_field_disable(jQuery('.arf_confirm_email_field_' + f_id), 'confirm_email');
                }
                if (f_type == 'password') {
                    jQuery('.arf_confirm_password_field_' + f_id).removeClass('arf_error');
                    arf_field_disable(jQuery('.arf_confirm_password_field_' + f_id), 'confirm_password');
                }
            } else if (get_display == 'disable') {
                jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container').removeClass('arf_error');
                arf_field_enable(jQuery('#arf_field_' + f_id + '_' + f_data_id + '_container'), f_type);
                if (f_type == 'email') {
                    jQuery('.arf_confirm_email_field_' + f_id).removeClass('arf_error');
                    arf_field_enable(jQuery('.arf_confirm_email_field_' + f_id), 'confirm_email');
                }
                if (f_type == 'password') {
                    jQuery('.arf_confirm_password_field_' + f_id).removeClass('arf_error');
                    arf_field_enable(jQuery('.arf_confirm_password_field_' + f_id), 'confirm_password');
                }
            } else if (get_display == 'set_value_of') {}
        }
    }
}

function arf_set_field_default_value(field_key, default_value, f_type, f_id, object) {
    var f_data_id = jQuery(object).data('id');
    var is_material = jQuery(object).find('.arf_fieldset').hasClass('arf_materialize_form');
    
    if (f_type == 'select' || f_type == 'arf_multiselect') {
        var f_temp_id = "#field_" + field_key + '_' + f_data_id;
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value);
        
        jQuery('#field_' + field_key + '_' + f_data_id).trigger('change');

    } else if (f_type == 'radio') {

        if (default_value != '') {
            jQuery('input[name="item_meta[' + f_id + ']"][value="' + default_value + '"]').prop('checked', true);
        } else {
            jQuery('input[name="item_meta[' + f_id + ']"]:checked').prop('checked',false);
        }
    } else if (f_type == 'checkbox') {
        jQuery('input[name="item_meta[' + f_id + '][]"]').trigger('change');
        if (default_value == '') {
            jQuery('input[name="item_meta[' + f_id + '][]"]:checked').prop('checked',false);
        } else {
            jQuery('input[name="item_meta[' + f_id + '][]"]:checked').prop('checked',false);
            
            if (typeof default_value === 'array' || typeof default_value === 'object') {
                for (var k in default_value) {
                    jQuery('input[name="item_meta[' + f_id + '][]"][value="' + default_value[k] + '"]').prop('checked', true);
                }
            } else {
                jQuery('input[name="item_meta[' + f_id + '][]"][value="' + default_value + '"]').prop('checked', true);
            }
        }
    } else if (f_type == 'arf_smiley') {
        if (default_value != '') {
            jQuery('input[name="item_meta[' + f_id + ']"][value="' + default_value + '"]').prop('checked', true);
        } else {
            jQuery('input[name="item_meta[' + f_id + ']"]:checked').prop('checked', false);
        }
    }else if (f_type == 'arf_switch') {
        jQuery('input[name="switch_item_meta[' + f_id + ']"]').trigger('change');

        if (default_value == '') {
            jQuery('input[name="switch_item_meta[' + f_id + ']"]:checked').prop('checked', false);
        } else {
            jQuery('input[name="switch_item_meta[' + f_id + ']"]:checked').prop('checked', false);
            var leftVal = jQuery('input[name="switch_item_meta[' + f_id + ']"][value="' + default_value + '"]').attr('data-leftval');
            var rightVal = jQuery('input[name="switch_item_meta[' + f_id + ']"][value="' + default_value + '"]').attr('data-rightval');
            if( default_value == rightVal ){
                jQuery('input[name="switch_item_meta[' + f_id + ']"][value="' + default_value + '"]').prop('checked', true);
            } else {
                jQuery('input[name="switch_item_meta[' + f_id + ']"][value="' + default_value + '"]').prop('checked', false);
            }
        }
    }else if (f_type == 'arfslider') {
        var form_data_id = jQuery('input[name="item_meta[' + f_id + ']"]').attr('data-form-data-id');
        if( typeof default_value == 'string' ){
            default_value = parseInt( default_value );
        }
        setTimeout(function(){
            jQuery('.arfslider_front').each(function(){
               var arf_slider_front = document.querySelector('.noUi-target');
               this.noUiSlider.set(default_value);
            });
        },150);
        jQuery('#field_' + field_key+'_'+form_data_id).val(default_value);
    } else if (f_type == 'like') {
        if (default_value == '1') {
            jQuery('#field_' + field_key+'_'+f_data_id+'-0').prop('checked', true);
            jQuery('#like_' + field_key+'_'+f_data_id+'-0').addClass('active');
            jQuery('#field_' + field_key+'_'+f_data_id+'-1').prop('checked', false);
            jQuery('#like_' + field_key+'_'+f_data_id+'-1').removeClass('active');
        } else if (default_value == '0') {
            jQuery('#field_' + field_key +'_'+f_data_id+'-0').prop('checked', false);
            jQuery('#like_' + field_key +'_'+f_data_id+'-0').removeClass('active');
            jQuery('#field_' + field_key +'_'+f_data_id+'-1').prop('checked', true);
            jQuery('#like_' + field_key +'_'+f_data_id+'-1').addClass('active');
        } else {
            jQuery('#field_' + field_key +'_'+f_data_id+'-0').prop('checked', false);
            jQuery('#like_' + field_key +'_'+f_data_id+'-0').removeClass('active');
            jQuery('#field_' + field_key +'_'+f_data_id+'-1').prop('checked', false);
            jQuery('#like_' + field_key +'_'+f_data_id+'-1').removeClass('active');
        }
    } else if (f_type == 'file') {
        if (jQuery('#field_' + field_key).val() != '') {
            var is_ajax_submission = jQuery(object).find('[data-id="form_submit_type"]').val() == 1 ? 1 : 0;
            if (is_ajax_submission) {
                jQuery('#arf_multi_file_uploader_' + field_key + '_' + f_data_id).find('.ajax-file-remove').each(function() {
                    jQuery(this).trigger('click');
                });
            }
            jQuery('#field_' + field_key).val("");
        }
    } else if (f_type == 'time') {
        jQuery('#field_' + field_key+'_'+f_data_id).val(default_value);
    } else if (f_type == 'scale') {
        jQuery('#field_' + field_key).val(default_value);
        if (default_value != '') {
            jQuery('input[name="item_meta[' + f_id + ']"][value="' + default_value + '"]').prop('checked', true);
        } else {
            jQuery('input[name="item_meta[' + f_id + ']"]:checked').prop('checked', false);
        }
    } else if (f_type == 'colorpicker') {
        var color = default_value;
        color = color.replace('#', '');
        jQuery('#field_' + field_key+'_'+ f_data_id).val(default_value);
        jQuery('#colorpicker_div_' + field_key+'_'+ f_data_id).text('#'+color);
        jQuery('#colorpicker_div_' + field_key+'_'+ f_data_id).css('background','#'+color);
    } else if( f_type == 'date' ){
        var default_value = jQuery('#field_' + field_key + '_' + f_data_id).attr('data-default-value') || '';
        jQuery('#field_' + field_key + '_' + f_data_id).attr('value',default_value).trigger('keyup');
    } else if (f_type != 'html' && f_type != 'captcha') {
        var arf_inside_repeater = jQuery("#field_" + field_key + "_" + f_data_id ).parents('.arf_field_type_arf_repeater').length > 0 || false;

        if (f_type == 'email' && jQuery('.arf_confirm_email_field_' + f_id).length > 0) {
            jQuery('.arf_confirm_email_field_' + f_id).find('.controls input').val(default_value).trigger('keyup');
        } else if (f_type == 'password' && jQuery('.arf_confirm_password_field_' + f_id).length > 0) {
            jQuery('.arf_confirm_password_field_' + f_id).find('.controls input').val(default_value).trigger('keyup');
        }
        if( arf_inside_repeater ){
            jQuery('[id^="field_' + field_key + '_' + f_data_id + '"]').val(default_value).trigger('keyup');
        } else {
            jQuery('#field_' + field_key + '_' + f_data_id).val(default_value).trigger('keyup');
        }
    }
}


function arf_set_value_of_field_action_default(field_key, default_value, f_type, f_id, object, f_data_id) {
    
    var is_material = false;
    if( object.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        is_material = true;
    }

    if (f_type == 'select' || f_type == 'arf_multiselect') {
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value);
        jQuery('#field_' + field_key + '_' + f_data_id).trigger('change');
        var selectpicker = jQuery('dl[data-id="field_' + field_key + '_' + f_data_id );
        
        var field_value_label = selectpicker.find( 'dd ul li[data-value="' + default_value + '"]').attr('data-label');
        if( 'undefined' == typeof field_value_label || null == field_value_label ){
            var field_value_label = selectpicker.find('dd ul li:first-child').attr('data-label');
        }
        selectpicker.find('dt span').text( field_value_label );
        
    } else if( f_type == 'arf_autocomplete'){
        var arf_autocomplete = jQuery("#arf_autocomplete_value_"+f_id);
        if( arf_autocomplete.length > 0){
            var arf_auto_labels = arf_autocomplete.attr('data-sep-labels');
            arf_auto_label_obj = JSON.parse(arf_auto_labels);
            var def_val = typeof arf_auto_label_obj[default_value] != 'undefined' ? arf_auto_label_obj[default_value] : '';
            jQuery('#arf_autocomplete_' + f_id).val(def_val);
            arf_autocomplete.val(default_value);
            jQuery('#arf_autocomplete_' + f_id).trigger('change');
        } else {
            jQuery('#field_' + field_key + '_' + f_data_id).val(default_value).trigger('change');
        }

    } else if (f_type == 'radio') {
        if (default_value != '') {
            jQuery('input[name="item_meta[' + f_id + ']"][value="' + default_value + '"]').prop('checked', true);
        } else {
            jQuery('input[name="item_meta[' + f_id + ']"]:checked').prop('checked', false);
        }
        jQuery('input[name="item_meta[' + f_id + ']"]').trigger('change');
    } else if (f_type == 'checkbox') {
        
        if (default_value == '') {
            jQuery('input[name="item_meta[' + f_id + '][]"]:checked').prop('checked',false).trigger('change');            
        } else {
            
            if (typeof default_value == 'array' || typeof default_value == 'object') {
                for (var k in default_value) {
                    jQuery('input[name="item_meta[' + f_id + '][]"][value="' + default_value[k] + '"]').prop('checked', true).trigger('change');
                }
            } else {
                jQuery('input[name="item_meta[' + f_id + '][]"][value="' + default_value + '"]').prop('checked', true).trigger('change');
            }
        }
        jQuery('input[name="item_meta[' + f_id + ']"]').each(function(e) {
            if (jQuery(this).is(':checked')) {
                jQuery(this).parents('.arf_enable_checkbox_image').find('.arf_checkbox_label_image').addClass('checked').trigger('change');
            } else {
                jQuery(this).parents('.arf_enable_checkbox_image').find('.arf_checkbox_label_image').removeClass('checked').trigger('change');
            }
        });
    } else if (f_type == 'arf_switch') { 
        var switchrightval = jQuery('#switch_field_' + field_key + '-' + f_data_id).attr('data-rightval');
        if (default_value == switchrightval) {
            jQuery('input[name="switch_item_meta[' + f_id + ']"]').prop('checked', true).trigger('change');
        }else{
            jQuery('input[name="switch_item_meta[' + f_id + ']"]').prop('checked', false).trigger('change');
        }    
    } else if (f_type == 'arfslider') {
        var form_data_id = jQuery('input[name="item_meta[' + f_id + ']"]').attr('data-form-data-id');        
        if( typeof default_value == 'string' ){
            default_value = parseInt( default_value );
        }
        setTimeout(function(){
            jQuery('#field_' + field_key + '_slide_'+form_data_id).arf_slider('setValue', default_value);
        },150);
        jQuery('#field_' + field_key+'_'+form_data_id).val(default_value);
    } else if (f_type == 'like') {
        if (default_value == '1') {
            jQuery('#field_' + field_key + '_' + f_data_id + '-0').prop('checked', true);
            jQuery('#like_' + field_key + '_' + f_data_id + '-0').addClass('active');
            jQuery('#field_' + field_key + '_' + f_data_id + '-1').prop('checked', false);
            jQuery('#like_' + field_key + '_' + f_data_id + '-1').removeClass('active');
        } else if (default_value === '0') {
            jQuery('#field_' + field_key + '_' + f_data_id + '-0').prop('checked', false);
            jQuery('#like_' + field_key + '_' + f_data_id + '-0').removeClass('active');
            jQuery('#field_' + field_key + '_' + f_data_id + '-1').prop('checked', true);
            jQuery('#like_' + field_key + '_' + f_data_id + '-1').addClass('active');
        } else {
            jQuery('#field_' + field_key + '_' + f_data_id + '-0').prop('checked', false);
            jQuery('#like_' + field_key + '_' + f_data_id + '-0').removeClass('active');
            jQuery('#field_' + field_key + '_' + f_data_id + '-1').prop('checked', false);
            jQuery('#like_' + field_key + '_' + f_data_id + '-1').removeClass('active');
        }
    } else if (f_type === 'time') {
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value).trigger('change');
        
    } else if (f_type === 'scale') {
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value);
        set_votes(jQuery('#' + field_key), field_key + '_' + f_data_id);
    } else if (f_type === 'colorpicker') {
        var color = default_value;
        color = color.replace('#', '');
        
    } else if (f_type == 'email') {
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value).trigger('change');
        jQuery('.arf_confirm_email_field_' + f_id).find('input').val(default_value).trigger('change');
        
    } else if (f_type == 'password') {
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value);
        jQuery('.arf_confirm_password_field_' + f_id).find('input').val(default_value).trigger('change');
        
    } else if (f_type != 'html' && f_type != 'captcha' && f_type != 'hidden') {
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value).trigger('change');
        jQuery('#field_' + field_key + '_' + f_data_id).val(default_value).trigger('keyup');
        setTimeout(function(){
            var keyup_eval = jQuery('#field_' + field_key + '_' + f_data_id).attr('data-arf-keyup');
            if( 'undefined' != typeof keyup_eval ){
                eval( keyup_eval );
            }
        },1000);
    }else if(f_type == 'hidden') {
        /* consitional rule not apply in hidden field changes */
        let field_key = jQuery('input[name="item_meta[' + f_id + ']"]').attr('id').replace('field_', '' );
        var form_key = jQuery('#field_'+field_key).parents(".arf_form_outer_wrapper").find("input[name='form_key']").val();
        var running_total_id = jQuery('#field_'+field_key).attr("data-running_total_id");
        if( typeof running_total_id != 'undefined' && '' != running_total_id ){
            var running_total_ids = running_total_id.split(",").map( Number );
            jQuery('#field_'+field_key).on("change", function(){
                arf_calculate_total(form_key, f_id, running_total_ids);
            });
        }
        jQuery('input[name="item_meta[' + f_id + ']"]').val(default_value).trigger( "change" );    

    }


    if( is_material && typeof arf_material_style_init == 'function'){
        arf_material_style_init();
    }

    if( typeof arf_material_outlined_init == 'function' ){
        arf_material_outlined_init();
    }
}

function arf_change_pagenavigation(object, current_page_number, total_page_number) {
    if (total_page_number == '') {
        return;
    }
    var to_width = (100 / total_page_number);
    to_width = to_width.toFixed(3);
    jQuery(object).find('.arf_wizard .page_break_nav').css('width', to_width + '%');
}

function arf_clear_page_break_fields(page_id, form_id) {
    var f_data_id = jQuery("#"+form_id).attr('data-id'); 
    jQuery('.ar_main_div_' + form_id).find('#' + page_id).find('input[type="file"]').each(function() {
        jQuery(this).val('');
        jQuery(this).attr('data-file-valid', 'true');
        var field_id = jQuery(this).attr('id');
        field_id = field_id.replace('field_', '');
        jQuery('#file_name_' + field_id).html('');
        if (jQuery(this).parents('.controls').next().hasClass('popover')) {
            jQuery(this).parents('.controls').next().hide();
        }
        jQuery('#arf_multi_file_uploader_' + field_id + '_'+ f_data_id).find('.ajax-file-remove').each(function() {
            jQuery(this).trigger('click');
        });
    });
}

jQuery(document).on('change', 'input[type="checkbox"]', function(e) {
    var arffunction = jQuery(this).attr('data-change');
    if (typeof(arffunction != 'undefined') && arffunction != "") {
        eval(arffunction);
        e.stopPropagation();
        e.preventDefault();
    }
});

function arf_field_disable(object, type) {
    
    var is_material = false;

    if( object.parents('.arf_fieldset').hasClass('arf_materialize_form') ){
        is_material = true;
    }
    
    object.attr('data-view', 'arf_disable');
    if (type == 'checkbox' || type == 'radio' || type == 'scale' || type == 'like') {
        object.find('*').prop("disabled", true);
    } else if (type == 'select' || type == 'arf_multiselect') {
        object.find('input').prop("disabled", "disabled");
        object.find('select').prop("disabled", "disabled");
    } else if (type == 'arfslider') {
        setTimeout(function() {
            object.find(".arfslider_front").attr('disabled',true);  
        }, 300);
    } else if (type == 'scale') {
        object.find('.ratings_stars').addClass('arf_ratings_stars_disable');
    } else if (type == 'like') {
        object.find('.arf_like').addClass('arf_like_disable');
        object.find('.arf_like_btn').addClass('arf_like_disable');
        object.find('.arf_dislike_btn').addClass('arf_like_disable');
    } else if (type == 'colorpicker') {
        object.find('.arf_colorpicker').addClass('arf_colorpicker_disable');
        object.find('.arf_colorpicker_disable').removeClass('arf_colorpicker');
        object.find('.arf_color_picker_input').prop('disabled',true);
    } else if(type=="signature"){
        var html_content = "<div class='arf_signature_disable_wrapper'></div>";
        var html_content2 = "<div class='arf_signature_reset_disable_wrapper'></div>";
        if(object.find('.arf_signature_disable_wrapper').length == 0){
            object.find(".arf_dig_sig_sigWrapper").append(html_content);
            object.find(".arf_dig_sig_clear").append(html_content2);
        }   
    } else if( type == 'arf_wysiwyg' ){
        let control = object.find('.arf_rich_text_editor');
        control.trumbowyg( 'disable' );
        if(object.find('button.trumbowyg-fullscreen-button').hasClass('trumbowyg-not-disable')){
            object.find('button.trumbowyg-fullscreen-button').removeClass('trumbowyg-not-disable');
        }
    } else {
        object.find("*").prop("disabled", true);
    }
    jQuery('.arf_js_colorpicker:not(.arfcolorvalue)').remove();
}

function arf_field_enable(object, type) {
    var is_material = false;

    if( object.parents('.arf_fieldset').hasClass('arf_materialize_form') ){
        is_material = true;
    }

    object.css('pointer-events', '');
    object.css('opacity', '');
    object.attr('data-view', 'arf_enable');
    if (type == 'checkbox' || type == 'radio' || type == 'scale' || type == 'like') {
        object.find("*").prop("disabled", false);
        object.find("*").removeClass("disabled");
    } else if (type == 'select' || type == 'arf_multiselect') {
        object.find('select').prop("disabled", false);
        object.find('input').prop("disabled", false);
        object.find("*").removeClass("disabled");
    } else if (type == 'arfslider') {
        setTimeout(function() {
            object.find(".arfslider_front").attr('disabled',false);  
        }, 300);
    } else if (type == 'scale') {
        object.find('.ratings_stars').removeClass('arf_ratings_stars_disable');
    } else if (type == 'like') {
        object.find('.arf_like').removeClass('arf_like_disable');
        object.find('.arf_like_btn').removeClass('arf_like_disable');
        object.find('.arf_dislike_btn').removeClass('arf_like_disable');
    } else if (type == 'colorpicker') {
        object.find('.arf_colorpicker_disable').addClass('arf_colorpicker');
        object.find('.arf_colorpicker').removeClass('arf_colorpicker_disable');
        object.find('.arf_color_picker_input').prop('disabled',false);
    } else if(type=="signature"){
        object.find(".arf_signature_disable_wrapper").remove();
        object.find(".arf_signature_reset_disable_wrapper").remove();
	    jQuery( object ).find( ".arf_clear_pad" ).trigger( "click" );
    } else if( type == 'arf_wysiwyg' ){
        let control = object.find('.arf_rich_text_editor');
        control.trumbowyg( 'enable' );
    } else {
        object.find("*").prop("disabled", false);
    }

}


function arf_new_cl_apply(from_key, field_id, field_type, field_key, f_data_id) {
    var object = jQuery('.arfshowmainform[data-form-id="form_' + from_key + '"][data-id="' + f_data_id + '"]');
    try {
        var arf_logic = jQuery(object).parent().find('.arf-cl').text();
        arf_logic = JSON.parse(arf_logic);
    } catch (e) {
        var arf_logic = jQuery(object).parent().find('.arf-cl').html();
        arf_logic = JSON.parse(arf_logic);
    }
    if (arf_logic == '' || arf_logic == null) {
        try {
            var arf_logic = jQuery('.arf-cl').text();
            arf_logic = JSON.parse(arf_logic);
        } catch (e) {
            var arf_logic = jQuery('.arf-cl').html();
            arf_logic = JSON.parse(arf_logic);
        }
    }
    var conditional_fields = {};
    for (var n in arf_logic) {
        conditional_fields[n] = [];
        var condition = arf_logic[n].condition;
        for (var i = 0; i < condition.counter; i++) {
            conditional_fields[n][i] = condition[i].field_id;
        }
    }
    var cnd_fields = [];
    var ab = 0;
    for (var j in conditional_fields) {
        for (var n in conditional_fields[j]) {
            var value = conditional_fields[j][n];
            cnd_fields[ab] = value;
            ab++;
        }
    }
    conditional_fields = cnd_fields;
    conditional_fields = arf_unique_array(conditional_fields);
    for (var x in arf_logic) {
        var condition = arf_logic[x].condition;
        var results = arf_logic[x].result;
        var operator = arf_logic[x].operator;
        var arf_current_form = arf_logic[x].arf_current_form;
        var clen = condition.counter;
        var rlen = results.counter;
        if (operator !== undefined) {
            delete condition.operator;
        }
        operator = operator.replace('and', '&&');
        operator = operator.replace('or', '||');
        delete condition.counter;
        delete results.counter;
        var object = '';
        if (arf_current_form != '') {
            jQuery("form.arfshowmainform").each(function() {
                if (arf_current_form == jQuery(this).attr('data-id')) {
                    object = jQuery(this);
                }
            });
        } else {
            object = jQuery("form.arfshowmainform");
        }
        var object_parent_id = object.parent().attr('id');
        var pattern = /arffrm_(\d+)_container/g;
        var form_id = object_parent_id.replace(pattern, '$1');
        var form_key = object.find('[data-id="form_key_' + form_id + '"]').val();
        if (clen >= 1) {
            var arf_cl_script = 'if( ';
            for (var c = 0; c < clen; c++) {
                var c_field_id = condition[c].field_id;
                if (jQuery.inArray(field_id, conditional_fields) === -1) {
                    return;
                }
                var c_field_op = condition[c].field_operator.replace('is not', '!=');
                c_field_op = lfield_opt = c_field_op.replace('is', '==');
                var c_field_type = condition[c].field_type;
                var c_field_value = condition[c].field_value;
                var c_field_key = condition[c].field_key;
                var field_operator_ = '';
                switch (condition[c].field_operator) {
                    case 'is':
                        field_operator_ = 'equals';
                        break;
                    case 'is not':
                        field_operator_ = "not equals";
                        break;
                    default:
                        field_operator_ = condition[c].field_operator;
                        break;
                }
                arf_cl_script += calculate_rule(c_field_id, c_field_type, field_operator_, c_field_value, form_key, arf_current_form, c_field_key);
                if (Number(clen) != Number(c + 1)) {
                    arf_cl_script += " " + operator + " ";
                }
            }
            arf_cl_script += '){';
        }
        arf_cl_script += "true";
        arf_cl_script += '}else{';
        arf_cl_script += "false";
        arf_cl_script += '}';
        
        if (rlen >= 1) {
            for (var r = 0; r < rlen; r++) {
                var r_action = results[r].action;
                var r_field_id = results[r].field_id;
                var r_field_type = results[r].field_type;
                var r_field_value = results[r].field_value;
                var r_page_no = results[r].page;
                var r_field_key = results[r].field_key;
                var r_field_default_value = results[r].field_default_value;
                if (eval(arf_cl_script)) {
                    if (r_action === 'set_value_of') {
                        arf_set_value_of_field_action_default(r_field_key, r_field_value, r_field_type, r_field_id, jQuery(object), f_data_id);
                    } else {
                        apply_rule_on_field(jQuery(object), r_field_id, r_action, r_field_type, r_page_no, f_data_id);
                    }
                } else {
                    if (r_action === 'set_value_of') {
                        arf_set_value_of_field_action_default(r_field_key, r_field_default_value, r_field_type, r_field_id, jQuery(object), f_data_id);
                    } else {                        
                        arf_set_field_default_value(r_field_key, r_field_default_value, r_field_type, r_field_id, jQuery(object));
                        apply_default_field_bulk(jQuery(object), r_field_id, r_action, r_field_type, r_page_no, f_data_id);
                    }
                }
            }
        }
    }
}

function arf_unique_array(array) {
    return array.filter(function(el, index, arr) {
        return index == arr.indexOf(el);
    });
}

function arf_cl_apply_v3(form_id, fields) {
    var rule_applied = 0;
    var nfields = [];
    if( typeof window.is_model_form != 'undefined' && false == window.is_model_form && jQuery('#arf_fieldset_' + form_id ).parents('.arfmodal-body').length > 0 ){
        return false;
    }
    if( typeof Object(fields).length == 'undefined' ){
        var field_keys = Object.keys(fields);
        for(var n = 0; n < field_keys.length; n++ ){
            var fkey = field_keys[n];
            nfields.push(fields[fkey]);
        }
    } else {
        nfields = fields;
    }
    
    for (var i = 0; i < nfields.length; i++) {
        arf_field_apply_rule(form_id, nfields[i]);
    }
}

function arf_field_apply_rule(formId, fieldId) {
    
    if( window.arf_is_submitting_form == true ){
        return false;
    }

    if (!window["arf_conditional_logic"] || !window["arf_conditional_logic"][formId] || !window["arf_conditional_logic"][formId]["logic"][fieldId]) {
        return false;
    }
    
    var conditionalLogicArray = window["arf_conditional_logic"][formId]["logic"][fieldId]["fields"];
    if( window.arf_set_value_of_applied === undefined){
        window.arf_set_value_of_applied = [];
    }
    
    window.arf_set_value_of_applied["'" + formId + "'"] = [];

    if( window.arf_set_field_conditional_logic_of_applied === undefined){
        window.arf_set_field_conditional_logic_of_applied = [];
    }
    
    window.arf_set_field_conditional_logic_of_applied[ formId  ] = [];
    
    var matches = 0;
    if (formId != '') {
        var object = jQuery('.arfshowmainform[data-id=' + formId + ']');
    } else {
        var object = jQuery('.arfshowmainform');
    }
    var form_parent_id = object.parent().attr('id');
    var pattern = /arffrm_(\d+)_container/g;
    var form_id = form_parent_id.replace(pattern, '$1');
    var form_key = object.find('[data-id="form_key_' + form_id + '"]').val();
    
    var objKeys = Object.keys(conditionalLogicArray);
    for( var clk = 0; clk < objKeys.length; clk++ ){
        
        var obj_key = objKeys[clk];
        var conditionalLogic = conditionalLogicArray[obj_key];

        var operator = conditionalLogic['logicType'];

        operator = operator.replace('all', '&&');
        operator = operator.replace('any', '||');
        operator = operator.replace('All', '&&');
        operator = operator.replace('Any', '||');

        var arf_script = 'if(';
        var clen = conditionalLogic.rules.length;
	
        for (var i = 0; i < clen; i++) {
            var rule = conditionalLogic.rules[i];
            var field_type = rule.fieldType;
            var field_id = rule.fieldId;
            var field_key = rule.fieldKey;
            var field_operator = '';
            switch (rule.operator) {
                case 'is':
                    field_operator = 'equals';
                    break;
                case 'is not':
                    field_operator = 'not equals';
                    break;
                default:
                    field_operator = rule.operator;
                    break;
            }
            var field_value = rule.value;

            arf_script += calculate_rule(field_id, field_type, field_operator, field_value, form_key, formId, field_key);

            if (Number(clen) != Number(i + 1)) {
                arf_script += " " + operator + " ";
            }
        }
	
        arf_script += '){';
        arf_script += 'true';
        arf_script += '}else{';
        arf_script += "false";
        arf_script += '}';
        var r_action = conditionalLogic['actionType'];
        var r_field_id = fieldId;
        var r_field_type = conditionalLogic['field_type'];
        var r_field_value = conditionalLogic['value'];
        if( '' != r_field_value && /^\[(.*)\]+$/.test( r_field_value ) ){
            try{
                r_field_value = JSON.parse( r_field_value );
            }catch(e){

            }
        }
        var r_field_key = conditionalLogic['field_key'];
        var r_field_default_value = conditionalLogic['default_value'];
        var f_data_id = formId;
        var r_page_no = conditionalLogic['page_no'];
        
        if(r_field_type=='break' || r_field_type=='divider' || r_field_type == 'section' || r_field_type == 'arf_repeater'){
                
            var page_break_fields=window["arf_conditional_logic"][formId]["logic"];

            var conditional_fields = [];

            jQuery.each(page_break_fields, function(i, fieldsdata) {
                
                jQuery.each(fieldsdata, function(field, field_data) {
                    var objKeys = Object.keys(field_data);
                    for( var clk = 0; clk < objKeys.length; clk++ ){
                            var obj_key = objKeys[clk];
                            var conditional_Logic = field_data[obj_key];
                            if(conditional_Logic['field_type']=="break" || conditional_Logic['field_type']=='divider' || conditional_Logic['field_type'] == 'section' || conditional_Logic['field_type'] == 'arf_repeater'){
                                var clen_data = conditional_Logic.rules.length;
                                
                                for (var ci = 0; ci < clen_data; ci++) {
                                    var rule_one = conditional_Logic.rules[ci];
                                    var rule_fieldId=[];
                                    rule_fieldId['field_id']=rule_one.fieldId;
                                    rule_fieldId['field_value']=rule_one.value;
                                    rule_fieldId['field_key']=rule_one.fieldKey;
                                    rule_fieldId['page_no']=conditional_Logic.page_no;
                                    rule_fieldId['page_break_id']=i;
                                    conditional_fields.push(rule_fieldId);
                                    
                                }
                            }     
                      }  

                });

            });
            
        }
        var all_pages_fields= (typeof window["arf_pages_fields"] != 'undefined' ) ? window["arf_pages_fields"][formId] : [];

        if (eval(arf_script)) {
            if (window.arf_set_field_conditional_logic_of_applied[formId].indexOf(r_field_id) < 0) {
                window.arf_set_field_conditional_logic_of_applied[formId].push(r_field_id);
            }
            if (r_action == 'set_value_of' && window.arf_set_value_of_applied["'"+formId+"'"].indexOf(r_field_id) < 0) {
                window.arf_set_value_of_applied["'"+formId+"'"].push(r_field_id);
                arf_set_value_of_field_action_default(r_field_key, r_field_value, r_field_type, r_field_id, jQuery(object), f_data_id);
            } else {
                apply_rule_on_field(jQuery(object), r_field_id, r_action, r_field_type, r_page_no, f_data_id);
            }
        } else if (window.arf_set_field_conditional_logic_of_applied[formId].indexOf(r_field_id) < 0) {
            if( r_action == "set_value_of" && window.arf_set_value_of_applied["'"+formId+"'"].indexOf(r_field_id) > -1 ){
                delete window.arf_set_value_of_applied["'"+formId+"'"][window.arf_set_value_of_applied["'"+formId+"'"].indexOf(r_field_id)];
            }

            if (r_action == 'set_value_of') {
                arf_set_value_of_field_action_default(r_field_key, r_field_default_value, r_field_type, r_field_id, jQuery(object), f_data_id);
            } else {
                
                if(r_field_type=='break'){
                    if(conditional_fields.length && all_pages_fields.length > 0){
                        jQuery.each(all_pages_fields, function(index, fielddata) {

                            if(fielddata.page_no==r_page_no && fielddata.field_key != r_field_key && fielddata.field_type!='break'){
                                
                                arf_set_field_default_value(fielddata.field_key, fielddata.default_value, fielddata.field_type, fielddata.field_id, jQuery(object));
                            }
                        });
                        jQuery.each(conditional_fields, function(index, conditionaldata) {
                            
                            if(jQuery('.page_break#page_'+r_page_no+' div.arf_field_'+conditionaldata['field_id']).length && conditionaldata['page_break_id'] != r_field_id){
                                
                                apply_default_field_bulk(jQuery(object), conditionaldata['page_break_id'], r_action, r_field_type,conditionaldata['page_no'], f_data_id);
                            }
                           
                        });
                    }
                }
                if(r_field_type=='divider' || r_field_type == 'section'){

                    if(conditional_fields.length){
                        jQuery.each(all_pages_fields, function(index, fielddata) {
                            if(fielddata.heading_id==r_field_id && fielddata.field_key != r_field_key && ( fielddata.field_type!='divider' || fielddata.field_type != 'section' ) ){
                                arf_set_field_default_value(fielddata.field_key, fielddata.default_value, fielddata.field_type, fielddata.field_id, jQuery(object));
                            }
                        });
                        jQuery.each(conditional_fields, function(index, conditionaldata) {
                            if(jQuery('.page_break #heading_'+r_field_id+' div.arf_field_'+conditionaldata['field_id']).length && conditionaldata['page_break_id'] != r_field_id){
                                apply_default_field_bulk(jQuery(object), conditionaldata['page_break_id'], r_action, r_field_type,conditionaldata['page_no'], f_data_id);
                            }
                           
                        });
                    }
                }
                if( r_field_type == 'arf_repeater' ){
                    if( conditional_fields.length ){
                        jQuery.each( all_pages_fields, function(index, fielddata){
                            if( fielddata.repeater_id == r_field_id && fielddata.field_key != r_field_key && fielddata.field_type !='arf_repeater' ){
                                arf_set_field_default_value(fielddata.field_key, fielddata.default_value, fielddata.field_type, fielddata.field_id, jQuery(object) );
                            }
                        });
                        jQuery.each( conditional_fields, function(index, conditionaldata){
                            if(jQuery(".page_break .arf_field_type_arf_repeater.arf_field_" + r_field_id + ' div.arf_field_' + conditionaldata['field_id']).length && conditionaldata['page_break_id'] != r_field_id ){
                                apply_default_field_bulk( jQuery(object), conditionaldata['page_break_id'], r_action, r_field_type, conditionaldata['page_no'],f_data_id);
                            }
                        });
                    }
                }

                arf_set_field_default_value(r_field_key, r_field_default_value, r_field_type, r_field_id, jQuery(object));
                apply_default_field_bulk(jQuery(object), r_field_id, r_action, r_field_type, r_page_no, f_data_id);
                jQuery("#field_" + r_field_key + "_" + f_data_id).trigger('change');
            }
        }
    }
}