"use strict";
jQuery(document).ready(function(){	
	wp.hooks.addFilter( "arforms_gutenberg_additional_options", 'arforms', arforms_addition_block_options, 10, 2 );
});

function arforms_addition_block_options( arforms_form_settings, props ){

	let arforms_pro_options = [
		wp.element.createElement(
			wp.components.SelectControl,
			{
				className: "arflite_form_display",
				label: wp.i18n.__("Form", "arforms-form-builder"),
				value: props.attributes.short_code,
				options: arflite_get_form_list(),
				onChange: function (e) {
					arflite_update_renderer(props, e);
				}
			},
		),
	];

	return arforms_form_settings.concat( arforms_pro_options );
}