var ajaxProcess = false;
window.is_drag = false;

function $id(id) {
    return document.getElementById(id);
}

function Output(msg) {
    var m = $id("messages");
}

function FileDragHover(e) {
    
    e.stopPropagation();
    e.preventDefault();
    
    var is_disabled = jQuery(e.target).parents('.arfmainformfield').attr('data-view');
    if( is_disabled != 'arf_disable' ){
        e.target.className = (e.type == "dragover" ? "arf_hover_file arf_file_drag_reply_container" : "arf_file_drag_reply_container");
    }
}

function FileSelectHandler(e) {

    var files = e.target.files || e.dataTransfer.files;

    var files_new = files;
    var $this = jQuery(this);
    
    var max_file_upload = jQuery(this).attr('data-validation-maxupload-maxupload') || 0;
    max_file_upload = parseInt( max_file_upload );

    if( files.length < 1 ){
        return false;
    }

    for (var i = 0, f; f = files[i]; i++) {

        var field_key_arr = $this.attr('id').split('field_');

        var field_key = field_key_arr[1];

        var newupload_count_id = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress:last').attr('arfupldcnt');

        var newupload_count = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress').length;
        
        if(newupload_count == 'undefined' || isNaN(newupload_count) || newupload_count == ""){
            newupload_count = 1;
        } else {
            newupload_count = parseInt(newupload_count)+1;
        }

        if(newupload_count_id == 'undefined' || isNaN(newupload_count_id) || newupload_count_id == ""){
            newupload_count_id = 1;
        } else {
            newupload_count_id = parseInt(newupload_count_id)+1;
        }

        var total_files = newupload_count;

        var field_name_arr = jQuery(this).attr('name').split('file');
        var field_name = field_name_arr[1];

        var field_type = jQuery('#file_types_' + field_key).val();

        var frmid = jQuery(this).attr('data-form-id');

        var frmdataid = jQuery(this).attr('data-form-data-id');

        var field_name_id = field_name;
        var field_size = jQuery('#file_size_' + field_key).val();

        if (typeof max_file_upload == 'undefined' || max_file_upload == '' || max_file_upload == 0) { 
            var default_content = document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML;
            var $arf_div_to_append = '<div class = "arfprogress progress-striped" id = "progress_' + field_key + '_' + newupload_count_id + '" arfupldcnt="'+newupload_count_id+'" style = "display: block;" > <div style = "width:0%;" class = "bar" > </div></div > <div style = "display: inline-block;" class = "arf_info" id = "info_' + field_key + '_' + newupload_count_id + '" > <span class = "percent" > % Completed </span><span class="percent" id="percent">0</span > </div>';
            document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML = default_content + $arf_div_to_append;
            jQuery('#arf_multi_file_uploader_' + field_key).show();
        }

        if (max_file_upload != '' && max_file_upload != 0 ) {
            
            if (total_files <= max_file_upload) {
                var default_content = document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML;
                var $arf_div_to_append = '<div class = "arfprogress progress-striped" id = "progress_' + field_key + '_' + newupload_count_id + '" arfupldcnt="'+newupload_count_id+'" style = "display: block;" > <div style = "width:0%;" class = "bar" > </div></div > <div style = "display: inline-block;" class = "arf_info" id = "info_' + field_key + '_' + newupload_count_id + '" > <span class = "percent" > % Completed </span><span class="percent" id="percent">0</span > </div>';
                document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML = default_content + $arf_div_to_append;
                jQuery('#arf_multi_file_uploader_' + field_key).show();
            }
        }
    }

    var arf_file_interval = setInterval(function () {
        
        if (!ajaxProcess) {

            var field_key_arr = $this.attr('id').split('field_');

            var field_key = field_key_arr[1];

            var field_name_arr = $this.attr('name').split('file');
            var field_name = field_name_arr[1];

            var field_type = jQuery('#file_types_' + field_key).val();

            var frmid = $this.attr('data-form-id'); 

            var frmdataid = $this.attr('data-form-data-id');

            var field_name_id = field_name;

            var field_size = jQuery('#file_size_' + field_key).val();
            
            var newupload_count_id = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress.counting:last').attr('arfupldcnt');
            
            var newupload_count = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress.counting').length;

            if(newupload_count == 'undefined' || isNaN(newupload_count) || newupload_count == ""){
                newupload_count = 1;
            } else {
                newupload_count = parseInt(newupload_count)+1;
            }

            if( newupload_count_id == 'undefined' || isNaN(newupload_count_id) || newupload_count_id == "" ){
                newupload_count_id = 1;
            } else {
                newupload_count_id = parseInt( newupload_count_id ) + 1;
            }

            if (max_file_upload != '' && max_file_upload != 0 && newupload_count > max_file_upload) {
                newupload_count = 0;
            }
            
            if (newupload_count > 0) {
                UploadFile(files_new[Object.keys(files_new)[0]], field_key, field_type, frmid, field_name_id, field_size, frmdataid, newupload_count_id, newupload_count);
            }

            var myObj = new Object;
            for (var i = 0; i < files_new.length; i++) {
                if (i !== 0) {
                    myObj[i - 1] = files_new[i];
                    myObj.length = i;
                }
            }

            files_new = myObj;
            if (jQuery.isEmptyObject(files_new)) {
                clearInterval(arf_file_interval);
            }
        } else {

        }
    }, 0);
}


function FileSelectHandlerDrag(e) {

    
    window.is_drag = true;
    
    e.preventDefault();
    
    var is_disabled = jQuery(e.target).parents('.arfmainformfield').attr('data-view');
    
    if( is_disabled == 'arf_disable' ){
        return false;
    }
    
    FileDragHover(e);

    var files = e.target.files || e.dataTransfer.files;

    if (ajaxProcess) {
        return false;
    }

    var files_new = files;
    var $this = jQuery(this);
    var data_field_id = $this.attr('data-id');
    var max_file_upload = jQuery('#' + data_field_id).attr('data-validation-maxupload-maxupload') || 0;
    var file_id = jQuery(this).data('id');
    for (var i = 0, f; f = files[i]; i++) {

        var field_key_arr = jQuery('#' + file_id).attr('id').split('field_');

        var field_key = field_key_arr[1];
        
        var newupload_count_id = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress:last').attr('arfupldcnt');

        var newupload_count = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress').length;
        
        if(newupload_count == 'undefined' || isNaN(newupload_count) || newupload_count == ""){
            newupload_count = 1;
        } else {
            newupload_count = parseInt(newupload_count)+1;
        }

        if(newupload_count_id == 'undefined' || isNaN(newupload_count_id) || newupload_count_id == ""){
            newupload_count_id = 1;
        } else {
            newupload_count_id = parseInt(newupload_count_id)+1;
        }


        
        var total_files = newupload_count;

        var field_name_arr = jQuery('#' + file_id).attr('name').split('file');
        var field_name = field_name_arr[1];
        

        jQuery('.arf_field_'+field_name).addClass('arf_success');

        var field_type = jQuery('#file_types_' + field_key).val();

        var frmid = jQuery('#' + file_id).attr('data-form-id');

        var frmdataid = jQuery('#' + file_id).attr('data-form-data-id');

        var field_name_id = field_name;

        var field_size = jQuery('#file_size_' + field_key).val();
        if (typeof max_file_upload == 'undefined' || max_file_upload == '' || max_file_upload == 0) {
            var default_content = document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML;
            var $arf_div_to_append = '<div class = "arfprogress progress-striped" id = "progress_' + field_key + '_' + newupload_count_id + '" arfupldcnt="'+newupload_count_id+'" style = "display: block;" > <div style = "width:0%;" class = "bar" > </div></div > <div style = "display: inline-block;" class = "arf_info" id = "info_' + field_key + '_' + newupload_count_id + '" > <span class = "percent" > % Completed </span><span class="percent" id="percent">0</span > </div>';
            document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML = default_content + $arf_div_to_append;
            jQuery('#arf_multi_file_uploader_' + field_key).show();
        }

        if (max_file_upload != '' && max_file_upload != 0 ) {
            if (total_files <= max_file_upload) {
                var default_content = document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML;
                var $arf_div_to_append = '<div class = "arfprogress progress-striped" id = "progress_' + field_key + '_' + newupload_count_id + '" arfupldcnt="'+newupload_count_id+'" style = "display: block;" > <div style = "width:0%;" class = "bar" > </div></div > <div style = "display: inline-block;" class = "arf_info" id = "info_' + field_key + '_' + newupload_count_id + '" > <span class = "percent" > % Completed </span><span class="percent" id="percent">0</span > </div>';
                document.getElementById('arf_multi_file_uploader_' + field_key).innerHTML = default_content + $arf_div_to_append;
                jQuery('#arf_multi_file_uploader_' + field_key).show();
            }
        }

        if (!document.getElementById(file_id).multiple) {
            break;
        }
    }


    var arf_file_interval = setInterval(function () {
        if (!ajaxProcess) {

            var field_key_arr = jQuery('#' + file_id).attr('id').split('field_');

            var field_key = field_key_arr[1];


            var field_name_arr = jQuery('#' + file_id).attr('name').split('file');
            var field_name = field_name_arr[1];

            var field_type = jQuery('#file_types_' + field_key).val();

            var frmid = jQuery('#' + file_id).attr('data-form-id');

            var frmdataid = jQuery('#' + file_id).attr('data-form-data-id');

            var field_name_id = field_name;

            var field_size = jQuery('#file_size_' + field_key).val();
            var newupload_count_id = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress.counting:last').attr('arfupldcnt');
            var newupload_count = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress.counting').length;
            if(newupload_count == 'undefined' || isNaN(newupload_count) || newupload_count == ""){
                newupload_count = 1;
            } else {
                newupload_count = parseInt(newupload_count)+1;
            }

            if (max_file_upload != '' && max_file_upload != 0 && newupload_count > max_file_upload) {
                newupload_count = 0;
            }

            if( newupload_count_id == 'undefined' || isNaN(newupload_count_id) || newupload_count_id == "" ){
                newupload_count_id = 1;
            } else {
                newupload_count_id = parseInt( newupload_count_id ) + 1;
            }
            
            if (newupload_count > 0) {
                UploadFile(files_new[Object.keys(files_new)[0]], field_key, field_type, frmid, field_name_id, field_size, frmdataid, newupload_count_id, newupload_count);
            }

            var myObj = new Object;
            for (var i = 0; i < files_new.length; i++) {
                if (i !== 0) {
                    myObj[i - 1] = files_new[i];
                    myObj.length = i;
                }
            }

            files_new = myObj;
            if (jQuery.isEmptyObject(files_new)) {
                clearInterval(arf_file_interval);
            }
            if (!document.getElementById(file_id).multiple) {
                clearInterval(arf_file_interval);
            }
        } else {

        }
    }, 1000);
}

function UploadFile(file, field_id_val, field_type, frmid, field_name_id, field_size, frmdataid, arf_new_id, newupload_count) {

    ajaxProcess = true;
    if (location.host.indexOf("sitepointstatic") >= 0){
        return;
    }
    
    var xhr = new XMLHttpRequest();
    var file_index = file.name.lastIndexOf('.'); 
    var total_files = newupload_count;
    var max_file_upload_limit = jQuery('#field_'+field_id_val).attr('data-validation-maxupload-maxupload') || 0;
    var file_extension = file.name.substring(file_index + 1); 

    file_extension = file_extension.toLowerCase();
    var types_arr = field_type.split(",");
    var arf_file_size = true;
    if (field_size != "auto" && (field_size != " ") && (field_size != 0)) {
        arf_file_size = (file.size <= field_size) ? true : false;
    }

    var arf_file_validation = (field_type.indexOf(file_extension) >= 0) ? true : false;
    var seconds = new Date().getTime();
    var funique_id = frmid + "_" + field_name_id + "_" + seconds;

    if (arf_file_validation && arf_file_size && (file_extension != "php" && file_extension != "php3" && file_extension != "php4" && file_extension != "php5" && file_extension != "pl" && file_extension != "py" && file_extension != "jsp" && file_extension != "asp" && file_extension != "exe" && file_extension != "cgi")) {
        
        var index = file.name.lastIndexOf('.'); 

        var extension = file.name.substring(index + 1); 

        var filename = /.*(?=\.)/.exec(file.name);
        var fname1 = frmid + "_" + field_name_id + "_" + seconds + "_" + filename;
        var fname = fname1.replace(/[^\w\s]/gi, '').replace(/ /g, "") + '.' + extension;
        var field_id = field_id_val;
        var is_preview = jQuery('[data-id="is_form_preview_' + frmid + '"]').val();
        var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
        var arffiledragurl = jQuery("[data-id='arffiledragurl']").val();
        if (!jQuery.isFunction(is_ssl_replace)) {
            return;
        }
        arfmainformurl = is_ssl_replace(arfmainformurl);
        
        xhr.open("POST",__ARFAJAXURL,true);

        var form_random_key = field_id.split('_');
        var random_key = form_random_key[1];

        jQuery("#arf_submit_btn_" + random_key ).attr('disabled','disabled');

        var param_data = new FormData();    
        var token = jQuery("#arf_file_token_" + frmid ).val();
    
        param_data.append('action','arf_send_form_data');
        param_data.append('frm',frmid);
        param_data.append('field_id',field_id);
        param_data.append('file_type',file.type);
        param_data.append('types_arr',types_arr);
        param_data.append('is_preview',is_preview);
        param_data.append('files',file);
        param_data.append('token',token);

        jQuery('.arf_file_drag_reply_container[data-id="field_' + field_id + '"]').addClass('disable');

        jQuery('#progress_' + field_id_val + '_' + arf_new_id).addClass('arfprogress');

        jQuery('#progress_' + field_id_val + '_' + arf_new_id).addClass('active').addClass('counting').show();

        jQuery('#info_' + field_id_val + '_' + arf_new_id).css('display', 'inline-block');


        xhr.upload.addEventListener("progress", function (e) {

            var pc = parseFloat(0 + (e.loaded / e.total * 100));
            pc = Math.round(pc);
            jQuery('#progress_' + field_id_val + '_' + arf_new_id + ' div.bar').css('width', pc + "%");
            jQuery('#info_' + field_id_val + '_' + arf_new_id + ' #percent').html(pc);
        }, false);

        xhr.addEventListener("load", function (e) {
            setTimeout(function () {
                
                jQuery('#info_' + field_id_val + '_' + arf_new_id + ' #percent').html('100');
                jQuery('#progress_' + field_id_val + '_' + arf_new_id + ' div.bar').css('width', "100%");
            }, 300);
        }, false);

        xhr.setRequestHeader("X_FILENAME", fname);
        xhr.setRequestHeader("X-FILENAME", fname);

        xhr.send(param_data);
        
        xhr.onreadystatechange = function (e) {
            /* var post_data = []; */
            if (xhr.readyState == 4) {
                if (xhr.status == 200)
                {
                    var data = xhr.responseText;
                    /* regarding fileupload changes start */
                    var post_data = data.split('|');
                    var field_id_data = post_data[1];
                    if( typeof field_id_data != 'undefined' ){
                        var field_id = field_id_data.split('_');
                        var fieldid = field_id[1];
                        var post_data_id = post_data[3];
                        var arf_repeater_file_id = (post_data[2].split('_'));
                        var repeater_id = arf_repeater_file_id[2];
                        
                        var parent_field_id = jQuery('.arf_field_'+field_name_id).attr('data-parent_field');
                        
                        if( parent_field_id > 0 ){
                            if( repeater_id != '' ){    
                                var item_meta_chk_val = jQuery('#item_meta_'+parent_field_id+'_'+fieldid+'_'+repeater_id).val();
                                if(item_meta_chk_val!=''){
                                    jQuery('#item_meta_'+parent_field_id+'_'+fieldid+'_'+repeater_id).val(item_meta_chk_val+'|'+post_data_id);
                                }
                                else{
                                    jQuery('#item_meta_'+parent_field_id+'_'+fieldid+'_'+repeater_id).val(post_data_id);
                                }
                            }
                        } else {
                            
                            var item_meta_chk_val = jQuery('#item_meta_'+fieldid).val();
                            if(item_meta_chk_val!=''){
                                jQuery('#item_meta_'+fieldid).val(item_meta_chk_val+'|'+post_data_id);
                            }
                            else{
                                jQuery('#item_meta_'+fieldid).val(post_data_id);
                            }
                        }   
                    }

                    /* regarding fileupload changes end */
                    
                    jQuery('input[name="file' + field_id + '"]').attr('data-is-insecure-file',"false");

                    if( data.match(/(error_upload_security)/g) ){

                        jQuery('#progress_' + field_id_val).hide();

                        jQuery('#progress_' + field_id_val + '_' + arf_new_id).addClass('counting');

                        jQuery('#info_' + field_id_val).hide();

                        var file_error = data;

                        var arf_invalid_file_message = file_error;

                        var field_id_arr = jQuery('#field_' + field_id_val).attr('name').split('file');
                        var field_id = field_id_arr[1];
                        var display_original_error = true;

                        jQuery('input[name="file' + field_id + '"]').attr('data-is-insecure-file',"true");

                        if( !jQuery('input[name="file' + field_id + '"]').hasClass('arf_reply_drag_file') ){
                            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 
                        } else {
                            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 
                            jQuery('input[name="file' + field_id + '"]').trigger('change');
                        }

                        jQuery('#arf_field_' + field_id + '_' + frmdataid + '_container').removeClass('arf_success');
                        var $this = jQuery('#arf_field_' + field_id + '_' + frmdataid + '_container .controls');
                        var $controlGroup = $this.parents(".control-group").first();
                        var $helpBlock = $controlGroup.find(".help-block").first();
                        var form_id = $this.closest('form').find('[data-id="form_id"]').val();
                        var error_type = (jQuery('[data-id="form_tooltip_error_' + form_id + '"]').val() == 'advance') ? 'advance' : 'normal';

                        var seconds = new Date().getTime();
                        var image_directory_url = document.getElementById('arf_image_directory_url_'+frmid+'_'+frmdataid).value;

                        var upload_content = '<div id="arf_' + funique_id + '_' + seconds + '" class="arf_file_info_item"><span id="remove_' + field_id_val + '" class="ajax-file-remove test1"  data-info-id="info_' + field_id_val + '_' + arf_new_id + '" data-progress-id="progress_' + field_id_val + '_' + arf_new_id + '" style="position: relative; overflow: hidden;" data-current-file-size="'+file.size+'" data-current-file-size-counter="'+arf_new_id+'" data-form-data-id="' + frmdataid + '" data-form-id="' + frmid + '" data-id="' + field_name_id + '" file-data-id="' + funique_id + '_' + seconds + '" ><svg height="19px" width="19px"><g><path xmlns="http://www.w3.org/2000/svg" fill-rule="evenodd" clip-rule="evenodd" fill="#ff0000" d="M16.939,5.845h-1.415V17.3c0,0.292-0.236,0.529-0.529,0.529H4.055  c-0.292,0-0.529-0.237-0.529-0.529V5.845H2.018c-0.292,0-0.529-0.739-0.529-1.031s0.237-0.982,0.529-0.982h2.509V1.379  c0-0.293,0.237-0.529,0.529-0.529h8.954c0.293,0,0.529,0.236,0.529,0.529v2.452h2.399c0.292,0,0.529,0.69,0.529,0.982  S17.231,5.845,16.939,5.845z M12.533,2.811H6.517v1.011h6.016V2.811z M13.541,5.845l-0.277-0.031L5.788,5.845H5.534v10.001h8.007  V5.845z M8.525,13.849H7.534v-6.08h0.991V13.849z M11.525,13.849h-0.991v-6.08h0.991V13.849z" /></g></svg></span><span id="file_name" class="file_name arf_info">' + file.name + '</span></div></span></div>';



                        jQuery('#info_' + field_id_val + '_' + arf_new_id).after(upload_content);
                        
                        if( display_original_error ){
                            
                            if (error_type == 'advance'){
                                if (!jQuery.isFunction(arf_show_tooltip)) {
                                    return;
                                }

                                var form_id = $controlGroup.closest('form').find('[data-id="form_id"]').val();

                                var color = jQuery('[data-id="form_tooltip_error_' + form_id + '"]').attr('data-color');

                                var position = jQuery('[data-id="form_tooltip_error_' + form_id + '"]').attr('data-position');

                                var border_color = "#f4f4f4";
                                var bounceeffect = "bounceInRight";
                                if (position == 'left')
                                {
                                    bounceeffect = "bounceInLeft";
                                }
                                else if (position == 'right')
                                {
                                    bounceeffect = "bounceInRight";
                                }
                                else if (position == 'top')
                                {
                                    bounceeffect = "bounceInDown";
                                }
                                else if (position == 'bottom')
                                {
                                    bounceeffect = "bounceInUp";
                                }
                                jQuery('#arf_' + funique_id + '_' + seconds).addClass('arf_advance_error').arf_popover({
                                    html: true,
                                    trigger: 'manual',
                                    placement: position,
                                    content: arf_invalid_file_message,
                                    animation: false
                                });
                                jQuery('#arf_' + funique_id + '_' + seconds).arf_popover('show');
                                jQuery('#arf_' + funique_id + '_' + seconds).addClass("arfanimated " + bounceeffect);
                            } else {
                                if (!$helpBlock.length) {
                                    $helpBlock = jQuery('<div class="help-block arfanimated bounceInDownNor"><ul role="alert"><li>' + arf_invalid_file_message + '</li></ul></div>');

                                    jQuery('#arf_' + funique_id + '_' + seconds ).parent().parent().parent().find('.help-block').append($helpBlock).addClass('arf_error');
                                    jQuery('#arf_' + funique_id + '_' + seconds ).addClass('arf_error');
                                    jQuery('#arf_' + funique_id + '_' + seconds + ' .help-block').removeClass('arfanimated bounceInDownNor').addClass('arfanimated bounceInDownNor');
                                } else {
                                    $helpBlock = jQuery('<ul role="alert"><li>' + arf_invalid_file_message + '</li></ul>');
                                    jQuery('#arf_' + funique_id + '_' + seconds ).parent().parent().parent().find('.help-block').empty();
                                    jQuery('#arf_' + funique_id + '_' + seconds ).parent().parent().parent().find('.help-block').append($helpBlock);
                                    jQuery('#arf_' + funique_id + '_' + seconds ).addClass('arf_error');
                                    
                                    jQuery('#arf_' + funique_id + '_' + seconds + ' .help-block').removeClass('arfanimated bounceInDownNor').addClass('arfanimated bounceInDownNor');
                                }
                            }
                        }

                        if( !display_original_error ){

                            var images = document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_id).value;
                            var upload_file_key = document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value;
                            if (images != '') {
                                document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_id).value = images + ',' + frmid + '_' + field_id + '_' + seconds + '_' + file.name;
                            } else {
                                document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_id).value =  frmid + '_' + field_id + '_' + seconds + '_' + file.name;
                            }
                            if (upload_file_key != '') {
                                document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value = upload_file_key + ',' + field_id_val + '_' + seconds;
                            } else {
                                document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value = field_id_val + '_' + seconds;
                            }
                        }
                        setTimeout( function(){
                            jQuery('#info_' + field_id_val + '_' + arf_new_id + ' #percent').html('0');
                            jQuery('#progress_' + field_id_val + '_' + arf_new_id + ' div.bar').css('width', "0%");
                        },500);
                    } else {
                        var seconds = new Date().getTime();
                        var response = data.split("|");
                        document.getElementById('field_'+field_id_val).value = "";
                        if( typeof jQuery('input[name="file' + field_name_id + '"]').attr('multiple') != 'undefined' ){
                            var arf_last_file_status = jQuery('input[name="file' + field_name_id + '"]').attr('data-file-valid');
                            if( arf_last_file_status != 'false'){
                                jQuery('input[name="file' + field_name_id + '"]').attr('data-file-valid', 'true');
                            }
                        } else {
                            jQuery('input[name="file' + field_name_id + '"]').attr('data-file-valid', 'true');
                        }

                        
                        var img_name = response[1];

                        if (img_name != undefined && !is_preview ) {
                            var extension = img_name.split('.');
                            extension = extension[1].toLowerCase();

                            var val_name = '__ARF_FILE_PATH_' + frmid;
                            var path = eval( val_name );
                            
                            if ( extension == 'jpg' || extension == 'jpeg' || extension == 'png' ) {
                            
                                var crop_data_id = field_name_id + '_' + frmdataid;
                                var data = path + img_name;

                                if(jQuery('.arf_crop_div[data_id="'+crop_data_id+'"]').length != 0){
                                    jQuery('.arf_crop_div[data_id="'+crop_data_id+'"]').find('img').attr('src', '');
                                    jQuery('.arf_crop_div[data_id="'+crop_data_id+'"]').find('img').attr('src', data);
                                    var cover_image = jQuery('.arf_crop_img[data_id="'+crop_data_id+'"]');
                                    var arf_first_time_open = 0;
                                    cropper_cover = new Cropper(cover_image, {
                                        viewMode: 4,
                                        aspectRatio: 1,
                                        dragCrop: true,
                                        zoomable: true,
                                        rotatable: true,
                                        dashed: false,
                                        cropBoxResizable: false,
                                        dragMode: 'move',
                                        zoomOnTouch: false,
                                        crop: function (e) {
                                            jQuery('.arf_crop_img[data_id="'+crop_data_id+'"]').attr('data-coord', Math.round(e.detail.x) + ',' + Math.round(e.detail.y) + ',' + Math.round(e.detail.width) + ',' + Math.round(e.detail.height));
                                            if( arf_first_time_open == 0 ){
                                                jQuery('.arf_reset_button.arf_img_setting[data_id="'+crop_data_id+'"]').trigger('click');
                                                jQuery('.arf_crop_img[data_id="'+crop_data_id+'"]').attr('data-coord','0,0,0,0');
                                                arf_first_time_open = 1;
                                            }
                                        },
                                        background: false,
                                    });
                                    jQuery('.arf_img_setting[data_id="' +crop_data_id+ '"]').off('click');
                                    jQuery('.arf_img_setting[data_id="' +crop_data_id+ '"]').on('click',function(event){
                                        var e = event || window.event;
                                        var target = e.target || e.srcElement;
                                        var cropped;
                                        var result;
                                        var input;
                                        var data;
                                        var options = {
                                            viewMode: 4,
                                            aspectRatio: 1,
                                            dragCrop: true,
                                            zoomable: true,
                                            rotatable: true,
                                            dashed: false,
                                            cropBoxResizable: false,
                                            dragMode: 'move',
                                            zoomOnTouch: false
                                        }
                                        if (!cropper_cover) {
                                            return;
                                        }

                                        while (target !== this) {
                                            if (target.getAttribute("data-method")) {
                                                break;
                                            }
                                            target = target.parentNode;
                                        }
                                        data = { method: target.getAttribute("data-method"), target: target.getAttribute("data-target"), option: target.getAttribute("data-option") || undefined, secondOption: target.getAttribute("data-second-option") || undefined };
                                        cropped = cropper_cover.cropped;

                                        if (data.method) {
                                            if (typeof data.target !== "undefined") {
                                                input = document.querySelector(data.target);
                                                if (!target.hasAttribute("data-option") && data.target && input) {
                                                    try {
                                                        data.option = JSON.parse(input.value);
                                                    } catch (e) {
                                                        console.log(e.message);
                                                    }
                                                }
                                            }

                                            switch (data.method) {
                                                case "reset":
                                                case "rotate":
                                                    if (cropped && options.viewMode > 0) {
                                                        cropper_cover.clear();
                                                    }
                                                    break;
                                                case "getCroppedCanvas":
                                                    try {
                                                        data.option = JSON.parse(data.option);
                                                    } catch (e) {
                                                        console.log(e.message);
                                                    }
                                                    if (uploadedImageType === "image/jpeg") {
                                                        if (!data.option) {
                                                            data.option = {};
                                                        }
                                                        data.option.fillColor = "#fff";
                                                    }
                                                    break;
                                            }

                                            
                                            result = cropper_cover[data.method](data.option);

                                            switch (data.method) {
                                                case "rotate":
                                                    if (cropped && options.viewMode > 0) {
                                                        cropper_cover.crop();
                                                    }
                                                    break;
                                                case "scaleX":
                                                case "scaleY":
                                                    target.setAttribute("data-option", -data.option);
                                                    break;
                                                case "getCroppedCanvas":
                                                    if (result) {
                                                        jQuery("#getCroppedCanvasModal").modal().find(".modal-body").html(result);
                                                        if (!download.disabled) {
                                                            download.download = uploadedImageName;
                                                            download.href = result.toDataURL(uploadedImageType);
                                                        }
                                                    }
                                                    break;
                                                case "destroy":
                                                    cropper_cover = null;
                                                    if (uploadedImageURL) {
                                                        URL.revokeObjectURL(uploadedImageURL);
                                                        uploadedImageURL = "";
                                                        image.src = originalImageURL;
                                                    }
                                                    break;
                                            }
                                            if (typeof result === "object" && result !== cropper_cover && input) {
                                                try {
                                                    input.value = JSON.stringify(result);
                                                } catch (e) {
                                                    console.log(e.message);
                                                }
                                            }
                                        }
                                    });

                                    jQuery('.arf_crop_div_wrapper[data_id="'+crop_data_id+'"]').bPopup({
                                        opacity: 0.5,
                                        closeClass: 'arf_popup_close_btn',
                                        follow: [false, false],
                                        escClose: false,
                                        modalClose: false,
                                        zIndex : 9999999,
                                        onClose: function(){
                                          cropper_cover.destroy();
                                        },
                                    });

                                }
                            } 
                        }

                        
                        
                        var images = document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_name_id).value;
                        var upload_file_key = document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value;
                        jQuery('#arf_multi_file_info_' + field_id_val).css('display', 'inline-block');
                        var image_directory_url = document.getElementById('arf_image_directory_url_'+frmid+'_'+frmdataid).value;
                        var default_content = document.getElementById('arf_multi_file_info_' + field_id_val).innerHTML;

                        var upload_content = '<div id="arf_' + funique_id + '" class="arf_file_info_item"><span id="remove_' + field_id_val + '_'+seconds+'" class="ajax-file-remove" data-post-id="'+post_data_id+'" data-current-file-size="'+file.size+'" data-current-file-size-counter="'+arf_new_id+'" data-info-id="info_' + field_id_val + '_' + arf_new_id + '" data-progress-id="progress_' + field_id_val + '_' + arf_new_id + '" style="position: relative; overflow: hidden;" data-form-data-id="' + frmdataid + '" data-form-id="' + frmid + '" data-id="' + field_name_id + '" file-data-id="' + funique_id + '" ><svg height="19px" width="19px"><g><path xmlns="http://www.w3.org/2000/svg" fill-rule="evenodd" clip-rule="evenodd" fill="#ff0000" d="M16.939,5.845h-1.415V17.3c0,0.292-0.236,0.529-0.529,0.529H4.055  c-0.292,0-0.529-0.237-0.529-0.529V5.845H2.018c-0.292,0-0.529-0.739-0.529-1.031s0.237-0.982,0.529-0.982h2.509V1.379  c0-0.293,0.237-0.529,0.529-0.529h8.954c0.293,0,0.529,0.236,0.529,0.529v2.452h2.399c0.292,0,0.529,0.69,0.529,0.982  S17.231,5.845,16.939,5.845z M12.533,2.811H6.517v1.011h6.016V2.811z M13.541,5.845l-0.277-0.031L5.788,5.845H5.534v10.001h8.007  V5.845z M8.525,13.849H7.534v-6.08h0.991V13.849z M11.525,13.849h-0.991v-6.08h0.991V13.849z" /></g></svg></span><span id="file_name" class="file_name arf_info">' + file.name + '</span></div>';

                        if (jQuery('#progress_' + field_id_val + '_' + arf_new_id + ' .bar').attr('style') !== 'width: 100%;') {
                            setTimeout(function () {
                                
                                jQuery('#info_' + field_id_val + '_' + arf_new_id).after(upload_content);
                                jQuery('#progress_' + field_id_val + '_' + arf_new_id).hide();
                                jQuery('#info_' + field_id_val + '_' + arf_new_id).hide();
                            }, 300);
                        } else {
                            setTimeout(function () {
                                jQuery('#info_' + field_id_val + '_' + arf_new_id).after(upload_content);
                                jQuery('#progress_' + field_id_val + '_' + arf_new_id).hide();
                                jQuery('#info_' + field_id_val + '_' + arf_new_id).hide();
                            },700);
                        }
                        
                        if (images != ''){
                            document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_name_id).value = images + ',' + response[1];
                        } else {
                            document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_name_id ).value = (typeof response[1] != 'undefined' ) ? response[1] : '';
                        }
                        if (upload_file_key != '') {
                            document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value = upload_file_key + ',' + response[2] + '_' + seconds;
                        }else{
                            document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value = (typeof response[2] != 'undefined' ) ? response[2] + '_' + seconds : '';
                        }

                        var fkey = response[2];
                        jQuery('.arf_file_drag_reply_container[data-id="field_' + fkey + '"]').removeClass('disable');
                        setTimeout(function(){
                            if( jQuery("#arf_multi_file_uploader_" + field_id_val ).find('.arfprogress:visible').length < 1 ){
                                jQuery("#arf_submit_btn_" + random_key ).removeAttr('disabled');
                            }
                        },1000);
                    }
                    
                }
            }
        };
    } else {
        
        jQuery('#progress_' + field_id_val).hide();

        jQuery('#progress_' + field_id_val + '_' + arf_new_id).addClass('counting');

        jQuery('#info_' + field_id_val).hide();
        if (typeof (__ARFERR) !== undefined)
            var file_error = __ARFERR;
        else
            var file_error = 'Sorry, this file type is not permitted for security reasons.';



        if (!arf_file_validation) {
            if (jQuery('#field_' + field_id_val).attr('data-invalid-message') !== undefined && jQuery('#field_' + field_id_val).attr('data-invalid-message') != '')
                var arf_invalid_file_message = jQuery('#field_' + field_id_val).attr('data-invalid-message');
            else
                var arf_invalid_file_message = file_error;
        }
        else if(!arf_file_size) {
            if (jQuery('#field_' + field_id_val).attr('data-size-invalid-message') !== undefined && jQuery('#field_' + field_id_val).attr('data-size-invalid-message') != '')
                var arf_invalid_file_message = jQuery('#field_' + field_id_val).attr('data-size-invalid-message');
            else
                var arf_invalid_file_message = file_error;
        }

        var field_id_arr = jQuery('#field_' + field_id_val).attr('name').split('file');
        var field_id = field_id_arr[1];
        var display_original_error = true;
        if( !jQuery('input[name="file' + field_id + '"]').hasClass('arf_reply_drag_file') ){
            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 
        } else {
            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 
            jQuery('input[name="file' + field_id + '"]').trigger('change');
        }

        jQuery('#arf_field_' + field_id + '_' + frmdataid + '_container').removeClass('arf_success');
        var $this = jQuery('#arf_field_' + field_id + '_' + frmdataid + '_container .controls');
        var $controlGroup = $this.parents(".control-group").first();
        var $helpBlock = $controlGroup.find(".help-block").first();
        var form_id = $this.closest('form').find('[data-id="form_id"]').val();
        var error_type = (jQuery('[data-id="form_tooltip_error_' + form_id + '"]').val() == 'advance') ? 'advance' : 'normal';

        var seconds = new Date().getTime();
        var image_directory_url = document.getElementById('arf_image_directory_url_'+frmid+'_'+frmdataid).value;
        var upload_content = '<div id="arf_' + funique_id + '_' + seconds + '" class="arf_file_info_item"><span id="remove_' + field_id_val + '" class="ajax-file-remove test3" data-info-id="info_' + field_id_val + '_' + arf_new_id + '" data-progress-id="progress_' + field_id_val + '_' + arf_new_id + '" style="position: relative; overflow: hidden;" data-current-file-size="'+file.size+'" data-current-file-size-counter="'+arf_new_id+'" data-form-data-id="' + frmdataid + '" data-form-id="' + frmid + '" data-id="' + field_name_id + '" file-data-id="' + funique_id + '_' + seconds + '" ><svg height="19px" width="19px"><g><path xmlns="http://www.w3.org/2000/svg" fill-rule="evenodd" clip-rule="evenodd" fill="#ff0000" d="M16.939,5.845h-1.415V17.3c0,0.292-0.236,0.529-0.529,0.529H4.055  c-0.292,0-0.529-0.237-0.529-0.529V5.845H2.018c-0.292,0-0.529-0.739-0.529-1.031s0.237-0.982,0.529-0.982h2.509V1.379  c0-0.293,0.237-0.529,0.529-0.529h8.954c0.293,0,0.529,0.236,0.529,0.529v2.452h2.399c0.292,0,0.529,0.69,0.529,0.982  S17.231,5.845,16.939,5.845z M12.533,2.811H6.517v1.011h6.016V2.811z M13.541,5.845l-0.277-0.031L5.788,5.845H5.534v10.001h8.007  V5.845z M8.525,13.849H7.534v-6.08h0.991V13.849z M11.525,13.849h-0.991v-6.08h0.991V13.849z" /></g></svg></span><span id="file_name" class="file_name arf_info">' + file.name + '</span></div></span></div>';
        jQuery('#info_' + field_id_val + '_' + arf_new_id).after(upload_content);
        
        if( display_original_error ){
            if (error_type == 'advance'){
                if (!jQuery.isFunction(arf_show_tooltip)) {
                    return;
                }

                var form_id = $controlGroup.closest('form').find('[data-id="form_id"]').val();

                var color = jQuery('[data-id="form_tooltip_error_' + form_id + '"]').attr('data-color');

                var position = jQuery('[data-id="form_tooltip_error_' + form_id + '"]').attr('data-position');

                var border_color = "#f4f4f4";
                var bounceeffect = "bounceInRight";
                if (position == 'left')
                {
                    bounceeffect = "bounceInLeft";
                }
                else if (position == 'right')
                {
                    bounceeffect = "bounceInRight";
                }
                else if (position == 'top')
                {
                    bounceeffect = "bounceInDown";
                }
                else if (position == 'bottom')
                {
                    bounceeffect = "bounceInUp";
                }
                (function(funique_id,seconds, position, arf_invalid_file_message, bounceeffect){
                    setTimeout(function(){
                        jQuery('#arf_' + funique_id + '_' + seconds).addClass('arf_advance_error').arf_popover({
                            html: true,
                            trigger: 'manual',
                            placement: position,
                            content: arf_invalid_file_message,
                            animation: false
                        });
                        jQuery('#arf_' + funique_id + '_' + seconds).arf_popover('show');
                        jQuery('#arf_' + funique_id + '_' + seconds).parents('.arf_file_field').find('.popover').addClass("arfanimated " + bounceeffect);
                    },100)
                })(funique_id, seconds, position, arf_invalid_file_message, bounceeffect)
            } else {
                if (!$helpBlock.length) {
                    $helpBlock = jQuery('<div class="help-block arfanimated bounceInDownNor"><ul role="alert"><li>' + arf_invalid_file_message + '</li></ul></div>');

                    jQuery('#arf_' + funique_id + '_' + seconds ).parent().parent().parent().find('.help-block').append($helpBlock).addClass('arf_error');
                    jQuery('#arf_' + funique_id + '_' + seconds ).addClass('arf_error');
                    jQuery('#arf_' + funique_id + '_' + seconds + ' .help-block').removeClass('arfanimated bounceInDownNor').addClass('arfanimated bounceInDownNor');
                } else {
                    $helpBlock = jQuery('<ul role="alert"><li>' + arf_invalid_file_message + '</li></ul>');
                    jQuery('#arf_' + funique_id + '_' + seconds ).parent().parent().parent().find('.help-block').empty();
                    (function(funique_id, seconds,$helpBlock){
                        setTimeout(function(){
                            jQuery('#arf_' + funique_id + '_' + seconds ).parent().parent().parent().find('.help-block').append($helpBlock);
                            jQuery('#arf_' + funique_id + '_' + seconds ).addClass('arf_error');
                            jQuery('#arf_' + funique_id + '_' + seconds + ' .help-block').removeClass('arfanimated bounceInDownNor').addClass('arfanimated bounceInDownNor');
                        },100)
                    })(funique_id, seconds, $helpBlock);
                }
            }
            ajaxProcess = false;
        }
        if( !display_original_error ){
            var images = document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_id).value;
            var upload_file_key = document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value;

            
            if (images != '') {
                document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_id).value = images + ',' + frmid + '_' + field_id + '_' + seconds + '_' + file.name;
            } else {
                document.getElementById('uploaded_file_name_' + frmid + '_' + frmdataid + '_' + field_id).value =  frmid + '_' + field_id + '_' + seconds + '_' + file.name;
            }
            if (upload_file_key != '') {
                document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value = upload_file_key + ',' + field_id_val + '_' + seconds;
            }else{
                document.getElementById('upload_field_id_' + frmid + '_' + frmdataid).value = field_id_val + '_' + seconds;
            }
        }

    }
    
    if(jQuery('#field_'+field_id_val).attr('multiple')===undefined){
       jQuery('#field_'+field_id_val).parents('.arf_file_field').hide();
    }
    if (max_file_upload_limit != '' && max_file_upload_limit != 0 && total_files >= max_file_upload_limit){
        jQuery('#field_'+field_id_val).parents('.arf_file_field').hide();
    }
    ajaxProcess = false;

}


function Init() {
    var array = [];
    jQuery('.arf_form').each(function () {
        var obj = jQuery(this);
        obj.find('.arf_file_drag_reply_container').each(function () {
            array.push(jQuery(this).attr('data-id'));
        });
    });
    
    jQuery(array).each(function (i) {
        var filedrag = jQuery('.arf_file_drag_reply_container[data-id="' + array[i] + '"]')[0];
        
        if (filedrag == null) {
            return;
        }

        var xhr = new XMLHttpRequest();
        if (xhr.upload) {
            
            filedrag.addEventListener("dragover", FileDragHover, false);
            filedrag.addEventListener("dragleave", FileDragHover, false);
            filedrag.addEventListener("drop", FileSelectHandlerDrag, false);
            filedrag.style.display = "block";
        }
    });
    
    return false;
}

jQuery(document).on('click', '.arf_form .original', function () {
    
    var fileselect = $id(jQuery(this).attr('id'));

    var field_key = jQuery(this).attr('id').replace('field_', '');

    var submit_type = jQuery('#type_' + field_key).val();

    if (submit_type == '0') {
        fileselect.addEventListener("change", FileSelectHandler, false);
        var field_key_arr1 = jQuery(this).attr('id').split('field_');
    }

    var xhr = new XMLHttpRequest();
    if (xhr.upload) {
    }
});

jQuery(document).on('click', '.arf_reply_drag_file', function () {

    var fileselect = $id(jQuery(this).attr('id'));
    
    var field_key = jQuery(this).attr('id').replace('field_', '');

    if (jQuery('.arf_file_drag_reply_container[data-id="field_' + field_key + '"]').hasClass('disable')) {
        return false;
    }
    var submit_type = jQuery('#type_' + field_key).val();
    
    if (submit_type == '0') {
        fileselect.addEventListener("change", FileSelectHandler, false);
        var field_key_arr1 = jQuery(this).attr('id').split('field_');
    }
    var xhr = new XMLHttpRequest();
    if (xhr.upload) {
    }
});
jQuery(document).on('click', ".ajax-file-remove:not(.disable)", function (i) {

    var remove_file_id = jQuery(this).attr('file-data-id');
    
    var field_key = jQuery(this).attr('id').replace('remove_', '');

    if( window.arf_is_submitting_form ){
        return false;
    }
    
    var inside_repeater = jQuery(this).parents('.arf_child_field').length > 0 || false;
    
    if (typeof remove_file_id.split('_')[0] == 'undefined') {

        var data_id = jQuery(this).attr("data-id");
        jQuery('#arf_' + remove_file_id).arf_popover('destroy');
        var arf_progress_id = jQuery(this).attr('data-progress-id');
        var arf_info_id = jQuery(this).attr('data-info-id');
        jQuery('#' + arf_progress_id).remove();
        jQuery('#' + arf_info_id).remove();
        jQuery('#arf_' + remove_file_id).remove();
        jQuery('.arf_field_'+data_id).find('.arf_file_field').show();
        jQuery('.arf_reply_drag_file_label').show();
        jQuery('.arf_file_drag_reply_container[data-id="field_' + field_key + '"]').removeClass('disable');
        return false;
    }

    jQuery(this).addClass('disable');

    var field_id = jQuery(this).attr('data-id');
    var remove_file_key = remove_file_id.split("_");

    var remove_field_key = field_key;
    var form_id = jQuery(this).attr('data-form-id');
    var form_data_id = jQuery(this).attr('data-form-data-id');
    var string = jQuery('#uploaded_file_name_' + form_id + '_' + form_data_id + '_' + field_id).val();
    var is_preview = jQuery('[data-id="is_form_preview_' + form_id + '"]').val();

    var arf_progress_id = jQuery(this).attr('data-progress-id');
    var arf_info_id = jQuery(this).attr('data-info-id');

    var current_file_size = jQuery(this).attr('data-current-file-size');

    var file_upload_counter = jQuery(this).attr('data-current-file-size-counter');

    var multiple_file_info_container = jQuery(this).parents('.arf_multi_file_info_container');

    var hasError = jQuery(this).parent('.arf_file_info_item').hasClass('arf_error');

    var hasError_advance = jQuery(this).parent('.arf_file_info_item').hasClass('arf_advance_error');
    if(hasError_advance==true)
    {
        hasError = hasError_advance;
    }

    file_name = '';
    
    if(remove_file_id.indexOf('.') < 0)
    {
        if (string.indexOf(',') >= 0) {
            var array_val = string.split(",");
            var file_name = '';
            if( hasError ){                
                if( array_val.indexOf( remove_file_id ) > -1 ){
                    file_name = remove_file_id;
                }
            } else {
                for (key in array_val) {
                    if (array_val[key].indexOf(remove_file_id) >= 0){
                        file_name = array_val[key];
                    }
                }
            }

        } else {
            file_name = string;
        }
    }

    if( jQuery(this).parents('.controls').find('#arf_reply_drag_and_drop').length > 0 || jQuery(this).parents('.controls').length>0){
        var helpBlock = jQuery(this).parents('.controls').find('.help-block');
        helpBlock.attr('class','help-block');
        helpBlock.html('');

        var data_id = jQuery(this).attr("data-id");
        jQuery('#arf_' + remove_file_id).arf_popover('destroy');
        var field_key = jQuery(this).attr('id').replace('remove_', '');
        var arf_progress_id = jQuery(this).attr('data-progress-id');
        var arf_info_id = jQuery(this).attr('data-info-id');
        if( inside_repeater ){
            var parent_field = jQuery(this).parents('.arf_child_field');
        }
        jQuery('#' + arf_progress_id).remove();
        jQuery('#' + arf_info_id).remove();
        jQuery('#arf_' + remove_file_id).remove();
        if( inside_repeater ){
            parent_field.find('.arf_file_field').show();
        } else {
            jQuery('.arf_field_'+data_id).find('.arf_file_field').show();
        }
        jQuery('.arf_reply_drag_file_label').show();
        jQuery('.arf_file_drag_reply_container[data-id="field_' + field_key + '"]').removeClass('disable');
        jQuery('.ajax-file-remove').removeClass('disable');
    }

    var remove_button_counter = 1;
    
    multiple_file_info_container.find('.ajax-file-remove').each(function(){
        jQuery(this).attr('data-current-file-size-counter',remove_button_counter);
        remove_button_counter++;
    });

    if(!hasError){
        if (file_name == '' && is_preview == 0){
            return;
        }
        if (typeof (__ARFAJAXURL) === undefined){
            return;
        }
        if (!jQuery.isFunction(is_ssl_replace)) {
            return;
        }
    }

    var container = jQuery(this).parents('.file_main_control');

    if( hasError ){

        var string2 = document.getElementById('uploaded_file_name_' + form_id + '_' + form_data_id + '_' + field_id).value;
        var field_ids = document.getElementById('upload_field_id_' + form_id + '_' + form_data_id).value;
        if(file_name!='')
        {
            if (string2.indexOf(file_name + ',') >= 0){
                var string2_new = string2.replace(file_name + ',', '');
            } else if (string2.indexOf(',' + file_name) >= 0){
                var string2_new = string2.replace(',' + file_name, '');
            } else if (string2.indexOf( file_name) >= 0){
                var string2_new = string2.replace( file_name, '');
            }
            if (field_ids.indexOf(remove_field_key + ',') >= 0){
                var field_ids_new = field_ids.replace(remove_field_key + ',', '');
            } else if (field_ids.indexOf(remove_field_key) >= 0){
                var field_ids_new = field_ids.replace(remove_field_key, '');
            }

            jQuery('#uploaded_file_name_' + form_id + '_' + form_data_id + '_' + field_id).val(string2_new);
            jQuery('#upload_field_id_' + form_id + '_' + form_data_id).val(field_ids_new);
        }

        var nextDiv = jQuery('#arf_' + remove_file_id).parent().next();

        jQuery('#arf_' + remove_file_id).remove();
        nextDiv.css('display','none');

        jQuery('.ajax-file-remove').removeClass('disable');

        jQuery('#' + arf_progress_id).remove();
        jQuery('#' + arf_info_id).remove();
        jQuery(this).parent('.arf_file_info_item').remove();

        var has_invalid_files = false;
        multiple_file_info_container.find('.ajax-file-remove').each(function(){

            if( jQuery(this).parent('.arf_file_info_item').hasClass('arf_error') || jQuery(this).parent('.arf_file_info_item').hasClass('arf_advance_error')){
                has_invalid_files = true;
            }
        });

        if( !has_invalid_files ){
            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'true');
        }
        jQuery('input[name="file' + field_id + '"]').val('');

    } else {
        var arf_wpnonce = jQuery('#arforms_nonce').val();
        var arf_file_token = jQuery('#arf_file_token_' + form_id).val();
        /* regarding file upload change start */
            var arf_postdataid = jQuery(this).attr('data-post-id');
        /* regarding file upload change end */

        jQuery.ajax({
            type: "POST", url: is_ssl_replace(__ARFAJAXURL),
            data: "action=arf_delete_file&file_name=" + file_name + "&form_id=" + form_id + "&arf_wpnonce=" + arf_wpnonce+"&token=" + arf_file_token + "&fileupload_postid=" + arf_postdataid,
            success: function (msg) {

                var string2 = jQuery('#uploaded_file_name_' + form_id + '_' + form_data_id + '_' + field_id ).val();
                var field_ids = jQuery('#upload_field_id_' + form_id + '_' + form_data_id).val();

                var fileuploadpost_id = jQuery('#item_meta_'+field_id).val();

                if( typeof fileuploadpost_id != 'undefined' && fileuploadpost_id!=''){
                    var fileuploadpost_id_arr = fileuploadpost_id.split('|');
                    var arf_item_meta_val = "";
                    for(i=0; i< fileuploadpost_id_arr.length; i++){
                        if(arf_postdataid!=fileuploadpost_id_arr[i])
                        {
                            if(arf_item_meta_val!='')
                            {
                                arf_item_meta_val += '|'+fileuploadpost_id_arr[i];
                            }
                            else {
                                arf_item_meta_val = fileuploadpost_id_arr[i];
                            }
                        }
                    }
                    jQuery('#item_meta_'+field_id).val(arf_item_meta_val);
                }


                if (field_ids.indexOf(remove_field_key + ',') >= 0)
                    var field_ids_new = field_ids.replace(remove_field_key + ',', '');
                else if (field_ids.indexOf(remove_field_key) >= 0)
                    var field_ids_new = field_ids.replace(remove_field_key, '');
                
                if (string2.indexOf(file_name + ',') >= 0)
                    var string2_new = string2.replace(file_name + ',', '');
                else if (string2.indexOf(',' + file_name) >= 0)
                    var string2_new = string2.replace(',' + file_name, '');
                else if (string2.indexOf(file_name) >= 0)
                    var string2_new = string2.replace(file_name, '');
                
                jQuery('#uploaded_file_name_' + form_id + '_' + form_data_id + '_' + field_id).val(string2_new);
                jQuery('#upload_field_id_' + form_id + '_' + form_data_id).val(field_ids_new);

                var nextDiv = jQuery('#arf_' + remove_file_id).parent().next();
                jQuery('#arf_' + remove_file_id).remove();
                nextDiv.css('display','none');

                jQuery('.ajax-file-remove').removeClass('disable');

                jQuery('#' + arf_progress_id).remove();
                jQuery('#' + arf_info_id).remove();
            }
        });
    
    }

    container.find('.arf_file_field').show();
    container.find('.arf_reply_drag_file_label').show(); 
    jQuery('.arf_file_drag_reply_container[data-id="field_' + field_key + '"]').removeClass('disable');
    if( jQuery("#arf_multi_file_uploader_" + field_key ).find('.arfprogress:visible').length < 1 ){
        jQuery("#arf_submit_btn_" + form_data_id ).removeAttr('disabled');
    }

    return false;

});

jQuery(document).on('click','.original_btn',function(){
    var field_key = jQuery(this).attr('id').replace('div_', '');
    jQuery('#' + field_key + '_iframe').contents().find("#fileselect").click();
    var field_name = jQuery(this).attr('data-id');
    var form_data_id = jQuery(this).attr('data-form-data-id');
    jQuery('#arf_field_' + field_name + '_' + form_data_id + '_container').find('.help-block').empty();
    jQuery('#arf_field_' + field_name + '_' + form_data_id + '_container').find('.popover').remove();
    jQuery('#progress_' + field_key).hide();
    var result = jQuery('#' + field_key + '_iframe').contents().find("#fileselect").val();
    if (result != '' ) {

        var field_type = jQuery('#file_types_' + field_key).val();
        var field_size = jQuery('#file_size_' + field_key).val();
        var types_arr = field_type.split(",");
        var file_name = result.replace(/C:\\fakepath\\/i, '');
        var frmid = jQuery(this).attr('data-form-id');
        var seconds = new Date().getTime();
        var index = file_name.lastIndexOf('.'); 

        var extension = file_name.substring(index + 1); 

        var filename = /.*(?=\.)/.exec(file_name);
        var fname1 = frmid + "_" + field_name + "_" + seconds + "_" + filename;
        var funique_id = frmid + "_" + field_name + "_" + seconds;
        var fname = fname1.replace(/[^\w\s]/gi, '').replace(' ', '') + '.' + extension;
        var field_id = field_key;
        var is_preview = jQuery('[data-id="is_form_preview_' + frmid + '"]').val();
        var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        var file_type = '';
        var ie_version = jQuery('[data-id="arf_browser_name"]').attr('data-version');
        var browser = jQuery('[data-id="arf_browser_name"]').val();
        if (!jQuery.isFunction(is_ssl_replace)) {
            return;
        }
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var token = jQuery("#arf_file_token_" + frmid ).val();
        jQuery("#"+field_key+"_iframe").contents().find('form').attr('action',__ARFAJAXURL+"?action=arf_send_form_data&frm=" + frmid + "&field_id=" + field_id + "&file_type=" + file_type + "&file_size="+field_size+"&types_arr=" + types_arr + "&is_preview=" + is_preview+"&ie_version="+ie_version+"&browser="+browser+"&token="+token);

        jQuery('#' + field_key + '_iframe').contents().find('form').submit();
        jQuery('#div_' + field_key).css('margin-top', "-4px");
        jQuery('#progress_' + field_key).show();
        jQuery('#info_' + field_key).css('display', 'inline-block');
        jQuery('#info_' + field_key + ' .percent').html('').show();
        jQuery('#info_' + field_key + ' #percent').html('Uploading...');
        jQuery('#progress_' + field_key + ' div.bar').animate({width: "100%"}, 'slow');
        var myInterval = setInterval(function () {

            if (jQuery('#' + field_key + '_iframe').contents()){
                var uploaded = jQuery('#' + field_key + '_iframe').contents().find('.uploaded').length;
                if (uploaded > 0) {
                    clearInterval(myInterval);
                    jQuery('#progress_' + field_key).removeClass('active').hide();
                    
                    if(jQuery('#field_'+field_key).attr('multiple') === undefined){
                       jQuery('#field_'+field_key).parents('.arf_file_field').hide();
                    }
                    
                    jQuery('#info_' + field_key + ' #percent').html('File Uploaded').hide();
                    jQuery('input[name="file' + field_name + '"]').val(filename);
                    jQuery('input[name="file' + field_name + '"]').attr('data-file-valid', 'true'); 

                    var data = jQuery('#' + field_key + '_iframe').contents().find('.uploaded').html();
                    var response = data.split("|");
                    var images = document.getElementById('uploaded_file_name_' + frmid + '_' + form_data_id + '_' + field_name).value;
                    var upload_file_key = document.getElementById('upload_field_id_' + frmid + '_' + form_data_id).value;
                    jQuery('#arf_multi_file_info_' + field_key).css('display', 'inline-block');
                    var image_directory_url = document.getElementById('arf_image_directory_url_'+frmid+'_'+form_data_id).value;
                    var default_content = document.getElementById('arf_multi_file_info_' + field_key).innerHTML;
                    
                    var newupload_count_id = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress.counting:last').attr('arfupldcnt');
                    
                    var newupload_count = jQuery('#arf_multi_file_uploader_' + field_key).find('.arfprogress.counting').length;
                    
                    if(newupload_count == 'undefined' || isNaN(newupload_count) || newupload_count == ""){
                        newupload_count = 1;
                    } else {
                        newupload_count = parseInt(newupload_count)+1;
                    }

                    if(newupload_count_id == 'undefined' || isNaN(newupload_count_id) || newupload_count_id == ""){
                        newupload_count_id = 1;
                    } else {
                        newupload_count_id = parseInt(newupload_count_id)+1;
                    }
                    
                    var arf_new_id = newupload_count_id;

                    var upload_content = '<div id="arf_' + funique_id + '" class="arf_file_info_item"><span id="remove_' + field_key + '" class="ajax-file-remove" data-current-file-size="'+field_size+'" data-current-file-size-counter="'+arf_new_id+'" style="position: relative; overflow: hidden; float:left;" data-form-data-id="' + form_data_id + '" data-form-id="' + frmid + '" data-id="' + field_name + '" file-data-id="' + funique_id + '" ><svg height="19px" width="19px"><g><path xmlns="http://www.w3.org/2000/svg" fill-rule="evenodd" clip-rule="evenodd" fill="#ff0000" d="M16.939,5.845h-1.415V17.3c0,0.292-0.236,0.529-0.529,0.529H4.055  c-0.292,0-0.529-0.237-0.529-0.529V5.845H2.018c-0.292,0-0.529-0.739-0.529-1.031s0.237-0.982,0.529-0.982h2.509V1.379  c0-0.293,0.237-0.529,0.529-0.529h8.954c0.293,0,0.529,0.236,0.529,0.529v2.452h2.399c0.292,0,0.529,0.69,0.529,0.982  S17.231,5.845,16.939,5.845z M12.533,2.811H6.517v1.011h6.016V2.811z M13.541,5.845l-0.277-0.031L5.788,5.845H5.534v10.001h8.007  V5.845z M8.525,13.849H7.534v-6.08h0.991V13.849z M11.525,13.849h-0.991v-6.08h0.991V13.849z" /></g></svg></span><span id="file_name" class="file_name arf_info">' + result.replace(/C:\\fakepath\\/i, '') + '</span></div>';
                    document.getElementById('arf_multi_file_info_' + field_key).innerHTML = default_content + upload_content;
                    
                    if (images != '') {
                        document.getElementById('uploaded_file_name_' + frmid + '_' + form_data_id + '_' + field_name).value = images + ',' + response[1];
                    }
                    else {
                        document.getElementById('uploaded_file_name_' + frmid + '_' + form_data_id + '_' + field_name).value = response[1];
                    }
                    if (upload_file_key != '') {
                        document.getElementById('upload_field_id_' + frmid + '_' + form_data_id).value = upload_file_key + ',' + response[2] + '_' + seconds;
                    }else {
                        document.getElementById('upload_field_id_' + frmid + '_' + form_data_id).value = response[2] + '_' + seconds;
                    }

                    jQuery('#'+field_key+'_iframe_div').html(' ').append('<iframe id="'+field_key+'_iframe" src="'+arffiledragurl+'/core/views/iframe.php"></iframe>');
                }

                var error_upload = jQuery('#' + field_key + '_iframe').contents().find('.error_upload').length;
                var error_upload_size = jQuery('#' + field_key + '_iframe').contents().find('.error_upload_size').length;
                if (error_upload > 0 || error_upload_size > 0) {
                    clearInterval(myInterval);
                    var field_id = field_name;
                    jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false');                         

                    jQuery('#info_' + field_key + ' .percent').html('').hide();
                    jQuery('#info_' + field_key + ' #percent').html('');
                    jQuery('#info_' + field_key).hide();
                    jQuery('#progress_' + field_key + ' div.bar').css({width: "100%"});
                    jQuery('#progress_' + field_key).hide();
                    if (typeof (__ARFERR) != 'undefined')
                        var file_error = __ARFERR;
                    else
                        var file_error = 'Sorry, this file type is not permitted for security reasons.';



                    if (error_upload > 0) {
                        if (jQuery('#field_' + field_key).attr('data-invalid-message') !== undefined && jQuery('#field_' + field_key).attr('data-invalid-message') != '')
                            var arf_invalid_file_message = jQuery('#field_' + field_key).attr('data-invalid-message');
                        else
                            var arf_invalid_file_message = file_error;
                    } else {
                        if (jQuery('#field_' + field_key).attr('data-size-invalid-message') !== undefined && jQuery('#field_' + field_key).attr('data-size-invalid-message') != '')
                            var arf_invalid_file_message = jQuery('#field_' + field_key).attr('data-size-invalid-message');
                        else
                            var arf_invalid_file_message = file_error;
                    }

                    jQuery('#arf_field_' + field_id + '_' + form_data_id + '_container').removeClass('arf_success');
                    var $this = jQuery('#arf_field_' + field_id + '_' + form_data_id + '_container .controls');
                    var $controlGroup = $this.parents(".control-group").first();
                    var $helpBlock = $controlGroup.find(".help-block").first();
                    var form_id = $this.closest('form').find('[data-id="form_id"]').val();
                    var error_type = (jQuery('[data-id="form_tooltip_error_' + form_id + '"]').val() == 'advance') ? 'advance' : 'normal';
                    if (error_type == 'advance')
                    {
                        if (!jQuery.isFunction(arf_show_tooltip)) {
                            return;
                        }
                        arf_show_tooltip($controlGroup, $helpBlock, arf_invalid_file_message);

                    } else {
                        if (!$helpBlock.length) {
                            $helpBlock = jQuery('<div class="help-block"><ul><li>' + arf_invalid_file_message + '</li></ul></div>');
                            $controlGroup.find('.controls').append($helpBlock);
                            $controlGroup.find('.controls .help-block').removeClass('arfanimated bounceInDownNor').addClass('arfanimated bounceInDownNor');
                        }
                        else
                        {
                            $helpBlock = jQuery('<ul role="alert"><li>' + arf_invalid_file_message + '</li></ul>');
                            $controlGroup.find('.controls .help-block').append($helpBlock);
                            $controlGroup.find('.controls .help-block').removeClass('arfanimated bounceInDownNor').addClass('arfanimated bounceInDownNor');
                        }
                    }

                    jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe_multiple.php"></iframe>');
                }
            }
        }, 1000);
    }


    });

jQuery(document).ready(function ($) {
    
    if (window.File && window.FileList && window.FileReader) {
        Init();
    }

});

(function webpackUniversalModuleDefinition(root, factory) {
    if (typeof exports === 'object' && typeof module === 'object')
        module.exports = factory();
    else if (typeof define === 'function' && define.amd)
        define([], factory);
    else {
        var a = factory();
        for (var i in a)
            (typeof exports === 'object' ? exports : root)[i] = a[i];
    }
})(this, function () {
    return (function (modules) {
        var installedModules = {};
        function __webpack_require__(moduleId) {
            if (installedModules[moduleId])
                return installedModules[moduleId].exports;
            var module = installedModules[moduleId] = {
                exports: {},
                id: moduleId,
                loaded: false
            };
            modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

            module.loaded = true;

            return module.exports;
        }

        __webpack_require__.m = modules;

        __webpack_require__.c = installedModules;

        __webpack_require__.p = "";

        return __webpack_require__(0);
    })
        ([
            function (module, exports, __webpack_require__) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });

                var _createClass = function () {
                    function defineProperties(target, props) {
                        for (var i = 0; i < props.length; i++) {
                            var descriptor = props[i];
                            descriptor.enumerable = descriptor.enumerable || false;
                            descriptor.configurable = true;
                            if ("value" in descriptor)
                                descriptor.writable = true;
                            Object.defineProperty(target, descriptor.key, descriptor);
                        }
                    }
                    return function (Constructor, protoProps, staticProps) {
                        if (protoProps)
                            defineProperties(Constructor.prototype, protoProps);
                        if (staticProps)
                            defineProperties(Constructor, staticProps);
                        return Constructor;
                    };
                }();

                var _defaults = __webpack_require__(1);

                var _defaults2 = _interopRequireDefault(_defaults);

                var _template = __webpack_require__(2);

                var _template2 = _interopRequireDefault(_template);

                var _render = __webpack_require__(3);

                var _render2 = _interopRequireDefault(_render);

                var _preview = __webpack_require__(5);

                var _preview2 = _interopRequireDefault(_preview);

                var _events = __webpack_require__(6);

                var _events2 = _interopRequireDefault(_events);

                var _handlers = __webpack_require__(7);

                var _handlers2 = _interopRequireDefault(_handlers);

                var _change = __webpack_require__(8);

                var _change2 = _interopRequireDefault(_change);

                var _methods = __webpack_require__(9);

                var _methods2 = _interopRequireDefault(_methods);

                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                function _interopRequireDefault(obj) {
                    return obj && obj.__esModule ? obj : {default: obj};
                }

                function _classCallCheck(instance, Constructor) {
                    if (!(instance instanceof Constructor)) {
                        throw new TypeError("Cannot call a class as a function");
                    }
                }

                var NAMESPACE = 'cropper';

                var CLASS_HIDDEN = NAMESPACE + '-hidden';

                var EVENT_ERROR = 'error';
                var EVENT_LOAD = 'load';
                var EVENT_READY = 'ready';
                var EVENT_CROP = 'crop';

                var REGEXP_DATA_URL = /^data:/;
                var REGEXP_DATA_URL_JPEG = /^data:image\/jpeg.*;base64,/;

                var AnotherCropper = void 0;

                var Cropper = function () {
                    function Cropper(element, options) {
                        _classCallCheck(this, Cropper);

                        var self = this;

                        self.element = element[0];
                        self.options = $.extend({}, _defaults2.default, $.isPlainObject(options) && options);
                        self.loaded = false;
                        self.ready = false;
                        self.complete = false;
                        self.rotated = false;
                        self.cropped = false;
                        self.disabled = false;
                        self.replaced = false;
                        self.limited = false;
                        self.wheeling = false;
                        self.isImg = false;
                        self.originalUrl = '';
                        self.canvasData = null;
                        self.cropBoxData = null;
                        self.previews = null;
                        self.init();
                    }

                    _createClass(Cropper, [{
                            key: 'init',
                            value: function init() {
                                var self = this;
                                var element = self.element;
                                var tagName = element.tagName.toLowerCase();
                                var url = void 0;

                                if ($.getData(element, NAMESPACE)) {
                                    return;
                                }

                                $.setData(element, NAMESPACE, self);

                                if (tagName === 'img') {
                                    self.isImg = true;

                                    self.originalUrl = url = element.getAttribute('src');

                                    if (!url) {
                                        return;
                                    }

                                    url = element.src;
                                } else if (tagName === 'canvas' && window.HTMLCanvasElement) {
                                    url = element.toDataURL();
                                }

                                self.load(url);
                            }
                        }, {
                            key: 'load',
                            value: function load(url) {
                                var self = this;
                                var options = self.options;
                                var element = self.element;

                                if (!url) {
                                    return;
                                }

                                self.url = url;
                                self.imageData = {};

                                if (!options.checkOrientation || !window.ArrayBuffer) {
                                    self.clone();
                                    return;
                                }

                                if (REGEXP_DATA_URL.test(url)) {
                                    if (REGEXP_DATA_URL_JPEG) {
                                        self.read($.dataURLToArrayBuffer(url));
                                    } else {
                                        self.clone();
                                    }
                                    return;
                                }

                                var xhr = new XMLHttpRequest();

                                xhr.onerror = xhr.onabort = function () {
                                    self.clone();
                                };

                                xhr.onload = function () {
                                    self.read(xhr.response);
                                };

                                if (options.checkCrossOrigin && $.isCrossOriginURL(url) && element.crossOrigin) {
                                    url = $.addTimestamp(url);
                                }

                                xhr.open('get', url);
                                xhr.responseType = 'arraybuffer';
                                xhr.send();
                            }
                        }, {
                            key: 'read',
                            value: function read(arrayBuffer) {
                                var self = this;
                                var options = self.options;
                                var orientation = $.getOrientation(arrayBuffer);
                                var imageData = self.imageData;
                                var rotate = 0;
                                var scaleX = 1;
                                var scaleY = 1;

                                if (orientation > 1) {
                                    self.url = $.arrayBufferToDataURL(arrayBuffer);

                                    switch (orientation) {

                                        case 2:
                                            scaleX = -1;
                                            break;

                                        case 3:
                                            rotate = -180;
                                            break;

                                        case 4:
                                            scaleY = -1;
                                            break;

                                        case 5:
                                            rotate = 90;
                                            scaleY = -1;
                                            break;

                                        case 6:
                                            rotate = 90;
                                            break;

                                        case 7:
                                            rotate = 90;
                                            scaleX = -1;
                                            break;

                                        case 8:
                                            rotate = -90;
                                            break;
                                    }
                                }

                                if (options.rotatable) {
                                    jQuery('#arf_crop_image').attr("data-rotate", rotate);
                                }

                                if (options.scalable) {
                                    imageData.scaleX = scaleX;
                                    imageData.scaleY = scaleY;
                                }

                                self.clone();
                            }
                        }, {
                            key: 'clone',
                            value: function clone() {
                                var self = this;
                                var element = self.element;
                                var url = self.url;
                                var crossOrigin = void 0;
                                var crossOriginUrl = void 0;
                                var start = void 0;
                                var stop = void 0;

                                if (self.options.checkCrossOrigin && $.isCrossOriginURL(url)) {
                                    crossOrigin = element.crossOrigin;

                                    if (crossOrigin) {
                                        crossOriginUrl = url;
                                    } else {
                                        crossOrigin = 'anonymous';
                                        crossOriginUrl = $.addTimestamp(url);
                                    }
                                }

                                self.crossOrigin = crossOrigin;
                                self.crossOriginUrl = crossOriginUrl;

                                var image = $.createElement('img');

                                if (crossOrigin) {
                                    image.crossOrigin = crossOrigin;
                                }

                                image.src = crossOriginUrl || url;
                                self.image = image;
                                self.onStart = start = $.proxy(self.start, self);
                                self.onStop = stop = $.proxy(self.stop, self);

                                if (self.isImg) {
                                    if (element.complete) {
                                        self.start();
                                    } else {
                                        $.addListener(element, EVENT_LOAD, start);
                                    }
                                } else {
                                    $.addListener(image, EVENT_LOAD, start);
                                    $.addListener(image, EVENT_ERROR, stop);
                                    $.addClass(image, 'cropper-hide');
                                    element.parentNode.insertBefore(image, element.nextSibling);
                                }
                            }
                        }, {
                            key: 'start',
                            value: function start(event) {

                                var self = this;
                                var image = self.isImg ? self.element : self.image;

                                if (event) {
                                    $.removeListener(image, EVENT_LOAD, self.onStart);
                                    $.removeListener(image, EVENT_ERROR, self.onStop);
                                }

                                $.getImageSize(image, function (naturalWidth, naturalHeight) {
                                    $.extend(self.imageData, {
                                        naturalWidth: naturalWidth,
                                        naturalHeight: naturalHeight,
                                        aspectRatio: naturalWidth / naturalHeight
                                    });

                                    self.loaded = true;
                                    self.build();
                                });
                            }
                        }, {
                            key: 'stop',
                            value: function stop() {
                                var self = this;
                                var image = self.image;

                                $.removeListener(image, EVENT_LOAD, self.onStart);
                                $.removeListener(image, EVENT_ERROR, self.onStop);

                                $.removeChild(image);
                                self.image = null;
                            }
                        }, {
                            key: 'build',
                            value: function build() {
                                var self = this;
                                var options = self.options;
                                var element = self.element;
                                var image = self.image;
                                var container = void 0;
                                var cropper = void 0;
                                var canvas = void 0;
                                var dragBox = void 0;
                                var cropBox = void 0;
                                var face = void 0;

                                if (!self.loaded) {
                                    return;
                                }

                                if (self.ready) {
                                    self.unbuild();
                                }

                                var template = $.createElement('div');
                                template.innerHTML = _template2.default;

                                self.container = container = element.parentNode;
                                self.cropper = cropper = $.getByClass(template, 'cropper-container')[0];
                                self.canvas = canvas = $.getByClass(cropper, 'cropper-canvas')[0];
                                self.dragBox = dragBox = $.getByClass(cropper, 'cropper-drag-box')[0];
                                self.cropBox = cropBox = $.getByClass(cropper, 'cropper-crop-box')[0];
                                self.viewBox = $.getByClass(cropper, 'cropper-view-box')[0];
                                self.face = face = $.getByClass(cropBox, 'cropper-face')[0];

                                $.appendChild(canvas, image);

                                $.addClass(element, CLASS_HIDDEN);

                                container.insertBefore(cropper, element.nextSibling);

                                if (!self.isImg) {
                                    $.removeClass(image, 'cropper-hide');
                                }

                                self.initPreview();
                                self.bind();

                                options.aspectRatio = Math.max(0, options.aspectRatio) || NaN;
                                options.viewMode = Math.max(0, Math.min(3, Math.round(options.viewMode))) || 0;

                                if (options.autoCrop) {
                                    self.cropped = true;

                                    if (options.modal) {
                                        $.addClass(dragBox, 'cropper-modal');
                                    }
                                } else {
                                    $.addClass(cropBox, CLASS_HIDDEN);
                                }

                                if (!options.guides) {
                                    $.addClass($.getByClass(cropBox, 'cropper-dashed'), CLASS_HIDDEN);
                                }

                                if (!options.center) {
                                    $.addClass($.getByClass(cropBox, 'cropper-center'), CLASS_HIDDEN);
                                }

                                if (options.background) {
                                    $.addClass(cropper, 'cropper-bg');
                                }

                                if (!options.highlight) {
                                    $.addClass(face, 'cropper-invisible');
                                }

                                if (options.cropBoxMovable) {
                                    $.addClass(face, 'cropper-move');
                                    $.setData(face, 'action', 'all');
                                }

                                if (!options.cropBoxResizable) {
                                    $.addClass($.getByClass(cropBox, 'cropper-line'), CLASS_HIDDEN);
                                    $.addClass($.getByClass(cropBox, 'cropper-point'), CLASS_HIDDEN);
                                }

                                self.setDragMode(options.dragMode);
                                self.render();
                                self.ready = true;
                                self.setData(options.data);

                                setTimeout(function () {
                                    if ($.isFunction(options.ready)) {
                                        $.addListener(element, EVENT_READY, options.ready, true);
                                    }

                                    $.dispatchEvent(element, EVENT_READY);
                                    $.dispatchEvent(element, EVENT_CROP, self.getData());

                                    self.complete = true;
                                }, 0);
                            }
                        }, {
                            key: 'unbuild',
                            value: function unbuild() {
                                var self = this;

                                if (!self.ready) {
                                    return;
                                }

                                self.ready = false;
                                self.complete = false;
                                self.initialImageData = null;

                                self.initialCanvasData = null;
                                self.initialCropBoxData = null;
                                self.containerData = null;
                                self.canvasData = null;

                                self.cropBoxData = null;
                                self.unbind();

                                self.resetPreview();
                                self.previews = null;

                                self.viewBox = null;
                                self.cropBox = null;
                                self.dragBox = null;
                                self.canvas = null;
                                self.container = null;

                                $.removeChild(self.cropper);
                                self.cropper = null;
                            }
                        }], [{
                            key: 'noConflict',
                            value: function noConflict() {
                                window.Cropper = AnotherCropper;
                                return Cropper;
                            }
                        }, {
                            key: 'setDefaults',
                            value: function setDefaults(options) {
                                $.extend(_defaults2.default, $.isPlainObject(options) && options);
                            }
                        }]);

                    return Cropper;
                }();

                $.extend(Cropper.prototype, _render2.default);
                $.extend(Cropper.prototype, _preview2.default);
                $.extend(Cropper.prototype, _events2.default);
                $.extend(Cropper.prototype, _handlers2.default);
                $.extend(Cropper.prototype, _change2.default);
                $.extend(Cropper.prototype, _methods2.default);

                if (typeof window !== 'undefined') {
                    AnotherCropper = window.Cropper;
                    window.Cropper = Cropper;
                }

                exports.default = Cropper;

            },
            function (module, exports) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });
                exports.default = {
                    viewMode: 0,
                    dragMode: 'crop',
                    aspectRatio: NaN,
                    data: null,
                    preview: '',
                    responsive: true,
                    restore: true,
                    checkCrossOrigin: true,
                    checkOrientation: true,
                    modal: true,
                    guides: true,
                    center: true,
                    highlight: true,
                    background: true,
                    autoCrop: true,
                    autoCropArea: 0.8,
                    movable: true,
                    rotatable: true,
                    scalable: true,
                    zoomable: true,
                    zoomOnTouch: false,
                    zoomOnWheel: true,
                    wheelZoomRatio: 0.1,
                    cropBoxMovable: true,
                    cropBoxResizable: true,
                    toggleDragModeOnDblclick: false,
                    minCanvasWidth: 0,
                    minCanvasHeight: 0,
                    minCropBoxWidth: 0,
                    minCropBoxHeight: 0,
                    minContainerWidth: 200,
                    minContainerHeight: 100,
                    ready: null,
                    cropstart: null,
                    cropmove: null,
                    cropend: null,
                    crop: null,
                    zoom: null
                };
            },
            function (module, exports) {
                'use strict';
                Object.defineProperty(exports, "__esModule", {
                    value: true
                });
                exports.default = '<div class="cropper-container">' + '<div class="cropper-wrap-box">' + '<div class="cropper-canvas"></div>' + '</div>' + '<div class="cropper-drag-box"></div>' + '<div class="cropper-crop-box">' + '<span class="cropper-view-box"></span>' + '<span class="cropper-dashed dashed-h"></span>' + '<span class="cropper-dashed dashed-v"></span>' + '<span class="cropper-center"></span>' + '<span class="cropper-face"></span>' + '<span class="cropper-line line-e" data-action="e"></span>' + '<span class="cropper-line line-n" data-action="n"></span>' + '<span class="cropper-line line-w" data-action="w"></span>' + '<span class="cropper-line line-s" data-action="s"></span>' + '<span class="cropper-point point-e" data-action="e"></span>' + '<span class="cropper-point point-n" data-action="n"></span>' + '<span class="cropper-point point-w" data-action="w"></span>' + '<span class="cropper-point point-s" data-action="s"></span>' + '<span class="cropper-point point-ne" data-action="ne"></span>' + '<span class="cropper-point point-nw" data-action="nw"></span>' + '<span class="cropper-point point-sw" data-action="sw"></span>' + '<span class="cropper-point point-se" data-action="se"></span>' + '</div>' + '</div>';
            },
            function (module, exports, __webpack_require__) {
                'use strict';
                Object.defineProperty(exports, "__esModule", {
                    value: true
                });
                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                exports.default = {
                    render: function render() {
                        var self = this;

                        self.initContainer();
                        self.initCanvas();
                        self.initCropBox();

                        self.renderCanvas();

                        if (self.cropped) {
                            self.renderCropBox();
                        }
                    },
                    initContainer: function initContainer() {
                        var self = this;
                        var options = self.options;
                        var element = self.element;
                        var container = self.container;
                        var cropper = self.cropper;
                        var containerData = void 0;

                        $.addClass(cropper, 'cropper-hidden');
                        $.removeClass(element, 'cropper-hidden');

                        self.containerData = containerData = {
                            width: Math.max(container.offsetWidth, Number(options.minContainerWidth) || 200),
                            height: Math.max(container.offsetHeight, Number(options.minContainerHeight) || 100)
                        };

                        $.setStyle(cropper, {
                            width: containerData.width,
                            height: containerData.height
                        });

                        $.addClass(element, 'cropper-hidden');
                        $.removeClass(cropper, 'cropper-hidden');
                    },
                    initCanvas: function initCanvas() {
                        var self = this;
                        var viewMode = self.options.viewMode;
                        var containerData = self.containerData;
                        var imageData = self.imageData;
                        var rotated = Math.abs(imageData.rotate) === 90;
                        var naturalWidth = rotated ? imageData.naturalHeight : imageData.naturalWidth;
                        var naturalHeight = rotated ? imageData.naturalWidth : imageData.naturalHeight;
                        var aspectRatio = naturalWidth / naturalHeight;
                        var canvasWidth = containerData.width;
                        var canvasHeight = containerData.height;

                        if (containerData.height * aspectRatio > containerData.width) {
                            if (viewMode === 3) {
                                canvasWidth = containerData.height * aspectRatio;
                            } else {
                                canvasHeight = containerData.width / aspectRatio;
                            }
                        } else if (viewMode === 3) {
                            canvasHeight = containerData.width / aspectRatio;
                        } else {
                            canvasWidth = containerData.height * aspectRatio;
                        }

                        var canvasData = {
                            naturalWidth: naturalWidth,
                            naturalHeight: naturalHeight,
                            aspectRatio: aspectRatio,
                            width: canvasWidth,
                            height: canvasHeight
                        };

                        canvasData.oldLeft = canvasData.left = (containerData.width - canvasWidth) / 2;
                        canvasData.oldTop = canvasData.top = (containerData.height - canvasHeight) / 2;

                        self.canvasData = canvasData;
                        self.limited = viewMode === 1 || viewMode === 2;
                        self.limitCanvas(true, true);
                        self.initialImageData = $.extend({}, imageData);
                        self.initialCanvasData = $.extend({}, canvasData);
                    },
                    limitCanvas: function limitCanvas(sizeLimited, positionLimited) {
                        var self = this;
                        var options = self.options;
                        var viewMode = options.viewMode;
                        var containerData = self.containerData;
                        if (containerData == null) { containerData = []; }
                        var canvasData = self.canvasData;
                        if (canvasData == null) { canvasData = []; }
                        var aspectRatio = canvasData.aspectRatio;
                        var cropBoxData = self.cropBoxData;
                        var cropped = self.cropped && cropBoxData;
                        var minCanvasWidth = void 0;
                        var minCanvasHeight = void 0;
                        var newCanvasLeft = void 0;
                        var newCanvasTop = void 0;

                        if (sizeLimited) {
                            minCanvasWidth = Number(options.minCanvasWidth) || 0;
                            minCanvasHeight = Number(options.minCanvasHeight) || 0;

                            if (viewMode > 1) {
                                minCanvasWidth = Math.max(minCanvasWidth, containerData.width);
                                minCanvasHeight = Math.max(minCanvasHeight, containerData.height);

                                if (viewMode === 3) {
                                    if (minCanvasHeight * aspectRatio > minCanvasWidth) {
                                        minCanvasWidth = minCanvasHeight * aspectRatio;
                                    } else {
                                        minCanvasHeight = minCanvasWidth / aspectRatio;
                                    }
                                }
                            } else if (viewMode > 0) {
                                if (minCanvasWidth) {
                                    minCanvasWidth = Math.max(minCanvasWidth, cropped ? cropBoxData.width : 0);
                                } else if (minCanvasHeight) {
                                    minCanvasHeight = Math.max(minCanvasHeight, cropped ? cropBoxData.height : 0);
                                } else if (cropped) {
                                    minCanvasWidth = cropBoxData.width;
                                    minCanvasHeight = cropBoxData.height;

                                    if (minCanvasHeight * aspectRatio > minCanvasWidth) {
                                        minCanvasWidth = minCanvasHeight * aspectRatio;
                                    } else {
                                        minCanvasHeight = minCanvasWidth / aspectRatio;
                                    }
                                }
                            }

                            if (minCanvasWidth && minCanvasHeight) {
                                if (minCanvasHeight * aspectRatio > minCanvasWidth) {
                                    minCanvasHeight = minCanvasWidth / aspectRatio;
                                } else {
                                    minCanvasWidth = minCanvasHeight * aspectRatio;
                                }
                            } else if (minCanvasWidth) {
                                minCanvasHeight = minCanvasWidth / aspectRatio;
                            } else if (minCanvasHeight) {
                                minCanvasWidth = minCanvasHeight * aspectRatio;
                            }

                            canvasData.minWidth = minCanvasWidth;
                            canvasData.minHeight = minCanvasHeight;
                            canvasData.maxWidth = Infinity;
                            canvasData.maxHeight = Infinity;
                        }

                        if (positionLimited) {
                            if (viewMode) {
                                newCanvasLeft = containerData.width - canvasData.width;
                                newCanvasTop = containerData.height - canvasData.height;

                                canvasData.minLeft = Math.min(0, newCanvasLeft);
                                canvasData.minTop = Math.min(0, newCanvasTop);
                                canvasData.maxLeft = Math.max(0, newCanvasLeft);
                                canvasData.maxTop = Math.max(0, newCanvasTop);

                                if (cropped && self.limited) {
                                    canvasData.minLeft = Math.min(cropBoxData.left, cropBoxData.left + (cropBoxData.width - canvasData.width));
                                    canvasData.minTop = Math.min(cropBoxData.top, cropBoxData.top + (cropBoxData.height - canvasData.height));
                                    canvasData.maxLeft = cropBoxData.left;
                                    canvasData.maxTop = cropBoxData.top;

                                    if (viewMode === 2) {
                                        if (canvasData.width >= containerData.width) {
                                            canvasData.minLeft = Math.min(0, newCanvasLeft);
                                            canvasData.maxLeft = Math.max(0, newCanvasLeft);
                                        }

                                        if (canvasData.height >= containerData.height) {
                                            canvasData.minTop = Math.min(0, newCanvasTop);
                                            canvasData.maxTop = Math.max(0, newCanvasTop);
                                        }
                                    }
                                }
                            } else {
                                canvasData.minLeft = -canvasData.width;
                                canvasData.minTop = -canvasData.height;
                                canvasData.maxLeft = containerData.width;
                                canvasData.maxTop = containerData.height;
                            }
                        }
                    },
                    renderCanvas: function renderCanvas(changed) {
                        var self = this;
                        var canvasData = self.canvasData;
                        if (canvasData == null) { canvasData = []; }
                        var imageData = self.imageData;
                        var rotate = imageData.rotate;
                        var aspectRatio = void 0;
                        var rotatedData = void 0;

                        if (self.rotated) {
                            self.rotated = false;

                            rotatedData = $.getRotatedSizes({
                                width: imageData.width,
                                height: imageData.height,
                                degree: rotate
                            });

                            aspectRatio = rotatedData.width / rotatedData.height;

                            if (aspectRatio !== canvasData.aspectRatio) {
                                canvasData.left -= (rotatedData.width - canvasData.width) / 2;
                                canvasData.top -= (rotatedData.height - canvasData.height) / 2;
                                canvasData.width = rotatedData.width;
                                canvasData.height = rotatedData.height;
                                canvasData.aspectRatio = aspectRatio;
                                canvasData.naturalWidth = imageData.naturalWidth;
                                canvasData.naturalHeight = imageData.naturalHeight;

                                if (rotate % 180) {
                                    rotatedData = $.getRotatedSizes({
                                        width: imageData.naturalWidth,
                                        height: imageData.naturalHeight,
                                        degree: rotate
                                    });

                                    canvasData.naturalWidth = rotatedData.width;
                                    canvasData.naturalHeight = rotatedData.height;
                                }

                                self.limitCanvas(true, false);
                            }
                        }

                        if (canvasData.width > canvasData.maxWidth || canvasData.width < canvasData.minWidth) {
                            canvasData.left = canvasData.oldLeft;
                        }

                        if (canvasData.height > canvasData.maxHeight || canvasData.height < canvasData.minHeight) {
                            canvasData.top = canvasData.oldTop;
                        }

                        canvasData.width = Math.min(Math.max(canvasData.width, canvasData.minWidth), canvasData.maxWidth);
                        canvasData.height = Math.min(Math.max(canvasData.height, canvasData.minHeight), canvasData.maxHeight);

                        self.limitCanvas(false, true);

                        canvasData.oldLeft = canvasData.left = Math.min(Math.max(canvasData.left, canvasData.minLeft), canvasData.maxLeft);
                        canvasData.oldTop = canvasData.top = Math.min(Math.max(canvasData.top, canvasData.minTop), canvasData.maxTop);

                        $.setStyle(self.canvas, {
                            width: canvasData.width,
                            height: canvasData.height,
                            left: canvasData.left,
                            top: canvasData.top
                        });

                        self.renderImage();

                        if (self.cropped && self.limited) {
                            self.limitCropBox(true, true);
                        }

                        if (changed) {
                            self.output();
                        }
                    },
                    renderImage: function renderImage(changed) {
                        var self = this;
                        var canvasData = self.canvasData;
                        if (canvasData == null) { canvasData = []; }
                        var imageData = self.imageData;
                        var newImageData = void 0;
                        var reversedData = void 0;
                        var reversedWidth = void 0;
                        var reversedHeight = void 0;

                        if (imageData.rotate) {
                            reversedData = $.getRotatedSizes({
                                width: canvasData.width,
                                height: canvasData.height,
                                degree: imageData.rotate,
                                aspectRatio: imageData.aspectRatio
                            }, true);

                            reversedWidth = reversedData.width;
                            reversedHeight = reversedData.height;

                            newImageData = {
                                width: reversedWidth,
                                height: reversedHeight,
                                left: (canvasData.width - reversedWidth) / 2,
                                top: (canvasData.height - reversedHeight) / 2
                            };
                        }

                        $.extend(imageData, newImageData || {
                            width: canvasData.width,
                            height: canvasData.height,
                            left: 0,
                            top: 0
                        });

                        var transform = $.getTransform(imageData);

                        $.setStyle(self.image, {
                            width: imageData.width,
                            height: imageData.height,
                            marginLeft: imageData.left,
                            marginTop: imageData.top,
                            WebkitTransform: transform,
                            msTransform: transform,
                            transform: transform
                        });

                        if (changed) {
                            self.output();
                        }
                    },
                    initCropBox: function initCropBox() {
                        var self = this;
                        var options = self.options;
                        var aspectRatio = options.aspectRatio;
                        var autoCropArea = Number(options.autoCropArea) || 0.8;
                        var canvasData = self.canvasData;
                        var cropBoxData = {
                            width: canvasData.width,
                            height: canvasData.height
                        };

                        if (aspectRatio) {
                            if (canvasData.height * aspectRatio > canvasData.width) {
                                cropBoxData.height = cropBoxData.width / aspectRatio;
                            } else {
                                cropBoxData.width = cropBoxData.height * aspectRatio;
                            }
                        }

                        self.cropBoxData = cropBoxData;
                        self.limitCropBox(true, true);

                        cropBoxData.width = Math.min(Math.max(cropBoxData.width, cropBoxData.minWidth), cropBoxData.maxWidth);
                        cropBoxData.height = Math.min(Math.max(cropBoxData.height, cropBoxData.minHeight), cropBoxData.maxHeight);

                        cropBoxData.width = Math.max(cropBoxData.minWidth, cropBoxData.width * autoCropArea);
                        cropBoxData.height = Math.max(cropBoxData.minHeight, cropBoxData.height * autoCropArea);
                        cropBoxData.oldLeft = cropBoxData.left = canvasData.left + (canvasData.width - cropBoxData.width) / 2;
                        cropBoxData.oldTop = cropBoxData.top = canvasData.top + (canvasData.height - cropBoxData.height) / 2;

                        self.initialCropBoxData = $.extend({}, cropBoxData);
                    },
                    limitCropBox: function limitCropBox(sizeLimited, positionLimited) {
                        var self = this;
                        var options = self.options;
                        var aspectRatio = options.aspectRatio;
                        var containerData = self.containerData;
                        var canvasData = self.canvasData;
                        var cropBoxData = self.cropBoxData;
                        var limited = self.limited;
                        var minCropBoxWidth = void 0;
                        var minCropBoxHeight = void 0;
                        var maxCropBoxWidth = void 0;
                        var maxCropBoxHeight = void 0;
                        if (cropBoxData == null) {
                            cropBoxData = [];
                        }
                        if (containerData ==null) {
                            containerData = [];
                        }
                        if (sizeLimited) {
                            minCropBoxWidth = Number(options.minCropBoxWidth) || 0;
                            minCropBoxHeight = Number(options.minCropBoxHeight) || 0;

                            minCropBoxWidth = Math.min(minCropBoxWidth, containerData.width);
                            minCropBoxHeight = Math.min(minCropBoxHeight, containerData.height);
                            maxCropBoxWidth = Math.min(containerData.width, limited ? canvasData.width : containerData.width);
                            maxCropBoxHeight = Math.min(containerData.height, limited ? canvasData.height : containerData.height);

                            if (aspectRatio) {
                                if (minCropBoxWidth && minCropBoxHeight) {
                                    if (minCropBoxHeight * aspectRatio > minCropBoxWidth) {
                                        minCropBoxHeight = minCropBoxWidth / aspectRatio;
                                    } else {
                                        minCropBoxWidth = minCropBoxHeight * aspectRatio;
                                    }
                                } else if (minCropBoxWidth) {
                                    minCropBoxHeight = minCropBoxWidth / aspectRatio;
                                } else if (minCropBoxHeight) {
                                    minCropBoxWidth = minCropBoxHeight * aspectRatio;
                                }

                                if (maxCropBoxHeight * aspectRatio > maxCropBoxWidth) {
                                    maxCropBoxHeight = maxCropBoxWidth / aspectRatio;
                                } else {
                                    maxCropBoxWidth = maxCropBoxHeight * aspectRatio;
                                }
                            }

                            cropBoxData.minWidth = Math.min(minCropBoxWidth, maxCropBoxWidth);
                            cropBoxData.minHeight = Math.min(minCropBoxHeight, maxCropBoxHeight);
                            cropBoxData.maxWidth = maxCropBoxWidth;
                            cropBoxData.maxHeight = maxCropBoxHeight;
                        }

                        if (positionLimited) {
                            if (limited) {
                                cropBoxData.minLeft = Math.max(0, canvasData.left);
                                cropBoxData.minTop = Math.max(0, canvasData.top);
                                cropBoxData.maxLeft = Math.min(containerData.width, canvasData.left + canvasData.width) - cropBoxData.width;
                                cropBoxData.maxTop = Math.min(containerData.height, canvasData.top + canvasData.height) - cropBoxData.height;
                            } else {
                                cropBoxData.minLeft = 0;
                                cropBoxData.minTop = 0;
                                cropBoxData.maxLeft = containerData.width - cropBoxData.width;
                                cropBoxData.maxTop = containerData.height - cropBoxData.height;
                            }
                        }
                    },
                    renderCropBox: function renderCropBox() {
                        var self = this;
                        var options = self.options;
                        var containerData = self.containerData;
                        var cropBoxData = self.cropBoxData;
                        if (cropBoxData == null) {
                            cropBoxData = [];
                        }
                        if (cropBoxData.width > cropBoxData.maxWidth || cropBoxData.width < cropBoxData.minWidth) {
                            cropBoxData.left = cropBoxData.oldLeft;
                        }

                        if (cropBoxData.height > cropBoxData.maxHeight || cropBoxData.height < cropBoxData.minHeight) {
                            cropBoxData.top = cropBoxData.oldTop;
                        }

                        cropBoxData.width = Math.min(Math.max(cropBoxData.width, cropBoxData.minWidth), cropBoxData.maxWidth);
                        cropBoxData.height = Math.min(Math.max(cropBoxData.height, cropBoxData.minHeight), cropBoxData.maxHeight);

                        self.limitCropBox(false, true);

                        cropBoxData.oldLeft = cropBoxData.left = Math.min(Math.max(cropBoxData.left, cropBoxData.minLeft), cropBoxData.maxLeft);
                        cropBoxData.oldTop = cropBoxData.top = Math.min(Math.max(cropBoxData.top, cropBoxData.minTop), cropBoxData.maxTop);

                        if (options.movable && options.cropBoxMovable) {
                            if (containerData == null) {
                                containerData = [];
                            }
                            $.setData(self.face, 'action', cropBoxData.width === containerData.width && cropBoxData.height === containerData.height ? 'move' : 'all');
                        }

                        $.setStyle(self.cropBox, {
                            width: cropBoxData.width,
                            height: cropBoxData.height,
                            left: cropBoxData.left,
                            top: cropBoxData.top
                        });

                        if (self.cropped && self.limited) {
                            self.limitCanvas(true, true);
                        }

                        if (!self.disabled) {
                            self.output();
                        }
                    },
                    output: function output() {
                        var self = this;

                        self.preview();

                        if (self.complete) {
                            $.dispatchEvent(self.element, 'crop', self.getData());
                        }
                    }
                };

            },
            function (module, exports) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });

                var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
                    return typeof obj;
                } : function (obj) {
                    return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj;
                };

                exports.typeOf = typeOf;
                exports.isNumber = isNumber;
                exports.isUndefined = isUndefined;
                exports.isObject = isObject;
                exports.isPlainObject = isPlainObject;
                exports.isFunction = isFunction;
                exports.isArray = isArray;
                exports.toArray = toArray;
                exports.trim = trim;
                exports.each = each;
                exports.extend = extend;
                exports.proxy = proxy;
                exports.setStyle = setStyle;
                exports.hasClass = hasClass;
                exports.addClass = addClass;
                exports.removeClass = removeClass;
                exports.toggleClass = toggleClass;
                exports.hyphenate = hyphenate;
                exports.getData = getData;
                exports.setData = setData;
                exports.removeData = removeData;
                exports.removeListener = removeListener;
                exports.dispatchEvent = dispatchEvent;
                exports.getEvent = getEvent;
                exports.getOffset = getOffset;
                exports.getTouchesCenter = getTouchesCenter;
                exports.getByTag = getByTag;
                exports.getByClass = getByClass;
                exports.createElement = createElement;
                exports.appendChild = appendChild;
                exports.removeChild = removeChild;
                exports.empty = empty;
                exports.isCrossOriginURL = isCrossOriginURL;
                exports.addTimestamp = addTimestamp;
                exports.getImageSize = getImageSize;
                exports.getTransform = getTransform;
                exports.getRotatedSizes = getRotatedSizes;
                exports.getSourceCanvas = getSourceCanvas;
                exports.getStringFromCharCode = getStringFromCharCode;
                exports.getOrientation = getOrientation;
                exports.dataURLToArrayBuffer = dataURLToArrayBuffer;
                exports.arrayBufferToDataURL = arrayBufferToDataURL;
                var REGEXP_DATA_URL_HEAD = /^data:([^;]+);base64,/;
                var REGEXP_HYPHENATE = /([a-z\d])([A-Z])/g;
                var REGEXP_ORIGINS = /^(https?:)\/\/([^:\/\?#]+):?(\d*)/i;
                var REGEXP_SPACES = /\s+/;
                var REGEXP_SUFFIX = /^(width|height|left|top|marginLeft|marginTop)$/;
                var REGEXP_TRIM = /^\s+(.*)\s+$/;
                var REGEXP_USERAGENT = /(Macintosh|iPhone|iPod|iPad).*AppleWebKit/i;
                var navigator = window.navigator;
                var IS_SAFARI_OR_UIWEBVIEW = navigator && REGEXP_USERAGENT.test(navigator.userAgent);

                var objectProto = Object.prototype;
                var toString = objectProto.toString;
                var hasOwnProperty = objectProto.hasOwnProperty;
                var slice = Array.prototype.slice;
                var fromCharCode = String.fromCharCode;

                function typeOf(obj) {
                    return toString.call(obj).slice(8, -1).toLowerCase();
                }

                function isNumber(num) {
                    return typeof num === 'number' && !isNaN(num);
                }

                function isUndefined(obj) {
                    return typeof obj === 'undefined';
                }

                function isObject(obj) {
                    return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && obj !== null;
                }

                function isPlainObject(obj) {
                    if (!isObject(obj)) {
                        return false;
                    }

                    try {
                        var _constructor = obj.constructor;
                        var prototype = _constructor.prototype;

                        return _constructor && prototype && hasOwnProperty.call(prototype, 'isPrototypeOf');
                    } catch (e) {
                        return false;
                    }
                }

                function isFunction(fn) {
                    return typeOf(fn) === 'function';
                }

                function isArray(arr) {
                    return Array.isArray ? Array.isArray(arr) : typeOf(arr) === 'array';
                }

                function toArray(obj, offset) {
                    offset = offset >= 0 ? offset : 0;

                    if (Array.from) {
                        return Array.from(obj).slice(offset);
                    }

                    return slice.call(obj, offset);
                }

                function trim(str) {
                    if (typeof str === 'string') {
                        str = str.trim ? str.trim() : str.replace(REGEXP_TRIM, '$1');
                    }

                    return str;
                }

                function each(obj, callback) {
                    if (obj && isFunction(callback)) {
                        var i = void 0;

                        if (isArray(obj) || isNumber(obj.length)) {
                            var length = obj.length;

                            for (i = 0; i < length; i++) {
                                if (callback.call(obj, obj[i], i, obj) === false) {
                                    break;
                                }
                            }
                        } else if (isObject(obj)) {
                            Object.keys(obj).forEach(function (key) {
                                callback.call(obj, obj[key], key, obj);
                            });
                        }
                    }

                    return obj;
                }

                function extend() {
                    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                        args[_key] = arguments[_key];
                    }

                    var deep = args[0] === true;
                    var data = deep ? args[1] : args[0];

                    if (args.length > 1) {

                        args.shift();

                        if (data == null) {
                            data = [];
                        }
                        args.forEach(function (arg) {
                            if (isObject(arg)) {
                                Object.keys(arg).forEach(function (key) {
                                    if (deep && isObject(data[key])) {
                                        extend(true, data[key], arg[key]);
                                    } else {
                                        data[key] = arg[key];
                                    }
                                });
                            }
                        });
                    }

                    return data;
                }

                function proxy(fn, context) {
                    for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
                        args[_key2 - 2] = arguments[_key2];
                    }

                    return function () {
                        for (var _len3 = arguments.length, args2 = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
                            args2[_key3] = arguments[_key3];
                        }

                        return fn.apply(context, args.concat(args2));
                    };
                }

                function setStyle(element, styles) {
                    if (element == null) { element = []; }
                    var style = element.style;

                    if (style == null) { style = []; }
                    each(styles, function (value, property) {
                        if (REGEXP_SUFFIX.test(property) && isNumber(value)) {
                            value += 'px';
                        }

                        style[property] = value;
                    });
                }

                function hasClass(element, value) {
                    return element.classList ? element.classList.contains(value) : element.className.indexOf(value) > -1;
                }

                function addClass(element, value) {
                    if (element == null) { element = []; }
                    if (isNumber(element.length)) {
                        each(element, function (elem) {
                            addClass(elem, value);
                        });
                        return;
                    }

                    if (element.classList) {
                        element.classList.add(value);
                        return;
                    }

                    var className = trim(element.className);

                    if (!className) {
                        element.className = value;
                    } else if (className.indexOf(value) < 0) {
                        element.className = className + ' ' + value;
                    }
                }

                function removeClass(element, value) {
                    if (element == null) { element = []; }
                    if (isNumber(element.length)) {
                        each(element, function (elem) {
                            removeClass(elem, value);
                        });
                        return;
                    }

                    if (element.classList) {
                        element.classList.remove(value);
                        return;
                    }

                    if (element.className.indexOf(value) >= 0) {
                        element.className = element.className.replace(value, '');
                    }
                }

                function toggleClass(element, value, added) {
                    if (isNumber(element.length)) {
                        each(element, function (elem) {
                            toggleClass(elem, value, added);
                        });
                        return;
                    }

                    if (added) {
                        addClass(element, value);
                    } else {
                        removeClass(element, value);
                    }
                }

                function hyphenate(str) {
                    return str.replace(REGEXP_HYPHENATE, '$1-$2').toLowerCase();
                }

                function getData(element, name) {
                    if (isObject(element[name])) {
                        return element[name];
                    } else if (element.dataset) {
                        return element.dataset[name];
                    }

                    return element.getAttribute('data-' + hyphenate(name));
                }

                function setData(element, name, data) {
                    if (isObject(data)) {
                        element[name] = data;
                    } else if (element.dataset) {
                        element.dataset[name] = data;
                    } else {
                        element.setAttribute('data-' + hyphenate(name), data);
                    }
                }

                function removeData(element, name) {
                    if (isObject(element[name])) {
                        delete element[name];
                    } else if (element.dataset) {
                        delete element.dataset[name];
                    } else {
                        element.removeAttribute('data-' + hyphenate(name));
                    }
                }

                function removeListener(element, type, handler) {
                    var types = trim(type).split(REGEXP_SPACES);

                    if (types.length > 1) {
                        each(types, function (t) {
                            removeListener(element, t, handler);
                        });
                        return;
                    }

                    if (element.removeEventListener) {
                        element.removeEventListener(type, handler, false);
                    } else if (element.detachEvent) {
                        element.detachEvent('on' + type, handler);
                    }
                }

                function addListener(element, type, _handler, once) {
                    var types = trim(type).split(REGEXP_SPACES);
                    var originalHandler = _handler;

                    if (types.length > 1) {
                        each(types, function (t) {
                            addListener(element, t, _handler);
                        });
                        return;
                    }

                    if (once) {
                        _handler = function handler() {
                            for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
                                args[_key4] = arguments[_key4];
                            }

                            removeListener(element, type, _handler);

                            return originalHandler.apply(element, args);
                        };
                    }

                    if (element.addEventListener) {
                        element.addEventListener(type, _handler, false);
                    } else if (element.attachEvent) {
                        element.attachEvent('on${type}', _handler);
                    }
                }

                exports.addListener = addListener;
                function dispatchEvent(element, type, data) {
                    if (element.dispatchEvent) {
                        var event = void 0;

                        if (isFunction(Event) && isFunction(CustomEvent)) {
                            if (isUndefined(data)) {
                                event = new Event(type, {
                                    bubbles: true,
                                    cancelable: true
                                });
                            } else {
                                event = new CustomEvent(type, {
                                    detail: data,
                                    bubbles: true,
                                    cancelable: true
                                });
                            }
                        } else if (isUndefined(data)) {
                            event = document.createEvent('Event');
                            event.initEvent(type, true, true);
                        } else {
                            event = document.createEvent('CustomEvent');
                            event.initCustomEvent(type, true, true, data);
                        }

                        return element.dispatchEvent(event);
                    } else if (element.fireEvent) {
                        return element.fireEvent('on' + type);
                    }

                    return true;
                }

                function getEvent(event) {
                    var e = event || window.event;

                    if (!e.target) {
                        e.target = e.srcElement || document;
                    }

                    if (!isNumber(e.pageX) && isNumber(e.clientX)) {
                        var eventDoc = event.target.ownerDocument || document;
                        var doc = eventDoc.documentElement;
                        var body = eventDoc.body;

                        e.pageX = e.clientX + ((doc && doc.scrollLeft || body && body.scrollLeft || 0) - (doc && doc.clientLeft || body && body.clientLeft || 0));
                        e.pageY = e.clientY + ((doc && doc.scrollTop || body && body.scrollTop || 0) - (doc && doc.clientTop || body && body.clientTop || 0));
                    }

                    return e;
                }

                function getOffset(element) {
                    var doc = document.documentElement;
                    var box = element.getBoundingClientRect();

                    return {
                        left: box.left + ((window.scrollX || doc && doc.scrollLeft || 0) - (doc && doc.clientLeft || 0)),
                        top: box.top + ((window.scrollY || doc && doc.scrollTop || 0) - (doc && doc.clientTop || 0))
                    };
                }

                function getTouchesCenter(touches) {
                    var length = touches.length;
                    var pageX = 0;
                    var pageY = 0;

                    if (length) {
                        each(touches, function (touch) {
                            pageX += touch.pageX;
                            pageY += touch.pageY;
                        });

                        pageX /= length;
                        pageY /= length;
                    }

                    return {
                        pageX: pageX,
                        pageY: pageY
                    };
                }

                function getByTag(element, tagName) {
                    return element.getElementsByTagName(tagName);
                }

                function getByClass(element, className) {
                    return element.getElementsByClassName ? element.getElementsByClassName(className) : element.querySelectorAll('.' + className);
                }

                function createElement(tagName) {
                    return document.createElement(tagName);
                }

                function appendChild(element, elem) {
                    element.appendChild(elem);
                }

                function removeChild(element) {
                    if (element.parentNode) {
                        element.parentNode.removeChild(element);
                    }
                }

                function empty(element) {
                    while (element.firstChild) {
                        element.removeChild(element.firstChild);
                    }
                }

                function isCrossOriginURL(url) {
                    var parts = url.match(REGEXP_ORIGINS);

                    return parts && (parts[1] !== location.protocol || parts[2] !== location.hostname || parts[3] !== location.port);
                }

                function addTimestamp(url) {
                    var timestamp = 'timestamp=' + new Date().getTime();

                    return url + (url.indexOf('?') === -1 ? '?' : '&') + timestamp;
                }

                function getImageSize(image, callback) {
                    if (image.naturalWidth && !IS_SAFARI_OR_UIWEBVIEW) {
                        callback(image.naturalWidth, image.naturalHeight);
                        return;
                    }

                    var newImage = createElement('img');

                    newImage.onload = function load() {
                        callback(this.width, this.height);
                    };

                    newImage.src = image.src;
                }

                function getTransform(data) {
                    var transforms = [];
                    var rotate = data.rotate;
                    var scaleX = data.scaleX;
                    var scaleY = data.scaleY;
                    if (isNumber(rotate) && rotate !== 0) {
                        transforms.push('rotate(' + rotate + 'deg)');
                    }

                    if (isNumber(scaleX) && scaleX !== 1) {
                        transforms.push('scaleX(' + scaleX + ')');
                    }

                    if (isNumber(scaleY) && scaleY !== 1) {
                        transforms.push('scaleY(' + scaleY + ')');
                    }

                    return transforms.length ? transforms.join(' ') : 'none';
                }

                function getRotatedSizes(data, reversed) {
                    var deg = Math.abs(data.degree) % 180;
                    var arc = (deg > 90 ? 180 - deg : deg) * Math.PI / 180;
                    var sinArc = Math.sin(arc);
                    var cosArc = Math.cos(arc);
                    var width = data.width;
                    var height = data.height;
                    var aspectRatio = data.aspectRatio;
                    var newWidth = void 0;
                    var newHeight = void 0;

                    if (!reversed) {
                        newWidth = width * cosArc + height * sinArc;
                        newHeight = width * sinArc + height * cosArc;
                    } else {
                        newWidth = width / (cosArc + sinArc / aspectRatio);
                        newHeight = newWidth / aspectRatio;
                    }

                    return {
                        width: newWidth,
                        height: newHeight
                    };
                }

                function getSourceCanvas(image, data) {
                    var canvas = createElement('canvas');
                    var context = canvas.getContext('2d');
                    var dstX = 0;
                    var dstY = 0;
                    var dstWidth = data.naturalWidth;
                    var dstHeight = data.naturalHeight;
                    var rotate = data.rotate;
                    var scaleX = data.scaleX;
                    var scaleY = data.scaleY;
                    var scalable = isNumber(scaleX) && isNumber(scaleY) && (scaleX !== 1 || scaleY !== 1);
                    var rotatable = isNumber(rotate) && rotate !== 0;
                    var advanced = rotatable || scalable;
                    var canvasWidth = dstWidth * Math.abs(scaleX);
                    var canvasHeight = dstHeight * Math.abs(scaleY);
                    var translateX = void 0;
                    var translateY = void 0;
                    var rotated = void 0;

                    if (scalable) {
                        translateX = canvasWidth / 2;
                        translateY = canvasHeight / 2;
                    }

                    if (rotatable) {
                        rotated = getRotatedSizes({
                            width: canvasWidth,
                            height: canvasHeight,
                            degree: rotate
                        });

                        canvasWidth = rotated.width;
                        canvasHeight = rotated.height;
                        translateX = canvasWidth / 2;
                        translateY = canvasHeight / 2;
                    }

                    canvas.width = canvasWidth;
                    canvas.height = canvasHeight;

                    if (advanced) {
                        dstX = -dstWidth / 2;
                        dstY = -dstHeight / 2;

                        context.save();
                        context.translate(translateX, translateY);
                    }

                    if (rotatable) {
                        context.rotate(rotate * Math.PI / 180);
                    }

                    if (scalable) {
                        context.scale(scaleX, scaleY);
                    }

                    context.drawImage(image, Math.floor(dstX), Math.floor(dstY), Math.floor(dstWidth), Math.floor(dstHeight));

                    if (advanced) {
                        context.restore();
                    }

                    return canvas;
                }

                function getStringFromCharCode(dataView, start, length) {
                    var str = '';
                    var i = start;

                    for (length += start; i < length; i++) {
                        str += fromCharCode(dataView.getUint8(i));
                    }

                    return str;
                }

                function getOrientation(arrayBuffer) {
                    var dataView = new DataView(arrayBuffer);
                    var length = dataView.byteLength;
                    var orientation = void 0;
                    var exifIDCode = void 0;
                    var tiffOffset = void 0;
                    var firstIFDOffset = void 0;
                    var littleEndian = void 0;
                    var endianness = void 0;
                    var app1Start = void 0;
                    var ifdStart = void 0;
                    var offset = void 0;
                    var i = void 0;

                    if (dataView.getUint8(0) === 0xFF && dataView.getUint8(1) === 0xD8) {
                        offset = 2;

                        while (offset < length) {
                            if (dataView.getUint8(offset) === 0xFF && dataView.getUint8(offset + 1) === 0xE1) {
                                app1Start = offset;
                                break;
                            }

                            offset++;
                        }
                    }

                    if (app1Start) {
                        exifIDCode = app1Start + 4;
                        tiffOffset = app1Start + 10;

                        if (getStringFromCharCode(dataView, exifIDCode, 4) === 'Exif') {
                            endianness = dataView.getUint16(tiffOffset);
                            littleEndian = endianness === 0x4949;

                            if (littleEndian || endianness === 0x4D4D) {
                                if (dataView.getUint16(tiffOffset + 2, littleEndian) === 0x002A) {
                                    firstIFDOffset = dataView.getUint32(tiffOffset + 4, littleEndian);

                                    if (firstIFDOffset >= 0x00000008) {
                                        ifdStart = tiffOffset + firstIFDOffset;
                                    }
                                }
                            }
                        }
                    }

                    if (ifdStart) {
                        length = dataView.getUint16(ifdStart, littleEndian);

                        for (i = 0; i < length; i++) {
                            offset = ifdStart + i * 12 + 2;

                            if (dataView.getUint16(offset, littleEndian) === 0x0112) {
                                offset += 8;

                                orientation = dataView.getUint16(offset, littleEndian);

                                if (IS_SAFARI_OR_UIWEBVIEW) {
                                    dataView.setUint16(offset, 1, littleEndian);
                                }

                                break;
                            }
                        }
                    }

                    return orientation;
                }

                function dataURLToArrayBuffer(dataURL) {
                    var base64 = dataURL.replace(REGEXP_DATA_URL_HEAD, '');
                    var binary = atob(base64);
                    var length = binary.length;
                    var arrayBuffer = new ArrayBuffer(length);
                    var dataView = new Uint8Array(arrayBuffer);
                    var i = void 0;

                    for (i = 0; i < length; i++) {
                        dataView[i] = binary.charCodeAt(i);
                    }

                    return arrayBuffer;
                }

                function arrayBufferToDataURL(arrayBuffer) {
                    var dataView = new Uint8Array(arrayBuffer);
                    var length = dataView.length;
                    var base64 = '';
                    var i = void 0;

                    for (i = 0; i < length; i++) {
                        base64 += fromCharCode(dataView[i]);
                    }

                    return 'data:image/jpeg;base64,' + btoa(base64);
                }
            },
            function (module, exports, __webpack_require__) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });

                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                var DATA_PREVIEW = 'preview';

                exports.default = {
                    initPreview: function initPreview() {
                        var self = this;
                        var preview = self.options.preview;
                        var image = $.createElement('img');
                        var crossOrigin = self.crossOrigin;
                        var url = crossOrigin ? self.crossOriginUrl : self.url;

                        if (crossOrigin) {
                            image.crossOrigin = crossOrigin;
                        }

                        image.src = url;
                        $.appendChild(self.viewBox, image);
                        self.image2 = image;

                        if (!preview) {
                            return;
                        }

                        var previews = document.querySelectorAll(preview);

                        self.previews = previews;

                        $.each(previews, function (element) {
                            var img = $.createElement('img');

                            $.setData(element, DATA_PREVIEW, {
                                width: element.offsetWidth,
                                height: element.offsetHeight,
                                html: element.innerHTML
                            });

                            if (crossOrigin) {
                                img.crossOrigin = crossOrigin;
                            }

                            img.src = url;

                            img.style.cssText = 'display:block;' + 'width:100%;' + 'height:auto;' + 'min-width:0!important;' + 'min-height:0!important;' + 'max-width:none!important;' + 'max-height:none!important;' + 'image-orientation:0deg!important;"';

                            $.empty(element);
                            $.appendChild(element, img);
                        });
                    },
                    resetPreview: function resetPreview() {
                        $.each(this.previews, function (element) {
                            var data = $.getData(element, DATA_PREVIEW);

                            $.setStyle(element, {
                                width: data.width,
                                height: data.height
                            });

                            element.innerHTML = data.html;
                            $.removeData(element, DATA_PREVIEW);
                        });
                    },
                    preview: function preview() {
                        var self = this;
                        var imageData = self.imageData;
                        var canvasData = self.canvasData;
                        if (canvasData == null) { canvasData = []; }
                        var cropBoxData = self.cropBoxData;
                        if (cropBoxData == null) { cropBoxData = []; }
                        var cropBoxWidth = cropBoxData.width;
                        var cropBoxHeight = cropBoxData.height;
                        var width = imageData.width;
                        var height = imageData.height;
                        var left = cropBoxData.left - canvasData.left - imageData.left;
                        var top = cropBoxData.top - canvasData.top - imageData.top;
                        var transform = $.getTransform(imageData);
                        var transforms = {
                            WebkitTransform: transform,
                            msTransform: transform,
                            transform: transform
                        };

                        if (!self.cropped || self.disabled) {
                            return;
                        }

                        $.setStyle(self.image2, $.extend({
                            width: width,
                            height: height,
                            marginLeft: -left,
                            marginTop: -top
                        }, transforms));

                        $.each(self.previews, function (element) {
                            var data = $.getData(element, DATA_PREVIEW);
                            var originalWidth = data.width;
                            var originalHeight = data.height;
                            var newWidth = originalWidth;
                            var newHeight = originalHeight;
                            var ratio = 1;

                            if (cropBoxWidth) {
                                ratio = originalWidth / cropBoxWidth;
                                newHeight = cropBoxHeight * ratio;
                            }

                            if (cropBoxHeight && newHeight > originalHeight) {
                                ratio = originalHeight / cropBoxHeight;
                                newWidth = cropBoxWidth * ratio;
                                newHeight = originalHeight;
                            }

                            $.setStyle(element, {
                                width: newWidth,
                                height: newHeight
                            });

                            $.setStyle($.getByTag(element, 'img')[0], $.extend({
                                width: width * ratio,
                                height: height * ratio,
                                marginLeft: -left * ratio,
                                marginTop: -top * ratio
                            }, transforms));
                        });
                    }
                };

            },
            function (module, exports, __webpack_require__) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });

                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                var EVENT_MOUSE_DOWN = 'mousedown touchstart pointerdown MSPointerDown';
                var EVENT_MOUSE_MOVE = 'mousemove touchmove pointermove MSPointerMove';
                var EVENT_MOUSE_UP = 'mouseup touchend touchcancel pointerup pointercancel' + ' MSPointerUp MSPointerCancel';
                var EVENT_WHEEL = 'wheel mousewheel DOMMouseScroll';
                var EVENT_DBLCLICK = 'dblclick';
                var EVENT_RESIZE = 'resize';
                var EVENT_CROP_START = 'cropstart';
                var EVENT_CROP_MOVE = 'cropmove';
                var EVENT_CROP_END = 'cropend';
                var EVENT_CROP = 'crop';
                var EVENT_ZOOM = 'zoom';

                exports.default = {
                    bind: function bind() {
                        var self = this;
                        var options = self.options;
                        var element = self.element;
                        var cropper = self.cropper;

                        if ($.isFunction(options.cropstart)) {
                            $.addListener(element, EVENT_CROP_START, options.cropstart);
                        }

                        if ($.isFunction(options.cropmove)) {
                            $.addListener(element, EVENT_CROP_MOVE, options.cropmove);
                        }

                        if ($.isFunction(options.cropend)) {
                            $.addListener(element, EVENT_CROP_END, options.cropend);
                        }

                        if ($.isFunction(options.crop)) {
                            $.addListener(element, EVENT_CROP, options.crop);
                        }

                        if ($.isFunction(options.zoom)) {
                            $.addListener(element, EVENT_ZOOM, options.zoom);
                        }

                        $.addListener(cropper, EVENT_MOUSE_DOWN, self.onCropStart = $.proxy(self.cropStart, self));

                        if (options.zoomable && options.zoomOnWheel) {
                            $.addListener(cropper, EVENT_WHEEL, self.onWheel = $.proxy(self.wheel, self));
                        }

                        if (options.toggleDragModeOnDblclick) {
                            $.addListener(cropper, EVENT_DBLCLICK, self.onDblclick = $.proxy(self.dblclick, self));
                        }

                        $.addListener(document, EVENT_MOUSE_MOVE, self.onCropMove = $.proxy(self.cropMove, self));
                        $.addListener(document, EVENT_MOUSE_UP, self.onCropEnd = $.proxy(self.cropEnd, self));

                        if (options.responsive) {
                            $.addListener(window, EVENT_RESIZE, self.onResize = $.proxy(self.resize, self));
                        }
                    },
                    unbind: function unbind() {
                        var self = this;
                        var options = self.options;
                        var element = self.element;
                        var cropper = self.cropper;

                        if ($.isFunction(options.cropstart)) {
                            $.removeListener(element, EVENT_CROP_START, options.cropstart);
                        }

                        if ($.isFunction(options.cropmove)) {
                            $.removeListener(element, EVENT_CROP_MOVE, options.cropmove);
                        }

                        if ($.isFunction(options.cropend)) {
                            $.removeListener(element, EVENT_CROP_END, options.cropend);
                        }

                        if ($.isFunction(options.crop)) {
                            $.removeListener(element, EVENT_CROP, options.crop);
                        }

                        if ($.isFunction(options.zoom)) {
                            $.removeListener(element, EVENT_ZOOM, options.zoom);
                        }

                        $.removeListener(cropper, EVENT_MOUSE_DOWN, self.onCropStart);

                        if (options.zoomable && options.zoomOnWheel) {
                            $.removeListener(cropper, EVENT_WHEEL, self.onWheel);
                        }

                        if (options.toggleDragModeOnDblclick) {
                            $.removeListener(cropper, EVENT_DBLCLICK, self.onDblclick);
                        }

                        $.removeListener(document, EVENT_MOUSE_MOVE, self.onCropMove);
                        $.removeListener(document, EVENT_MOUSE_UP, self.onCropEnd);

                        if (options.responsive) {
                            $.removeListener(window, EVENT_RESIZE, self.onResize);
                        }
                    }
                };

            },
            function (module, exports, __webpack_require__) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });
                exports.REGEXP_ACTIONS = undefined;

                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                var REGEXP_ACTIONS = exports.REGEXP_ACTIONS = /^(e|w|s|n|se|sw|ne|nw|all|crop|move|zoom)$/;

                exports.default = {
                    resize: function resize() {
                        var self = this;

                        var restore = self.options.restore;
                        var container = self.container;
                        var containerData = self.containerData;

                        if (self.disabled || !containerData) {
                            return;
                        }

                        var ratio = container.offsetWidth / containerData.width;
                        var canvasData = void 0;
                        var cropBoxData = void 0;

                        if (ratio !== 1 || container.offsetHeight !== containerData.height) {
                            if (restore) {
                                canvasData = self.getCanvasData();
                                cropBoxData = self.getCropBoxData();
                            }

                            self.render();

                            if (restore) {
                                self.setCanvasData($.each(canvasData, function (n, i) {
                                    canvasData[i] = n * ratio;
                                }));
                                self.setCropBoxData($.each(cropBoxData, function (n, i) {
                                    cropBoxData[i] = n * ratio;
                                }));
                            }
                        }
                    },
                    dblclick: function dblclick() {
                        var self = this;

                        if (self.disabled) {
                            return;
                        }

                        self.setDragMode($.hasClass(self.dragBox, 'cropper-crop') ? 'move' : 'crop');
                    },
                    wheel: function wheel(event) {
                        var self = this;
                        var e = $.getEvent(event);
                        var ratio = Number(self.options.wheelZoomRatio) || 0.1;
                        var delta = 1;

                        if (self.disabled) {
                            return;
                        }

                        e.preventDefault();

                        if (self.wheeling) {
                            return;
                        }

                        self.wheeling = true;

                        setTimeout(function () {
                            self.wheeling = false;
                        }, 50);

                        if (e.deltaY) {
                            delta = e.deltaY > 0 ? 1 : -1;
                        } else if (e.wheelDelta) {
                            delta = -e.wheelDelta / 120;
                        } else if (e.detail) {
                            delta = e.detail > 0 ? 1 : -1;
                        }

                        self.zoom(-delta * ratio, e);
                    },
                    cropStart: function cropStart(event) {
                        var self = this;

                        var options = self.options;
                        var e = $.getEvent(event);
                        var touches = e.touches;
                        var touchesLength = void 0;
                        var touch = void 0;
                        var action = void 0;

                        if (self.disabled) {
                            return;
                        }

                        if (touches) {
                            touchesLength = touches.length;

                            if (touchesLength > 1) {
                                if (options.zoomable && options.zoomOnTouch && touchesLength === 2) {
                                    touch = touches[1];
                                    self.startX2 = touch.pageX;
                                    self.startY2 = touch.pageY;
                                    action = 'zoom';
                                } else {
                                    return;
                                }
                            }

                            touch = touches[0];
                        }

                        action = action || $.getData(e.target, 'action');

                        if (REGEXP_ACTIONS.test(action)) {
                            if ($.dispatchEvent(self.element, 'cropstart', {
                                originalEvent: e,
                                action: action
                            }) === false) {
                                return;
                            }

                            e.preventDefault();

                            self.action = action;
                            self.cropping = false;

                            self.startX = touch ? touch.pageX : e.pageX;
                            self.startY = touch ? touch.pageY : e.pageY;

                            if (action === 'crop') {
                                self.cropping = true;
                                $.addClass(self.dragBox, 'cropper-modal');
                            }
                        }
                    },
                    cropMove: function cropMove(event) {
                        var self = this;
                        var options = self.options;
                        var e = $.getEvent(event);
                        var touches = e.touches;
                        var action = self.action;
                        var touchesLength = void 0;
                        var touch = void 0;

                        if (self.disabled) {
                            return;
                        }

                        if (touches) {
                            touchesLength = touches.length;

                            if (touchesLength > 1) {
                                if (options.zoomable && options.zoomOnTouch && touchesLength === 2) {
                                    touch = touches[1];
                                    self.endX2 = touch.pageX;
                                    self.endY2 = touch.pageY;
                                } else {
                                    return;
                                }
                            }

                            touch = touches[0];
                        }

                        if (action) {
                            if ($.dispatchEvent(self.element, 'cropmove', {
                                originalEvent: e,
                                action: action
                            }) === false) {
                                return;
                            }

                            e.preventDefault();

                            self.endX = touch ? touch.pageX : e.pageX;
                            self.endY = touch ? touch.pageY : e.pageY;

                            self.change(e.shiftKey, action === 'zoom' ? e : null);
                        }
                    },
                    cropEnd: function cropEnd(event) {
                        var self = this;
                        var options = self.options;
                        var e = $.getEvent(event);
                        var action = self.action;

                        if (self.disabled) {
                            return;
                        }

                        if (action) {
                            e.preventDefault();

                            if (self.cropping) {
                                self.cropping = false;
                                $.toggleClass(self.dragBox, 'cropper-modal', self.cropped && options.modal);
                            }

                            self.action = '';

                            $.dispatchEvent(self.element, 'cropend', {
                                originalEvent: e,
                                action: action
                            });
                        }
                    }
                };

            },
            function (module, exports, __webpack_require__) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });

                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                var ACTION_EAST = 'e';
                var ACTION_WEST = 'w';
                var ACTION_SOUTH = 's';
                var ACTION_NORTH = 'n';
                var ACTION_SOUTH_EAST = 'se';
                var ACTION_SOUTH_WEST = 'sw';
                var ACTION_NORTH_EAST = 'ne';
                var ACTION_NORTH_WEST = 'nw';

                exports.default = {
                    change: function change(shiftKey, originalEvent) {
                        var self = this;
                        var options = self.options;
                        var containerData = self.containerData;
                        var canvasData = self.canvasData;
                        var cropBoxData = self.cropBoxData;
                        var aspectRatio = options.aspectRatio;
                        var action = self.action;
                        var width = cropBoxData.width;
                        var height = cropBoxData.height;
                        var left = cropBoxData.left;
                        var top = cropBoxData.top;
                        var right = left + width;
                        var bottom = top + height;
                        var minLeft = 0;
                        var minTop = 0;
                        var maxWidth = containerData.width;
                        var maxHeight = containerData.height;
                        var renderable = true;
                        var offset = void 0;

                        if (!aspectRatio && shiftKey) {
                            aspectRatio = width && height ? width / height : 1;
                        }

                        if (self.limited) {
                            minLeft = cropBoxData.minLeft;
                            minTop = cropBoxData.minTop;
                            maxWidth = minLeft + Math.min(containerData.width, canvasData.left + canvasData.width);
                            maxHeight = minTop + Math.min(containerData.height, canvasData.top + canvasData.height);
                        }

                        var range = {
                            x: self.endX - self.startX,
                            y: self.endY - self.startY
                        };

                        if (aspectRatio) {
                            range.X = range.y * aspectRatio;
                            range.Y = range.x / aspectRatio;
                        }

                        switch (action) {
                            case 'all':
                                left += range.x;
                                top += range.y;
                                break;

                            case ACTION_EAST:
                                if (range.x >= 0 && (right >= maxWidth || aspectRatio && (top <= minTop || bottom >= maxHeight))) {
                                    renderable = false;
                                    break;
                                }

                                width += range.x;

                                if (aspectRatio) {
                                    height = width / aspectRatio;
                                    top -= range.Y / 2;
                                }

                                if (width < 0) {
                                    action = ACTION_WEST;
                                    width = 0;
                                }

                                break;

                            case ACTION_NORTH:
                                if (range.y <= 0 && (top <= minTop || aspectRatio && (left <= minLeft || right >= maxWidth))) {
                                    renderable = false;
                                    break;
                                }

                                height -= range.y;
                                top += range.y;

                                if (aspectRatio) {
                                    width = height * aspectRatio;
                                    left += range.X / 2;
                                }

                                if (height < 0) {
                                    action = ACTION_SOUTH;
                                    height = 0;
                                }

                                break;

                            case ACTION_WEST:
                                if (range.x <= 0 && (left <= minLeft || aspectRatio && (top <= minTop || bottom >= maxHeight))) {
                                    renderable = false;
                                    break;
                                }

                                width -= range.x;
                                left += range.x;

                                if (aspectRatio) {
                                    height = width / aspectRatio;
                                    top += range.Y / 2;
                                }

                                if (width < 0) {
                                    action = ACTION_EAST;
                                    width = 0;
                                }

                                break;

                            case ACTION_SOUTH:
                                if (range.y >= 0 && (bottom >= maxHeight || aspectRatio && (left <= minLeft || right >= maxWidth))) {
                                    renderable = false;
                                    break;
                                }

                                height += range.y;

                                if (aspectRatio) {
                                    width = height * aspectRatio;
                                    left -= range.X / 2;
                                }

                                if (height < 0) {
                                    action = ACTION_NORTH;
                                    height = 0;
                                }

                                break;

                            case ACTION_NORTH_EAST:
                                if (aspectRatio) {
                                    if (range.y <= 0 && (top <= minTop || right >= maxWidth)) {
                                        renderable = false;
                                        break;
                                    }

                                    height -= range.y;
                                    top += range.y;
                                    width = height * aspectRatio;
                                } else {
                                    if (range.x >= 0) {
                                        if (right < maxWidth) {
                                            width += range.x;
                                        } else if (range.y <= 0 && top <= minTop) {
                                            renderable = false;
                                        }
                                    } else {
                                        width += range.x;
                                    }

                                    if (range.y <= 0) {
                                        if (top > minTop) {
                                            height -= range.y;
                                            top += range.y;
                                        }
                                    } else {
                                        height -= range.y;
                                        top += range.y;
                                    }
                                }

                                if (width < 0 && height < 0) {
                                    action = ACTION_SOUTH_WEST;
                                    height = 0;
                                    width = 0;
                                } else if (width < 0) {
                                    action = ACTION_NORTH_WEST;
                                    width = 0;
                                } else if (height < 0) {
                                    action = ACTION_SOUTH_EAST;
                                    height = 0;
                                }

                                break;

                            case ACTION_NORTH_WEST:
                                if (aspectRatio) {
                                    if (range.y <= 0 && (top <= minTop || left <= minLeft)) {
                                        renderable = false;
                                        break;
                                    }

                                    height -= range.y;
                                    top += range.y;
                                    width = height * aspectRatio;
                                    left += range.X;
                                } else {
                                    if (range.x <= 0) {
                                        if (left > minLeft) {
                                            width -= range.x;
                                            left += range.x;
                                        } else if (range.y <= 0 && top <= minTop) {
                                            renderable = false;
                                        }
                                    } else {
                                        width -= range.x;
                                        left += range.x;
                                    }

                                    if (range.y <= 0) {
                                        if (top > minTop) {
                                            height -= range.y;
                                            top += range.y;
                                        }
                                    } else {
                                        height -= range.y;
                                        top += range.y;
                                    }
                                }

                                if (width < 0 && height < 0) {
                                    action = ACTION_SOUTH_EAST;
                                    height = 0;
                                    width = 0;
                                } else if (width < 0) {
                                    action = ACTION_NORTH_EAST;
                                    width = 0;
                                } else if (height < 0) {
                                    action = ACTION_SOUTH_WEST;
                                    height = 0;
                                }

                                break;

                            case ACTION_SOUTH_WEST:
                                if (aspectRatio) {
                                    if (range.x <= 0 && (left <= minLeft || bottom >= maxHeight)) {
                                        renderable = false;
                                        break;
                                    }

                                    width -= range.x;
                                    left += range.x;
                                    height = width / aspectRatio;
                                } else {
                                    if (range.x <= 0) {
                                        if (left > minLeft) {
                                            width -= range.x;
                                            left += range.x;
                                        } else if (range.y >= 0 && bottom >= maxHeight) {
                                            renderable = false;
                                        }
                                    } else {
                                        width -= range.x;
                                        left += range.x;
                                    }

                                    if (range.y >= 0) {
                                        if (bottom < maxHeight) {
                                            height += range.y;
                                        }
                                    } else {
                                        height += range.y;
                                    }
                                }

                                if (width < 0 && height < 0) {
                                    action = ACTION_NORTH_EAST;
                                    height = 0;
                                    width = 0;
                                } else if (width < 0) {
                                    action = ACTION_SOUTH_EAST;
                                    width = 0;
                                } else if (height < 0) {
                                    action = ACTION_NORTH_WEST;
                                    height = 0;
                                }

                                break;

                            case ACTION_SOUTH_EAST:
                                if (aspectRatio) {
                                    if (range.x >= 0 && (right >= maxWidth || bottom >= maxHeight)) {
                                        renderable = false;
                                        break;
                                    }

                                    width += range.x;
                                    height = width / aspectRatio;
                                } else {
                                    if (range.x >= 0) {
                                        if (right < maxWidth) {
                                            width += range.x;
                                        } else if (range.y >= 0 && bottom >= maxHeight) {
                                            renderable = false;
                                        }
                                    } else {
                                        width += range.x;
                                    }

                                    if (range.y >= 0) {
                                        if (bottom < maxHeight) {
                                            height += range.y;
                                        }
                                    } else {
                                        height += range.y;
                                    }
                                }

                                if (width < 0 && height < 0) {
                                    action = ACTION_NORTH_WEST;
                                    height = 0;
                                    width = 0;
                                } else if (width < 0) {
                                    action = ACTION_SOUTH_WEST;
                                    width = 0;
                                } else if (height < 0) {
                                    action = ACTION_NORTH_EAST;
                                    height = 0;
                                }

                                break;

                            case 'move':
                                self.move(range.x, range.y);
                                renderable = false;
                                break;

                            case 'zoom':
                                self.zoom(function (x1, y1, x2, y2) {
                                    var z1 = Math.sqrt(x1 * x1 + y1 * y1);
                                    var z2 = Math.sqrt(x2 * x2 + y2 * y2);

                                    return (z2 - z1) / z1;
                                }(Math.abs(self.startX - self.startX2), Math.abs(self.startY - self.startY2), Math.abs(self.endX - self.endX2), Math.abs(self.endY - self.endY2)), originalEvent);
                                self.startX2 = self.endX2;
                                self.startY2 = self.endY2;
                                renderable = false;
                                break;

                            case 'crop':
                                if (!range.x || !range.y) {
                                    renderable = false;
                                    break;
                                }

                                offset = $.getOffset(self.cropper);
                                left = self.startX - offset.left;
                                top = self.startY - offset.top;
                                width = cropBoxData.minWidth;
                                height = cropBoxData.minHeight;

                                if (range.x > 0) {
                                    action = range.y > 0 ? ACTION_SOUTH_EAST : ACTION_NORTH_EAST;
                                } else if (range.x < 0) {
                                    left -= width;
                                    action = range.y > 0 ? ACTION_SOUTH_WEST : ACTION_NORTH_WEST;
                                }

                                if (range.y < 0) {
                                    top -= height;
                                }

                                if (!self.cropped) {
                                    $.removeClass(self.cropBox, 'cropper-hidden');
                                    self.cropped = true;

                                    if (self.limited) {
                                        self.limitCropBox(true, true);
                                    }
                                }

                                break;

                        }

                        if (renderable) {
                            cropBoxData.width = width;
                            cropBoxData.height = height;
                            cropBoxData.left = left;
                            cropBoxData.top = top;
                            self.action = action;

                            self.renderCropBox();
                        }

                        self.startX = self.endX;
                        self.startY = self.endY;
                    }
                };

            },
            function (module, exports, __webpack_require__) {

                'use strict';

                Object.defineProperty(exports, "__esModule", {
                    value: true
                });

                var _utilities = __webpack_require__(4);

                var $ = _interopRequireWildcard(_utilities);

                function _interopRequireWildcard(obj) {
                    if (obj && obj.__esModule) {
                        return obj;
                    } else {
                        var newObj = {};
                        if (obj != null) {
                            for (var key in obj) {
                                if (Object.prototype.hasOwnProperty.call(obj, key))
                                    newObj[key] = obj[key];
                            }
                        }
                        newObj.default = obj;
                        return newObj;
                    }
                }

                function _toConsumableArray(arr) {
                    if (Array.isArray(arr)) {
                        for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {
                            arr2[i] = arr[i];
                        }
                        return arr2;
                    } else {
                        return Array.from(arr);
                    }
                }

                exports.default = {
                    crop: function crop() {
                        var self = this;

                        if (self.ready && !self.disabled) {
                            if (!self.cropped) {
                                self.cropped = true;
                                self.limitCropBox(true, true);

                                if (self.options.modal) {
                                    $.addClass(self.dragBox, 'cropper-modal');
                                }

                                $.removeClass(self.cropBox, 'cropper-hidden');
                            }

                            self.setCropBoxData(self.initialCropBoxData);
                        }

                        return self;
                    },
                    reset: function reset() {
                        var self = this;

                        if (self.ready && !self.disabled) {
                            self.imageData = $.extend({}, self.initialImageData);
                            self.canvasData = $.extend({}, self.initialCanvasData);
                            self.cropBoxData = $.extend({}, self.initialCropBoxData);

                            self.renderCanvas();

                            if (self.cropped) {
                                self.renderCropBox();
                            }
                        }

                        return self;
                    },
                    clear: function clear() {
                        var self = this;

                        if (self.cropped && !self.disabled) {
                            $.extend(self.cropBoxData, {
                                left: 0,
                                top: 0,
                                width: 0,
                                height: 0
                            });

                            self.cropped = false;
                            self.renderCropBox();

                            self.limitCanvas();

                            self.renderCanvas();

                            $.removeClass(self.dragBox, 'cropper-modal');
                            $.addClass(self.cropBox, 'cropper-hidden');
                        }

                        return self;
                    },
                    replace: function replace(url, onlyColorChanged) {
                        var self = this;

                        if (!self.disabled && url) {
                            if (self.isImg) {
                                self.element.src = url;
                            }

                            if (onlyColorChanged) {
                                self.url = url;
                                self.image.src = url;

                                if (self.ready) {
                                    self.image2.src = url;

                                    $.each(self.previews, function (element) {
                                        $.getByTag(element, 'img')[0].src = url;
                                    });
                                }
                            } else {
                                if (self.isImg) {
                                    self.replaced = true;
                                }

                                self.options.data = null;
                                self.load(url);
                            }
                        }

                        return self;
                    },
                    enable: function enable() {
                        var self = this;

                        if (self.ready) {
                            self.disabled = false;
                            $.removeClass(self.cropper, 'cropper-disabled');
                        }

                        return self;
                    },
                    disable: function disable() {
                        var self = this;

                        if (self.ready) {
                            self.disabled = true;
                            $.addClass(self.cropper, 'cropper-disabled');
                        }

                        return self;
                    },
                    destroy: function destroy() {
                        var self = this;
                        var element = self.element;
                        var image = self.image;

                        if (self.loaded) {
                            if (self.isImg && self.replaced) {
                                element.src = self.originalUrl;
                            }

                            self.unbuild();
                            $.removeClass(element, 'cropper-hidden');
                        } else if (self.isImg) {
                            $.removeListener(element, 'load', self.start);
                        } else if (image) {
                            $.removeChild(image);
                        }

                        $.removeData(element, 'cropper');

                        return self;
                    },
                    move: function move(offsetX, offsetY) {
                        var self = this;
                        var canvasData = self.canvasData;

                        return self.moveTo($.isUndefined(offsetX) ? offsetX : canvasData.left + Number(offsetX), $.isUndefined(offsetY) ? offsetY : canvasData.top + Number(offsetY));
                    },
                    moveTo: function moveTo(x, y) {
                        var self = this;
                        var canvasData = self.canvasData;
                        var changed = false;

                        if ($.isUndefined(y)) {
                            y = x;
                        }

                        x = Number(x);
                        y = Number(y);

                        if (self.ready && !self.disabled && self.options.movable) {
                            if ($.isNumber(x)) {
                                canvasData.left = x;
                                changed = true;
                            }

                            if ($.isNumber(y)) {
                                canvasData.top = y;
                                changed = true;
                            }

                            if (changed) {
                                self.renderCanvas(true);
                            }
                        }

                        return self;
                    },
                    zoom: function zoom(ratio, _originalEvent) {
                        var self = this;
                        var canvasData = self.canvasData;

                        ratio = Number(ratio);

                        if (ratio < 0) {
                            ratio = 1 / (1 - ratio);
                        } else {
                            ratio = 1 + ratio;
                        }

                        return self.zoomTo(canvasData.width * ratio / canvasData.naturalWidth, _originalEvent);
                    },
                    zoomTo: function zoomTo(ratio, _originalEvent) {
                        var self = this;
                        var options = self.options;
                        var canvasData = self.canvasData;
                        var width = canvasData.width;
                        var height = canvasData.height;
                        var naturalWidth = canvasData.naturalWidth;
                        var naturalHeight = canvasData.naturalHeight;
                        var newWidth = void 0;
                        var newHeight = void 0;
                        var offset = void 0;
                        var center = void 0;

                        ratio = Number(ratio);

                        if (ratio >= 0 && self.ready && !self.disabled && options.zoomable) {
                            newWidth = naturalWidth * ratio;
                            newHeight = naturalHeight * ratio;

                            if ($.dispatchEvent(self.element, 'zoom', {
                                originalEvent: _originalEvent,
                                oldRatio: width / naturalWidth,
                                ratio: newWidth / naturalWidth
                            }) === false) {
                                return self;
                            }

                            if (_originalEvent) {
                                offset = $.getOffset(self.cropper);
                                center = _originalEvent.touches ? $.getTouchesCenter(_originalEvent.touches) : {
                                    pageX: _originalEvent.pageX,
                                    pageY: _originalEvent.pageY
                                };

                                canvasData.left -= (newWidth - width) * ((center.pageX - offset.left - canvasData.left) / width);
                                canvasData.top -= (newHeight - height) * ((center.pageY - offset.top - canvasData.top) / height);
                            } else {
                                canvasData.left -= (newWidth - width) / 2;
                                canvasData.top -= (newHeight - height) / 2;
                            }

                            canvasData.width = newWidth;
                            canvasData.height = newHeight;
                            self.renderCanvas(true);
                        }

                        return self;
                    },
                    rotate: function rotate(degree) {
                        var self = this;

                        return self.rotateTo((self.imageData.rotate || 0) + Number(degree));
                    },
                    rotateTo: function rotateTo(degree) {
                        var self = this;

                        degree = Number(degree);

                        if ($.isNumber(degree) && self.ready && !self.disabled && self.options.rotatable) {
                            self.imageData.rotate = degree % 360;
                            self.rotated = true;
                            self.renderCanvas(true);
                        }

                        return self;
                    },
                    scale: function scale(scaleX, scaleY) {
                        var self = this;
                        var imageData = self.imageData;
                        var changed = false;

                        if ($.isUndefined(scaleY)) {
                            scaleY = scaleX;
                        }

                        scaleX = Number(scaleX);
                        scaleY = Number(scaleY);

                        if (self.ready && !self.disabled && self.options.scalable) {
                            if ($.isNumber(scaleX)) {
                                imageData.scaleX = scaleX;
                                changed = true;
                            }

                            if ($.isNumber(scaleY)) {
                                imageData.scaleY = scaleY;
                                changed = true;
                            }

                            if (changed) {
                                self.renderImage(true);
                            }
                        }

                        return self;
                    },
                    scaleX: function scaleX(_scaleX) {
                        var self = this;
                        var scaleY = self.imageData.scaleY;

                        return self.scale(_scaleX, $.isNumber(scaleY) ? scaleY : 1);
                    },
                    scaleY: function scaleY(_scaleY) {
                        var self = this;
                        var scaleX = self.imageData.scaleX;

                        return self.scale($.isNumber(scaleX) ? scaleX : 1, _scaleY);
                    },
                    getData: function getData(rounded) {
                        var self = this;
                        var options = self.options;
                        var imageData = self.imageData;
                        var canvasData = self.canvasData;
                        var cropBoxData = self.cropBoxData;
                        var ratio = void 0;
                        var data = void 0;

                        if (self.ready && self.cropped) {
                            data = {
                                x: cropBoxData.left - canvasData.left,
                                y: cropBoxData.top - canvasData.top,
                                width: cropBoxData.width,
                                height: cropBoxData.height
                            };

                            ratio = imageData.width / imageData.naturalWidth;

                            $.each(data, function (n, i) {
                                n /= ratio;
                                data[i] = rounded ? Math.round(n) : n;
                            });
                        } else {
                            data = {
                                x: 0,
                                y: 0,
                                width: 0,
                                height: 0
                            };
                        }

                        if (options.rotatable) {
                            data.rotate = imageData.rotate || 0;
                        }

                        if (options.scalable) {
                            data.scaleX = imageData.scaleX || 1;
                            data.scaleY = imageData.scaleY || 1;
                        }

                        return data;
                    },
                    setData: function setData(data) {
                        var self = this;
                        var options = self.options;
                        var imageData = self.imageData;
                        var canvasData = self.canvasData;
                        var cropBoxData = {};
                        var rotated = void 0;
                        var scaled = void 0;
                        var ratio = void 0;

                        if ($.isFunction(data)) {
                            data = data.call(self.element);
                        }

                        if (self.ready && !self.disabled && $.isPlainObject(data)) {
                            if (options.rotatable) {
                                if ($.isNumber(data.rotate) && data.rotate !== imageData.rotate) {
                                    imageData.rotate = data.rotate;
                                    self.rotated = rotated = true;
                                }
                            }

                            if (options.scalable) {
                                if ($.isNumber(data.scaleX) && data.scaleX !== imageData.scaleX) {
                                    imageData.scaleX = data.scaleX;
                                    scaled = true;
                                }

                                if ($.isNumber(data.scaleY) && data.scaleY !== imageData.scaleY) {
                                    imageData.scaleY = data.scaleY;
                                    scaled = true;
                                }
                            }

                            if (rotated) {
                                self.renderCanvas();
                            } else if (scaled) {
                                self.renderImage();
                            }

                            ratio = imageData.width / imageData.naturalWidth;

                            if ($.isNumber(data.x)) {
                                cropBoxData.left = data.x * ratio + canvasData.left;
                            }

                            if ($.isNumber(data.y)) {
                                cropBoxData.top = data.y * ratio + canvasData.top;
                            }

                            if ($.isNumber(data.width)) {
                                cropBoxData.width = data.width * ratio;
                            }

                            if ($.isNumber(data.height)) {
                                cropBoxData.height = data.height * ratio;
                            }

                            self.setCropBoxData(cropBoxData);
                        }

                        return self;
                    },
                    getContainerData: function getContainerData() {
                        var self = this;

                        return self.ready ? self.containerData : {};
                    },
                    getImageData: function getImageData() {
                        var self = this;

                        return self.loaded ? self.imageData : {};
                    },
                    getCanvasData: function getCanvasData() {
                        var self = this;
                        var canvasData = self.canvasData;
                        var data = {};

                        if (self.ready) {
                            $.each(['left', 'top', 'width', 'height', 'naturalWidth', 'naturalHeight'], function (n) {
                                data[n] = canvasData[n];
                            });
                        }

                        return data;
                    },
                    setCanvasData: function setCanvasData(data) {
                        var self = this;
                        var canvasData = self.canvasData;
                        var aspectRatio = canvasData.aspectRatio;

                        if ($.isFunction(data)) {
                            data = data.call(self.element);
                        }

                        if (self.ready && !self.disabled && $.isPlainObject(data)) {
                            if ($.isNumber(data.left)) {
                                canvasData.left = data.left;
                            }

                            if ($.isNumber(data.top)) {
                                canvasData.top = data.top;
                            }

                            if ($.isNumber(data.width)) {
                                canvasData.width = data.width;
                                canvasData.height = data.width / aspectRatio;
                            } else if ($.isNumber(data.height)) {
                                canvasData.height = data.height;
                                canvasData.width = data.height * aspectRatio;
                            }

                            self.renderCanvas(true);
                        }

                        return self;
                    },
                    getCropBoxData: function getCropBoxData() {
                        var self = this;
                        var cropBoxData = self.cropBoxData;
                        var data = void 0;

                        if (self.ready && self.cropped) {
                            data = {
                                left: cropBoxData.left,
                                top: cropBoxData.top,
                                width: cropBoxData.width,
                                height: cropBoxData.height
                            };
                        }

                        return data || {};
                    },
                    setCropBoxData: function setCropBoxData(data) {
                        var self = this;
                        var cropBoxData = self.cropBoxData;
                        var aspectRatio = self.options.aspectRatio;
                        var widthChanged = void 0;
                        var heightChanged = void 0;

                        if ($.isFunction(data)) {
                            data = data.call(self.element);
                        }

                        if (self.ready && self.cropped && !self.disabled && $.isPlainObject(data)) {
                            if ($.isNumber(data.left)) {
                                cropBoxData.left = data.left;
                            }

                            if ($.isNumber(data.top)) {
                                cropBoxData.top = data.top;
                            }

                            if ($.isNumber(data.width)) {
                                widthChanged = true;
                                cropBoxData.width = data.width;
                            }

                            if ($.isNumber(data.height)) {
                                heightChanged = true;
                                cropBoxData.height = data.height;
                            }

                            if (aspectRatio) {
                                if (widthChanged) {
                                    cropBoxData.height = cropBoxData.width / aspectRatio;
                                } else if (heightChanged) {
                                    cropBoxData.width = cropBoxData.height * aspectRatio;
                                }
                            }

                            self.renderCropBox();
                        }

                        return self;
                    },
                    getCroppedCanvas: function getCroppedCanvas(options) {
                        var self = this;

                        if (!self.ready || !window.HTMLCanvasElement) {
                            return null;
                        }

                        if (!self.cropped) {
                            return $.getSourceCanvas(self.image, self.imageData);
                        }

                        if (!$.isPlainObject(options)) {
                            options = {};
                        }

                        var data = self.getData();
                        var originalWidth = data.width;
                        var originalHeight = data.height;
                        var aspectRatio = originalWidth / originalHeight;
                        var scaledWidth = void 0;
                        var scaledHeight = void 0;
                        var scaledRatio = void 0;

                        if ($.isPlainObject(options)) {
                            scaledWidth = options.width;
                            scaledHeight = options.height;

                            if (scaledWidth) {
                                scaledHeight = scaledWidth / aspectRatio;
                                scaledRatio = scaledWidth / originalWidth;
                            } else if (scaledHeight) {
                                scaledWidth = scaledHeight * aspectRatio;
                                scaledRatio = scaledHeight / originalHeight;
                            }
                        }

                        var canvasWidth = Math.floor(scaledWidth || originalWidth);
                        var canvasHeight = Math.floor(scaledHeight || originalHeight);

                        var canvas = $.createElement('canvas');
                        var context = canvas.getContext('2d');

                        canvas.width = canvasWidth;
                        canvas.height = canvasHeight;

                        if (options.fillColor) {
                            context.fillStyle = options.fillColor;
                            context.fillRect(0, 0, canvasWidth, canvasHeight);
                        }

                        var parameters = function () {
                            var source = $.getSourceCanvas(self.image, self.imageData);
                            var sourceWidth = source.width;
                            var sourceHeight = source.height;
                            var canvasData = self.canvasData;
                            var params = [source];

                            var srcX = data.x + canvasData.naturalWidth * (Math.abs(data.scaleX || 1) - 1) / 2;
                            var srcY = data.y + canvasData.naturalHeight * (Math.abs(data.scaleY || 1) - 1) / 2;
                            var srcWidth = void 0;
                            var srcHeight = void 0;

                            var dstX = void 0;
                            var dstY = void 0;
                            var dstWidth = void 0;
                            var dstHeight = void 0;

                            if (srcX <= -originalWidth || srcX > sourceWidth) {
                                srcX = srcWidth = dstX = dstWidth = 0;
                            } else if (srcX <= 0) {
                                dstX = -srcX;
                                srcX = 0;
                                srcWidth = dstWidth = Math.min(sourceWidth, originalWidth + srcX);
                            } else if (srcX <= sourceWidth) {
                                dstX = 0;
                                srcWidth = dstWidth = Math.min(originalWidth, sourceWidth - srcX);
                            }

                            if (srcWidth <= 0 || srcY <= -originalHeight || srcY > sourceHeight) {
                                srcY = srcHeight = dstY = dstHeight = 0;
                            } else if (srcY <= 0) {
                                dstY = -srcY;
                                srcY = 0;
                                srcHeight = dstHeight = Math.min(sourceHeight, originalHeight + srcY);
                            } else if (srcY <= sourceHeight) {
                                dstY = 0;
                                srcHeight = dstHeight = Math.min(originalHeight, sourceHeight - srcY);
                            }

                            params.push(Math.floor(srcX), Math.floor(srcY), Math.floor(srcWidth), Math.floor(srcHeight));
                            if (scaledRatio) {
                                dstX *= scaledRatio;
                                dstY *= scaledRatio;
                                dstWidth *= scaledRatio;
                                dstHeight *= scaledRatio;
                            }

                            if (dstWidth > 0 && dstHeight > 0) {
                                params.push(Math.floor(dstX), Math.floor(dstY), Math.floor(dstWidth), Math.floor(dstHeight));
                            }

                            return params;
                        }();

                        context.drawImage.apply(context, _toConsumableArray(parameters));

                        return canvas;
                    },
                    setAspectRatio: function setAspectRatio(aspectRatio) {
                        var self = this;
                        var options = self.options;

                        if (!self.disabled && !$.isUndefined(aspectRatio)) {
                            options.aspectRatio = Math.max(0, aspectRatio) || NaN;

                            if (self.ready) {
                                self.initCropBox();

                                if (self.cropped) {
                                    self.renderCropBox();
                                }
                            }
                        }

                        return self;
                    },
                    setDragMode: function setDragMode(mode) {
                        var self = this;
                        var options = self.options;
                        var dragBox = self.dragBox;
                        var face = self.face;
                        var croppable = void 0;
                        var movable = void 0;

                        if (self.loaded && !self.disabled) {
                            croppable = mode === 'crop';
                            movable = options.movable && mode === 'move';
                            mode = croppable || movable ? mode : 'none';

                            $.setData(dragBox, 'action', mode);
                            $.toggleClass(dragBox, 'cropper-crop', croppable);
                            $.toggleClass(dragBox, 'cropper-move', movable);

                            if (!options.cropBoxMovable) {
                                $.setData(face, 'action', mode);
                                $.toggleClass(face, 'cropper-crop', croppable);
                                $.toggleClass(face, 'cropper-move', movable);
                            }
                        }

                        return self;
                    }
                };
            }
        ]);
});

(function (c) {
    c.fn.bPopup = function (A, E) {
        function L() {
            a.contentContainer = c(a.contentContainer || b);
            switch (a.content) {
                case "iframe":
                    var d = c('<iframe class="b-iframe" ' + a.iframeAttr + "></iframe>");
                    d.appendTo(a.contentContainer);
                    t = b.outerHeight(!0);
                    u = b.outerWidth(!0);
                    B();
                    d.attr("src", a.loadUrl);
                    l(a.loadCallback);
                    break;
                case "image":
                    B();
                    c("<img />")
                        .load(function () {
                            l(a.loadCallback);
                            F(c(this));
                        })
                        .attr("src", a.loadUrl)
                        .hide()
                        .appendTo(a.contentContainer);
                    break;
                default:
                    B(),
                        c('<div class="b-ajax-wrapper"></div>')
                            .load(a.loadUrl, a.loadData, function (d, b, e) {
                                l(a.loadCallback, b);
                                F(c(this));
                            })
                            .hide()
                            .appendTo(a.contentContainer);
            }
        }
        function B() {
            a.modal &&
                c('<div class="b-modal ' + e + '"></div>')
                    .css({ backgroundColor: a.modalColor, position: "fixed", top: 0, right: 0, bottom: 0, left: 0, opacity: 0, zIndex: a.zIndex + v })
                    .appendTo(a.appendTo)
                    .fadeTo(a.speed, a.opacity);
            C();
            b.data("bPopup", a)
                .data("id", e)
                .css({
                    left: "slideIn" == a.transition || "slideBack" == a.transition ? ("slideBack" == a.transition ? f.scrollLeft() + w : -1 * (x + u)) : m(!((!a.follow[0] && n) || g)),
                    position: a.positionStyle || "absolute",
                    top: "slideDown" == a.transition || "slideUp" == a.transition ? ("slideUp" == a.transition ? f.scrollTop() + y : z + -1 * t) : p(!((!a.follow[1] && q) || g)),
                    "z-index": a.zIndex + v + 1,
                })
                .each(function () {
                    a.appending && c(this).appendTo(a.appendTo);
                });
            G(!0);
        }
        function r() {
            a.modal &&
                c(".b-modal." + b.data("id")).fadeTo(a.speed, 0, function () {
                    c(this).remove();
                });
            a.scrollBar || c("html").css("overflow", "auto");
            c(".b-modal." + e).unbind("click");
            f.unbind("keydown." + e);
            k.unbind("." + e).data("bPopup", 0 < k.data("bPopup") - 1 ? k.data("bPopup") - 1 : null);
            b.undelegate(".bClose, ." + a.closeClass, "click." + e, r).data("bPopup", null);
            clearTimeout(H);
            G();
            return !1;
        }
        function I(d) {
            y = k.height();
            w = k.width();
            h = D();
            if (h.x || h.y)
                clearTimeout(J),
                    (J = setTimeout(function () {
                        C();
                        d = d || a.followSpeed;
                        var e = {};
                        h.x && (e.left = a.follow[0] ? m(!0) : "auto");
                        h.y && (e.top = a.follow[1] ? p(!0) : "auto");
                        b.dequeue().each(function () {
                            g ? c(this).css({ left: x, top: z }) : c(this).animate(e, d, a.followEasing);
                        });
                    }, 50));
        }
        function F(d) {
            var c = d.width(),
                e = d.height(),
                f = {};
            a.contentContainer.css({ height: e, width: c });
            e >= b.height() && (f.height = b.height());
            c >= b.width() && (f.width = b.width());
            t = b.outerHeight(!0);
            u = b.outerWidth(!0);
            C();
            a.contentContainer.css({ height: "auto", width: "auto" });
            f.left = m(!((!a.follow[0] && n) || g));
            f.top = p(!((!a.follow[1] && q) || g));
            b.animate(f, 250, function () {
                d.show();
                h = D();
            });
        }
        function M() {
            k.data("bPopup", v);
            b.delegate(".bClose, ." + a.closeClass, "click." + e, r);
            a.modalClose &&
                c(".b-modal." + e)
                    .css("cursor", "pointer")
                    .bind("click", r);
            N ||
                (!a.follow[0] && !a.follow[1]) ||
                k
                    .bind("scroll." + e, function () {
                        if (h.x || h.y) {
                            var d = {};
                            h.x && (d.left = a.follow[0] ? m(!g) : "auto");
                            h.y && (d.top = a.follow[1] ? p(!g) : "auto");
                            b.dequeue().animate(d, a.followSpeed, a.followEasing);
                        }
                    })
                    .bind("resize." + e, function () {
                        I();
                    });
            a.escClose &&
                f.bind("keydown." + e, function (a) {
                    27 == a.which && r();
                });
        }
        function G(d) {
            function c(e) {
                b.css({ display: "block", opacity: 1 }).animate(e, a.speed, a.easing, function () {
                    K(d);
                });
            }
            switch (d ? a.transition : a.transitionClose || a.transition) {
                case "slideIn":
                    c({ left: d ? m(!((!a.follow[0] && n) || g)) : f.scrollLeft() - (u || b.outerWidth(!0)) - 200 });
                    break;
                case "slideBack":
                    c({ left: d ? m(!((!a.follow[0] && n) || g)) : f.scrollLeft() + w + 200 });
                    break;
                case "slideDown":
                    c({ top: d ? p(!((!a.follow[1] && q) || g)) : f.scrollTop() - (t || b.outerHeight(!0)) - 200 });
                    break;
                case "slideUp":
                    c({ top: d ? p(!((!a.follow[1] && q) || g)) : f.scrollTop() + y + 200 });
                    break;
                default:
                    b.stop().fadeTo(a.speed, d ? 1 : 0, function () {
                        K(d);
                    });
            }
        }
        function K(d) {
            d ? (M(), l(E), a.autoClose && (H = setTimeout(r, a.autoClose))) : (b.hide(), l(a.onClose), a.loadUrl && (a.contentContainer.empty(), b.css({ height: "auto", width: "auto" })));
        }
        function m(a) {
            return a ? x + f.scrollLeft() : x;
        }
        function p(a) {
            return a ? z + f.scrollTop() : z;
        }
        function l(a, e) {
            c.isFunction(a) && a.call(b, e);
        }
        function C() {
            z = q ? a.position[1] : Math.max(0, (y - b.outerHeight(!0)) / 2 - a.amsl);
            x = n ? a.position[0] : (w - b.outerWidth(!0)) / 2;
            h = D();
        }
        function D() {
            return { x: w > b.outerWidth(!0), y: y > b.outerHeight(!0) };
        }
        c.isFunction(A) && ((E = A), (A = null));
        var a = c.extend({}, c.fn.bPopup.defaults, A);
        a.scrollBar || c("html").css("overflow", "hidden");
        var b = this,
            f = c(document),
            k = c(window),
            y = k.height(),
            w = k.width(),
            N = /OS 6(_\d)+/i.test(navigator.userAgent),
            v = 0,
            e,
            h,
            q,
            n,
            g,
            z,
            x,
            t,
            u,
            J,
            H;
        b.close = function () {
            r();
        };
        b.reposition = function (a) {
            I(a);
        };
        return b.each(function () {
            c(this).data("bPopup") ||
                (l(a.onOpen),
                (v = (k.data("bPopup") || 0) + 1),
                (e = "__b-popup" + v + "__"),
                (q = "auto" !== a.position[1]),
                (n = "auto" !== a.position[0]),
                (g = "fixed" === a.positionStyle),
                (t = b.outerHeight(!0)),
                (u = b.outerWidth(!0)),
                a.loadUrl ? L() : B());
        });
    };
    c.fn.bPopup.defaults = {
        amsl: 50,
        appending: !0,
        appendTo: "body",
        autoClose: !1,
        closeClass: "b-close",
        content: "ajax",
        contentContainer: !1,
        easing: "swing",
        escClose: !0,
        follow: [!0, !0],
        followEasing: "swing",
        followSpeed: 500,
        iframeAttr: 'scrolling="no" frameborder="0"',
        loadCallback: !1,
        loadData: !1,
        loadUrl: !1,
        modal: !0,
        modalClose: !0,
        modalColor: "#000",
        onClose: !1,
        onOpen: !1,
        opacity: 0.7,
        position: ["auto", "auto"],
        positionStyle: "absolute",
        scrollBar: !0,
        speed: 250,
        transition: "fadeIn",
        transitionClose: !1,
        zIndex: 9997,
    };
})(jQuery);