window.phone_fields = [];
window.is_model_form = false;

function hslToHex(h, s, l) {
  l /= 100;
  const a = s * Math.min(l, 1 - l) / 100;
  const f = n => {
    const k = (n + h / 30) % 12;
    const color = l - a * Math.max(Math.min(k - 3, 9 - k, 1), -1);
    return Math.round(255 * color).toString(16).padStart(2, '0');
  };
  return `#${f(0)}${f(8)}${f(4)}`;
}

function open_modal_box(id, height, width, checkradio_style_prop, is_close_link, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id, entry_view_id, data ) {
    if( "" != data && "undefined" != typeof data ){

        let data_1 = data.split("||");
        let get_item_id = data_1[0];
        let get_item_val = data_1[1];

        if( "undefined" != get_item_id && "undefined" != get_item_val ){

            get_item_id = get_item_id.split('_');
            
            let get_field_type = jQuery(".arf_field_"+ get_item_id[2] ).attr('data-field-type');
            
        
            if( get_field_type == 'checkbox' ){

                jQuery('input[name="item_meta[' + get_item_id[2] + '][]"]').trigger('change');
                if (get_item_val == '') {
                    jQuery('input[name="item_meta[' + get_item_id[2] + '][]"]:checked').prop('checked',false);
                } else {
                    jQuery('input[name="item_meta[' + get_item_id[2] + '][]"]:checked').prop('checked',false);
                    
                    if (typeof get_item_val === 'array' || typeof get_item_val === 'object') {
                        for (var k in get_item_val) {
                            jQuery('input[name="item_meta[' + get_item_id[2] + '][]"][value="' + get_item_val[k] + '"]').prop('checked', true);
                        }
                    } else {
                        jQuery('input[name="item_meta[' + get_item_id[2] + '][]"][value="' + get_item_val + '"]').prop('checked', true);
                    }
                }
    
            }  else if ( get_field_type == 'radio') {
    
                if (get_item_val != '') {
                    jQuery('input[name="item_meta[' + get_item_id[2] + ']"][value="' + get_item_val + '"]').prop('checked', true);
                } else {
                    jQuery('input[name="item_meta[' + get_item_id[2] + ']"]:checked').prop('checked', false);
                }
                jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').trigger('change');
    
            } else if ( get_field_type == 'date' ) {

                    let date_format = jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').attr('data-date-format');
                
                    if( ''!= date_format ){


                    let change_to_current_date_format = moment( get_item_val ).format( date_format );
                    
                    jQuery('input[name="item_meta[' + get_item_id[2] + ']"]')
                    jQuery('input[data-name="item_meta['+ get_item_id[2] +']"]').val( change_to_current_date_format );
                    jQuery('input[data-name="item_meta['+ get_item_id[2] +']"]').attr( 'value', change_to_current_date_format );
                }
        
                jQuery('input[data-name="item_meta['+ get_item_id[2] +']"]').val(get_item_val);

                

            } else if( get_field_type == 'colorpicker'){

                var color = get_item_val;
                color = color.replace('#', '');
                
                jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').val(get_item_val).trigger( "change" );
                arf_get_id = jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').attr('id');

                if( "undefined" != arf_get_id && "" != arf_get_id ){
                    
                    arf_get_field_key = arf_get_id.split('field_');
                    jQuery('#'+arf_get_id).val(get_item_val).trigger( "change" );
                    jQuery('#'+arf_get_id).text('#'+color);
                    jQuery('#colorpicker_div_'+arf_get_field_key[1]).css('background','#'+color);
                }


            } else if( get_field_type == 'select' || get_field_type == 'arf_multiselect') {

                arf_get_id = jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').attr('id');

                if( "undefined" != arf_get_id && "" != arf_get_id ){

                    jQuery('#' + arf_get_id ).val(get_item_val);
                    
                    jQuery('#' + arf_get_id ).trigger('change');

                    let to_field = jQuery('input[name="item_meta[' + get_item_id[2] + ']"]');

                    to_field.val(get_item_val);
                    to_field.trigger('change');
                    jQuery('input[name="item_meta[' + get_item_id[2] + ']"]')
                    var selectpicker = jQuery('dl[data-name="item_meta[' + get_item_id[2] + ']"');
                    selectpicker.find( 'dd ul li[data-value="' + get_item_id[2] + '"]');
                    selectpicker.find('dt span').text( get_item_val );
                }        
            } else if (get_field_type == 'arf_smiley') {

                if (get_item_val != '') {
                    jQuery('input[name="item_meta[' + get_item_id[2] + ']"][value="' + get_item_val + '"]').prop('checked', true);
                } else {
                    jQuery('input[name="item_meta[' + get_item_id[2] + ']"]:checked').prop('checked', false);
                }

            }else if (get_field_type == 'arf_switch') {

                jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"]').trigger('change');
                jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').val(get_item_val);
                jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"]').val(get_item_val);

                if (get_item_val == '') {
                    jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"]:checked').prop('checked', false);
                } else {
                    jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"]:checked').prop('checked', false);
                    var leftVal = jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"]').attr('data-leftval');
                    var rightVal = jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"]').attr('data-rightval');
                    
                    if( get_item_val == rightVal ){
                        console.log( "inside this ");
                        jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"][value="' + get_item_val + '"]').prop('checked', true);
                    } else {
                        jQuery('input[name="switch_item_meta[' + get_item_id[2] + ']"][value="' + get_item_val + '"]').prop('checked', false);
                    }
                    
                }
            } else if( get_field_type == 'like'){

                arf_get_id = jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').attr('id');
                arf_get_id = arf_get_id.split('_');

                if( "undefined" != arf_get_id && ""!= arf_get_id ){
                    field_key = arf_get_id[1];
                    f_data_id = arf_get_id[2].split('-');
                    f_data_id = f_data_id[0];

                    if (get_item_val == '1') {

                        jQuery('#field_' + field_key+'_'+f_data_id+'-0').prop('checked', true);
                        jQuery('#like_' + field_key+'_'+f_data_id+'-0').addClass('active');
                        jQuery('#field_' + field_key+'_'+f_data_id+'-1').prop('checked', false);
                        jQuery('#like_' + field_key+'_'+f_data_id+'-1').removeClass('active');

                    } else if (get_item_val == '0') {
                        jQuery('#field_' + field_key +'_'+f_data_id+'-0').prop('checked', false);
                        jQuery('#like_' + field_key +'_'+f_data_id+'-0').removeClass('active');
                        jQuery('#field_' + field_key +'_'+f_data_id+'-1').prop('checked', true);
                        jQuery('#like_' + field_key +'_'+f_data_id+'-1').addClass('active');
                    } else {
                        jQuery('#field_' + field_key +'_'+f_data_id+'-0').prop('checked', false);
                        jQuery('#like_' + field_key +'_'+f_data_id+'-0').removeClass('active');
                        jQuery('#field_' + field_key +'_'+f_data_id+'-1').prop('checked', false);
                        jQuery('#like_' + field_key +'_'+f_data_id+'-1').removeClass('active');
                    }
                }

            } else if ( get_field_type  == 'arfslider') {

                var form_data_id = jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').attr('data-form-data-id');

                if( typeof get_item_val == 'string' ){
                    get_item_val = parseInt( get_item_val );
                }
                setTimeout(function(){
                    jQuery('.arfslider_front').each(function(){
                       var arf_slider_front = document.querySelector('.noUi-target');
                       this.noUiSlider.set(get_item_val);
                    });
                },150);
                jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').val(get_item_val)
                
            } else if( get_field_type == 'textarea'){  

                jQuery('textarea[name="item_meta[' + get_item_id[2] + ']"]').text(get_item_val).trigger( "change" );

            }  else {

                jQuery('input[name="item_meta[' + get_item_id[2] + ']"]').val(get_item_val).trigger( "change" );
            }
        } 


    }

    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }

    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    var body_class_new = '';

    if( ! arf_display_popup_again(id, popup_data_uniq_id ) ){
        return false;
    }

    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
        body_class_new = arf_body_class[i].split('arforms_model_popup_id_');
        if (body_class_new[1] != 'undefined' && /[\d+]/.test(body_class_new[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }

    jQuery('body').addClass("arforms_model_view_" + id);
    jQuery('body').addClass("arforms_model_popup_id_" + popup_data_uniq_id);
    
    var admin_ajax_url = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="admin_ajax_url"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    admin_ajax_url = is_ssl_replace(admin_ajax_url);
    var _wpnonce = jQuery('#arforms_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: admin_ajax_url,
        data: "action=current_modal&position_modal=arf_modal_default+&_wpnonce="+_wpnonce,
        success: function(errObj) {}
    });
    var screenheight = jQuery(window).height();
    var screenwidth = jQuery(window).width();
    var modal_body_height = Number(height);
    var checkstep = 0;
    if ((jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height()) >= screenheight) {
        var tmp_height = Number(jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height()) - Number(screenheight);
        checkstep = 1;
    } else {
        var tmp_height = Number(screenheight) - Number(jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height());
        checkstep = 0;
    }
    if (checkstep != 0) {
        var total_height = 20;
        modal_body_height = screenheight - 55;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (screenheight - 40) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (screenheight - 40) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
    } else {
        var total_height = Number(tmp_height / 2);
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', (modal_body_height - 15) + 'px');
    }
    var tmp_width = Number(screenwidth) - Number(width);
    var total_width = Number(tmp_width / 2);
    var arf_top = (tmp_height) / 2;
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('top', arf_top + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('left', total_width + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-mtop', total_height);
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-mleft', total_width);
    var scroll_top = jQuery(window).scrollTop();
    if (height == '' || height == 'auto') {
        var arf_top = (tmp_height) / 2;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('top', arf_top + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', 'auto');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', 'auto');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', 'absolute');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('overflow', 'visible');
    }
    jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).addClass('arfpopupmaindiv');
    var form_key = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_key_' + id + '"]').val();

    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
    var modal_bgcolor = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.close_btn').attr('data-modalcolor') || '#000000';
    var modal_overlay = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.close_btn').attr('data-modal-overlay') || 0.6;
    var arf_is_hasl = modal_bgcolor.indexOf('hsl');    
    if(arf_is_hasl != -1){
        var result = modal_bgcolor.match(/\((.*)\)/);
        var hslarray = result[1].split(', ');
        var h = hslarray[0].replace("%","");
        var s = hslarray[1].replace("%","");
        var l = hslarray[2].replace("%","");
        modal_bgcolor = hslToHex(h, s, l);
    }    
    var rgbcolor = arfhextorgbcolor(modal_bgcolor);
    arf_rgb_color = "rgba(" + rgbcolor.r + "," + rgbcolor.g + "," + rgbcolor.b +","+modal_overlay+")";
    
    if (is_close_link == 'no') {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).removeClass('fade_out').addClass('arf_active');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .close_btn.arf_close_btn_inner').addClass('arf_hide_close');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ':not(".arfmodal-fullscreen")').css('background',arf_rgb_color);
        
        jQuery('body').append('<div class="arfmodal-backdrop in hide_close_btn arf_active" />');
    } else {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).removeClass('fade_out').addClass('arf_active');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .close_btn.arf_close_btn_inner').removeClass('arf_hide_close');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ':not(".arfmodal-fullscreen")').css('background',arf_rgb_color);
        
        jQuery('body').append('<div class="arfmodal-backdrop in arf_active" />');
    }

    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).addClass('arf_previous_modal');
    jQuery('[data-link-popup-id="'+popup_data_uniq_id+'"]').addClass('arf_previous_modal');

    var popup_body_height = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_form_outer_wrapper').height();
    jQuery('.arf_larger_popup').removeClass('arf_larger_popup');
    if( popup_body_height > screenheight ){
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).addClass('arf_larger_popup');
    }

    jQuery('html').css('overflow','hidden');

    if (screenwidth <= 770) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find(".arf_form_outer_wrapper .arfshowmainform .allfields .arf_fieldset").css("height", 'auto');
        var windowHeight = jQuery(window).height() - Number(60);
        var windowHeightOrg = jQuery(window).height();
        var actualheight = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_fieldset').height();
        if (actualheight < windowHeight) {
            if (screenwidth < width) {
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find(".arf_form_outer_wrapper .arfshowmainform .allfields .arf_fieldset").css("height", windowHeightOrg + "px");
            }
        }
        if (screenwidth < width) {
            if (height == '' || height == 'auto') {
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', 'fixed');
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('overflow', 'auto');
            }
        }
    }
    var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
    data_open = (data_open !== undefined) ? data_open : true;
    if (checkradio_style_prop != "" && data_open == true) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
    }
    if (data_open == true) {
        
    }
    var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    var arffiledragurl = jQuery("[data-id='arffiledragurl']").val();
    arfmainformurl = is_ssl_replace(arfmainformurl);
    var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
    var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
    jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
        var id = jQuery(this).attr('id');
        id = id.replace('field_', '');
        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
        var file_data = jQuery(this)[0].files;
        for (var i = 0; i < file_data.length; i++) {
            var fileName = file_data[i].name;
            fileName = fileName.replace(/C:\\fakepath\\/i, '');
            if (fileName != '') {
                var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                if (old_file_name == 'No file selected') {
                    old_file_name = '';
                }
                if (old_file_name != '') {
                    jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                } else {
                    jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                }
            }
        }
    });
    
    jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
        var field = jQuery(this).attr('id');
        var field = field.replace('like_', 'field_');
        if (jQuery("#" + field).is(':disabled')) {
            return false;
        }
        if (!jQuery("#" + field).is(':checked')) {
            jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
        }
    });
    jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
        var field = jQuery(this).attr('id');
        var field_data = field.split('-');
        var field_id = field_data[0];
        var field2 = field_id.replace('like_', 'field_');
        var field3 = field_id.replace('like_', '');
        var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
        var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
        var like = field_data[1];
        if (like == 1) {
            jQuery('#' + field_id + '-0').removeClass('active');
            jQuery('#' + field_id + '-1').addClass('active');
            jQuery('#' + field_id + '-1').css('background', likeactivecolor);
            jQuery('#' + field_id + '-0').css('background', '');
        } else if (like == 0) {
            jQuery('#' + field_id + '-1').removeClass('active');
            jQuery('#' + field_id + '-0').addClass('active');
            jQuery('#' + field_id + '-1').css('background', '');
            jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
        }
    });
    jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
        var field = jQuery(this).attr('id');
        var field_data = field.split('-');
        var field_id = field_data[0];
        var field2 = field_id.replace('like_', 'field_');
        var field3 = field_id.replace('like_', '');
        var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
        var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
        var like = field_data[1];
        if (like == 1) {
            jQuery('#' + field_id + '-0').removeClass('active');
            jQuery('#' + field_id + '-1').addClass('active');
            jQuery('#' + field_id + '-1').css('background', likeactivecolor);
            jQuery('#' + field_id + '-0').css('background', '');
        } else if (like == 0) {
            jQuery('#' + field_id + '-1').removeClass('active');
            jQuery('#' + field_id + '-0').addClass('active');
            jQuery('#' + field_id + '-1').css('background', '');
            jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
        }
    });
    jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
        var title = jQuery(this).attr('data-title');
        if (title !== undefined) {
            jQuery(this).arf_popover({
                html: true,
                trigger: 'hover',
                placement: 'top',
                content: title,
                title: '',
                animation: false
            });
        }
    });
    arforms_controls_obj.arforms_initialize_form_fields();
    arforms_pro_controls_obj.arforms_init_pro_fields();
    if (typeof arf_change_modal_slider != 'function') {
        return;
    }
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        var field_id = jQuery(this).attr('id');
        var fkey = 'field_'+field_id;
        if (typeof window.phone_fields[fkey] == 'undefined') {
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }   
        }
    });

    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },100);
    }

    arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    if( typeof wp.hooks != 'undefined' ){
        wp.hooks.doAction( 'arf_open_model_form', id, entry_view_id );
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }
    }

    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        var starttimerpgno = jQuery('#arf_date_time_countdown-' + id + '-' + popup_data_uniq_id).attr('start-timer-pgno');
        if( starttimerpgno <= 1){
            jQuery('#arf_date_time_countdown-' + id + '-' + popup_data_uniq_id ).TimeCircles().restart();
        }
    }

    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_fly_left(id, height, width, checkradio_style_prop, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_fly_left_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }
    jQuery('body').addClass("arforms_model_fly_left_view_" + id);
    var admin_ajax_url = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="admin_ajax_url"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    admin_ajax_url = is_ssl_replace(admin_ajax_url);
    var _wpnonce = jQuery('#arforms_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: admin_ajax_url,
        data: "action=current_modal&position_modal=arf_modal_left+&_wpnonce="+_wpnonce,
        success: function(errObj) {}
    });

    var is_message_visible = false;
    if( jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body').hasClass('arf_hide_form_after_submit') && jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('#arf_message_success_popup')[0].style.display != 'none' ){
        is_message_visible = true;
    }

    var screenheight = jQuery(window).height();
    var screenwidth = jQuery(window).width();
    var modal_body_height = Number(height);
    var actualheight = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_fieldset').height();
    var checkstep = 0;
    if ((height) >= screenheight) {
        var tmp_height = Number(height) - Number(screenheight);
        checkstep = 1;
    } else {
        var tmp_height = Number(screenheight) - Number(height);
        checkstep = 0;
    }
    if (checkstep != 0) {
        var total_height = 20;
        modal_body_height = screenheight - 57;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (screenheight - 40) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (screenheight - 40) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
    } else {
        var total_height = Number(tmp_height / 2);
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', (modal_body_height - 15) + 'px');
    }

    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('opacity', '1');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('z-index', '999999');

    var tmp_width = Number(screenwidth) - Number(width);
    var total_width = Number(tmp_width / 2);
    var total_height = Number(screenheight - actualheight) / 2;
    if( !is_message_visible ){
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('top', total_height);
    }
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-mtop', total_height);
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-mleft', total_width);
    var scroll_top = jQuery(window).scrollTop();
    if (height == '' || height == 'auto') {
        total_height = scroll_top + 20;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css({
            opacity: "0",
            display: "block"
        });
        var actualheight = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_fieldset').outerHeight();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css({
            opacity: '',
            display: ""
        });
        if (screenheight > actualheight) {
            var total_height = (screenheight - actualheight) / 2;
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_form_outer_wrapper').css({'top' : '15%', 'position' : 'fixed', 'width' : '100%'});
            jQuery("html").animate({ scrollTop: 0 }, "slow");
        }
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', 'auto');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', 'auto');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', 'absolute');
        var isSafari = !!navigator.userAgent.match(/Version\/[\d\.]+.*Safari/)
        if (!isSafari) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('overflow', 'visible');
        }
    }
    jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', width + 'px');
    jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block_left_' + id).hide();
    var animate_opts = {};

    if( !is_message_visible ){
        animate_opts.top = total_height + 'px';
        animate_opts.left = total_width + 'px';
        animate_opts.right = total_width + 'px';
        animate_opts.bottom = total_height + 'px';
    } else {
        animate_opts.top = '20%';
        animate_opts.left = total_width + 'px';
        animate_opts.right = total_width + 'px';
        animate_opts.bottom = total_height + 'px';
    }
    
    if (jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).hasClass('in')) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).removeClass('in');
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block').show();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate(animate_opts, 500);
    } else {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).addClass('in');
        var form_key = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_key_' + id + '"]').val();
        
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arform_sb_fx_form').css('display', 'block');
        jQuery('.arf_popup_' + popup_data_uniq_id).find('#open_modal_box_fly_left_' + id).show();       
        
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate(animate_opts, 500);
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('display', 'block');
        var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
        data_open = (data_open !== undefined) ? data_open : true;
        if (checkradio_style_prop != "" && data_open == true) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
        }
        if (data_open == true) {
            
        }
        var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
        if (typeof is_ssl_replace != 'function') {
            return;
        }
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
        var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
            var id = jQuery(this).attr('id');
            id = id.replace('field_', '');
            jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
            var file_data = jQuery(this)[0].files;
            for (var i = 0; i < file_data.length; i++) {
                var fileName = file_data[i].name;
                fileName = fileName.replace(/C:\\fakepath\\/i, '');
                if (fileName != '') {
                    var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                    if (old_file_name == 'No file selected') {
                        old_file_name = '';
                    }
                    if (old_file_name != '') {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                    } else {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                    }
                }
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field = field.replace('like_', 'field_');
            if (jQuery("#" + field).is(':disabled')) {
                return false;
            }
            if (!jQuery("#" + field).is(':checked')) {
                jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
            }
        });
        jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
            var title = jQuery(this).attr('data-title');
            if (title !== undefined) {
                jQuery(this).arf_popover({
                    html: true,
                    trigger: 'hover',
                    placement: 'top',
                    content: title,
                    title: '',
                    animation: false
                });
            }
        });
        
        if (typeof arf_change_modal_slider != 'function') {
            return;
        }
        arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    }
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    if (screenwidth <= 770) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find(".arf_form_outer_wrapper .arfshowmainform .allfields .arf_fieldset").css("height", 'auto');
        var windowHeight = jQuery(window).height() - Number(60);
        var actualheight = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_fieldset').height();
        if (actualheight < windowHeight) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find(".arf_form_outer_wrapper .arfshowmainform .allfields .arf_fieldset").css("height", windowHeight + "px");
        }
        if (screenwidth < width) {
            if (height == '' || height == 'auto') {
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', 'fixed');
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('overflow', 'auto');
            }
        }
    }
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();


    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }

    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        arf_pagebreak_startTimer( 'arf_date_time_countdown-' + id + '-' + popup_data_uniq_id );
    }
    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_fly_left_move(id, height, width, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }
    

    var modalwidth = jQuery(window).width();
    modalwidth = Number(modalwidth) + Number(20);
    var tmp_width = Number(modalwidth) - Number(width);
    var total_width = Number(tmp_width / 2) - Number(50);
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).removeClass('in');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', '');
    var screenwidth = jQuery(window).width();
    if (screenwidth <= 770) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).hide();
    } else {
        if(jQuery('body').hasClass('rtl')){
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'right': total_width + 'px',
            }, 200, function() {});
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'right': -modalwidth + 'px',
            }, 500, function() {});
        } else {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'left': total_width + 'px',
            }, 200, function() {});
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'left': modalwidth + 'px',
            }, 500, function() {});
        }
    }
    jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block_right_' + id).show(800);
    jQuery('.arf_popup_' + popup_data_uniq_id).find('#open_modal_box_fly_right_' + id).show();
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }
    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_fly_right(id, height, width, checkradio_style_prop, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_fly_right_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }
    jQuery('body').addClass("arforms_model_fly_right_view_" + id);
    jQuery(document).ready(function($) {
        jQuery(".vpb_captcha").keypress(function() {
            jQuery(this).parents('.arfformfield').find('.popover').remove();
            jQuery(this).removeClass('control-group');
            jQuery(this).removeClass('arf_error');
        });
    });
    var admin_ajax_url = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="admin_ajax_url"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    admin_ajax_url = is_ssl_replace(admin_ajax_url);
    var _wpnonce = jQuery('#arforms_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: admin_ajax_url,
        data: "action=current_modal&position_modal=arf_modal_right+&_wpnonce="+_wpnonce,
        success: function(errObj) {}
    });

    var is_message_visible = false;
    if( jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body').hasClass('arf_hide_form_after_submit') && jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('#arf_message_success_popup')[0].style.display != 'none' ){
        is_message_visible = true;
    }

    var screenheight = jQuery(window).height();
    var screenwidth = jQuery(window).width();
    var modal_body_height = Number(height);
    var checkstep = 0;
    if (height >= screenheight) {
        var tmp_height = Number(height) - Number(screenheight);
        checkstep = 1;
    } else {
        var tmp_height = Number(screenheight) - Number(height);
        
        checkstep = 0;
    }
    if (checkstep != 0) {
        var total_height = 20;
        modal_body_height = screenheight - 59;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (screenheight - 40) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (screenheight - 40) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
    } else {
        var total_height = Number(tmp_height / 2);
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', (modal_body_height - 19) + 'px');
    }
    var tmp_width = Number(screenwidth) - Number(width);
    var total_width = Number(tmp_width / 2);
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('left', screenwidth);
    if( !is_message_visible ){
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('top', total_height);
    }
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('data-mtop', total_height);
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('data-mleft', total_width);
    var scroll_top = jQuery(window).scrollTop();
    if (height == '' || height == 'auto') {
        total_height = scroll_top + 20;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css({
            opacity: "0",
            display: "block"
        });
        var actualheight = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_fieldset').outerHeight();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css({
            opacity: '',
            display: ""
        });
        if (screenheight > actualheight) {
            var total_height = (screenheight - actualheight) / 2;
            jQuery("html").animate({ scrollTop: 0}, "slow");
        }
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', 'auto');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', 'auto');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', 'absolute');
        var isSafari = !!navigator.userAgent.match(/Version\/[\d\.]+.*Safari/)
        if (!isSafari) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('overflow', 'visible');
        }
    }
    var animate_opts = {};
    if( !is_message_visible ){
        animate_opts.top = total_height + 'px';
        animate_opts.left = total_width + 'px';
        animate_opts.right = total_width + 'px';
        animate_opts.bottom = total_height + 'px';
    } else {
        animate_opts.top = '20%';
        animate_opts.left = total_width + 'px';
        animate_opts.right = total_width + 'px';
        animate_opts.bottom = total_height + 'px';
    }

    jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', width + 'px');
    jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block_right_' + id).hide();
    if (jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).hasClass('in')) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).removeClass('in');
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block').show();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate(animate_opts, 500);
    } else {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).addClass('in');
        var form_key = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_key_' + id + '"]').val();
        
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arform_sb_fx_form').css('display', 'block');
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block').hide();
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate(animate_opts, 500);
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('display', 'block');
        var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
        data_open = (data_open !== undefined) ? data_open : true;
        if (checkradio_style_prop != "" && data_open == true) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
        }
        if (data_open == true) {
        
        }
        var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
        if (typeof is_ssl_replace != 'function') {
            return;
        }
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
        var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
            var id = jQuery(this).attr('id');
            id = id.replace('field_', '');
            jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
            var file_data = jQuery(this)[0].files;
            for (var i = 0; i < file_data.length; i++) {
                var fileName = file_data[i].name;
                fileName = fileName.replace(/C:\\fakepath\\/i, '');
                if (fileName != '') {
                    var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                    if (old_file_name == 'No file selected') {
                        old_file_name = '';
                    }
                    if (old_file_name != '') {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                    } else {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                    }
                }
            }
        });
       
        jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field = field.replace('like_', 'field_');
            if (jQuery("#" + field).is(':disabled')) {
                return false;
            }
            if (!jQuery("#" + field).is(':checked')) {
                jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
            }
        });
        jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
            var title = jQuery(this).attr('data-title');
            if (title !== undefined) {
                jQuery(this).arf_popover({
                    html: true,
                    trigger: 'hover',
                    placement: 'top',
                    content: title,
                    title: '',
                    animation: false
                });
            }
        });
        
        if (typeof arf_change_modal_slider != 'function') {
            return;
        }
        arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    }
    if (screenwidth <= 770) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find(".arf_form_outer_wrapper .arfshowmainform .allfields .arf_fieldset").css("height", 'auto');
        var windowHeight = jQuery(window).height() - Number(60);
        var actualheight = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arf_fieldset').height();
        if (actualheight < windowHeight) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find(".arf_form_outer_wrapper .arfshowmainform .allfields .arf_fieldset").css("height", windowHeight + "px");
        }
        if (screenwidth < width) {
            if (height == '' || height == 'auto') {
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('position', 'fixed');
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('overflow', 'auto');
            }
        }
    }
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }           
    }

    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        arf_pagebreak_startTimer( 'arf_date_time_countdown-' + id + '-' + popup_data_uniq_id );
    }

    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_fly_right_move(id, height, width, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    var modalwidth = jQuery(window).width();
    modalwidth = Number(modalwidth) + Number(20);
    var tmp_width = Number(modalwidth) - Number(width);
    var total_width = Number(tmp_width / 2) + Number(50);
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).removeClass('in');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('opacity', '0');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('z-index', '-1');
    var screenwidth = jQuery(window).width();
    if (screenwidth <= 770) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).hide();
    } else {
        if(jQuery('body').hasClass('rtl')){
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'right': total_width + 'px',
            }, 200, function() {});
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'right': modalwidth + 'px',
            }, 800, function() {});

        } else {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'left': total_width + 'px',
            }, 200, function() {});
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).animate({
                'left': -modalwidth + 'px',
            }, 800, function() {});
        }
    }
    jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_side_block_left_' + id).show(800);
    jQuery('.arf_popup_' + popup_data_uniq_id).find('#open_modal_box_fly_right_' + id).show();
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }
    
    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_sitcky_bottom(id, height, width, checkradio_style_prop, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    if (jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arf_res_front_msg').length > 0) {
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_bottom_main').slideToggle('500');
        return;
    }
    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_sitcky_bottom_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }
    jQuery('body').addClass("arforms_model_sitcky_bottom_view_" + id);
    jQuery(document).ready(function($) {
        jQuery(".vpb_captcha").keypress(function() {
            jQuery(this).parents('.arfformfield').find('.popover').remove();
            jQuery(this).removeClass('control-group');
            jQuery(this).removeClass('arf_error');
        });
    });
    var admin_ajax_url = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="admin_ajax_url"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    admin_ajax_url = is_ssl_replace(admin_ajax_url);
    var _wpnonce = jQuery('#arforms_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: admin_ajax_url,
        data: "action=current_modal&position_modal=arf_modal_bottom+&_wpnonce="+_wpnonce,
        success: function(errObj) {}
    });

    var screenwidth = jQuery(window).width();
    var screenheight = jQuery(window).height();

    if( isNaN(height) && height != 'auto' ){
        height = screenheight - 150;
    }

    var modal_body_height = Number(height) - 140;
    
    
    var newheightformainmodal = 0;

    if (height >= screenheight) {
        modal_body_height = screenheight - 55;
        newheightformainmodal = screenheight - 55;
    } else {
        modal_body_height = Number(height) + 36;
        newheightformainmodal = Number(height);
    }
    var is_message_visible = false;
    if( jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body').hasClass('arf_hide_form_after_submit') && jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('#arf_message_success_popup')[0].style.display != 'none' ){
        is_message_visible = true;
    } else {
        if (height == 'auto') {
            setTimeout(function() {
                var total_popup_height = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height();
                
                var button_height = jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_modal_stickybottom_' + id).outerHeight();
                modal_body_height = (screenheight - 100);
                newheightformainmodal = (screenheight - 100);
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (newheightformainmodal) + 'px');
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (height));
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', height );
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('max-height', newheightformainmodal + 'px');
                
            }, 499);
        }
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (newheightformainmodal) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (newheightformainmodal) + 'px');
    }
    
    if (width >= screenwidth) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('width', screenwidth + 'px');
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', screenwidth + 'px');
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).css('right', '0');
    } else {
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', width + 'px');
    }
    if( !is_message_visible ){

        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('max-height', newheightformainmodal + 'px');
    }
    if (jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_bottom').hasClass('arform_bottom_fixed_block_open')) {
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_bottom').removeClass('arform_bottom_fixed_block_open');
    } else {
        var form_key = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_key_' + id + '"]').val();
        
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_bottom').addClass('arform_bottom_fixed_block_open');
        var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
        data_open = (data_open !== undefined) ? data_open : true;
        if (checkradio_style_prop != "" && data_open == true) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
        }
        if (data_open == true) {
        }
        var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
        if (typeof is_ssl_replace != 'function') {
            return;
        }
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
        var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
            var id = jQuery(this).attr('id');
            id = id.replace('field_', '');
            jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
            var file_data = jQuery(this)[0].files;
            for (var i = 0; i < file_data.length; i++) {
                var fileName = file_data[i].name;
                fileName = fileName.replace(/C:\\fakepath\\/i, '');
                if (fileName != '') {
                    var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                    if (old_file_name == 'No file selected') {
                        old_file_name = '';
                    }
                    if (old_file_name != '') {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                    } else {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                    }
                }
            }
        });
        
        jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field = field.replace('like_', 'field_');
            if (jQuery("#" + field).is(':disabled')) {
                return false;
            }
            if (!jQuery("#" + field).is(':checked')) {
                jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
            }
        });
        jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
            var title = jQuery(this).attr('data-title');
            if (title !== undefined) {
                jQuery(this).arf_popover({
                    html: true,
                    trigger: 'hover',
                    placement: 'top',
                    content: title,
                    title: '',
                    animation: false
                });
            }
        });
        
        if (typeof arf_change_modal_slider != 'function') {
            return;
        }
        arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    }
    jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_bottom_main').slideToggle('500');
    setTimeout(function(){
		arforms_controls_obj.arforms_initialize_form_fields();
		arforms_pro_controls_obj.arforms_init_pro_fields();
	},510);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('canvas.arf_do_canvas_resize').each(function(){
        var $this = jQuery( this );

        $this.css( 'max-width','100%' );

        var parent       = $this.parent();

        var parentWidth  = parseInt( parent.css( 'width' ) );
        var parentHeight = parseInt( parent.css( 'height' ) );

        $this.css( 'max-width','' );

        this.width  = parentWidth;
        this.height = parentHeight;
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },100);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }

    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        arf_pagebreak_startTimer( 'arf_date_time_countdown-' + id + '-' + popup_data_uniq_id );
    }

    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_sitcky_top(id, height, width, checkradio_style_prop, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    if (jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arf_res_front_msg').length > 0) {
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_top_main').slideToggle("500");
        return;
    }
    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_sitcky_top_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }
    jQuery('body').addClass("arforms_model_sitcky_top_view_" + id);
    var screenwidth = jQuery(window).width();
    var modal_body_height = Number(height) - 140;
    var screenheight = jQuery(window).height();
    if( isNaN(height) && height != 'auto'){
        height = screenheight - 150;
    }
    var newheightformainmodal = 0;

    if (height >= screenheight) {
        modal_body_height = screenheight - 55;
        newheightformainmodal = screenheight - 55;
    } else {
        modal_body_height = Number(height) + 36 - 26;
        newheightformainmodal = Number(height);
    }
    
    var is_message_visible = false;
    if( jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body').hasClass('arf_hide_form_after_submit') && jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('#arf_message_success_popup')[0].style.display != 'none' ){
        is_message_visible = true;
    } else {
        if (height == 'auto') {
            setTimeout(function() {
                var total_popup_height = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height();
                var button_height = jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_modal_stickytop_' + id).outerHeight();
                modal_body_height = screenheight - 100;
                newheightformainmodal = screenheight - 100;
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (newheightformainmodal) + 'px');
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', height);
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', height);
                jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('max-height', newheightformainmodal + 'px');
            }, 499);
        }
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (newheightformainmodal) + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (newheightformainmodal) + 'px');
    }
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('zIndex', '9998');
    jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_top').css('zIndex', '9999');
    jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_top').css('position', 'relative');
    if (width >= screenwidth) {
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('width', screenwidth + 'px');
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', screenwidth + 'px');
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).css('right', '0');
    } else {
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', width + 'px');
    }
    var applycheckstyleprop = "";
    if( !is_message_visible ){
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('max-height', newheightformainmodal + 'px');
    }
    if (jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_top').hasClass('arform_bottom_fixed_block_open')) {
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_top').removeClass('arform_bottom_fixed_block_open');
    } else {
        var form_key = jQuery('[data-id="form_key_' + id + '"]').val();
        
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
        jQuery('.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_top').addClass('arform_bottom_fixed_block_open');
        var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
        if (typeof is_ssl_replace != 'function') {
            return;
        }
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
        var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
            var id = jQuery(this).attr('id');
            id = id.replace('field_', '');
            jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
            var file_data = jQuery(this)[0].files;
            for (var i = 0; i < file_data.length; i++) {
                var fileName = file_data[i].name;
                fileName = fileName.replace(/C:\\fakepath\\/i, '');
                if (fileName != '') {
                    var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                    if (old_file_name == 'No file selected') {
                        old_file_name = '';
                    }
                    if (old_file_name != '') {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                    } else {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                    }
                }
            }
        });
        
        applycheckstyleprop = 1;
        jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field = field.replace('like_', 'field_');
            if (jQuery("#" + field).is(':disabled')) {
                return false;
            }
            if (!jQuery("#" + field).is(':checked')) {
                jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
            }
        });
        jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
            var title = jQuery(this).attr('data-title');
            if (title !== undefined) {
                jQuery(this).arf_popover({
                    html: true,
                    trigger: 'hover',
                    placement: 'top',
                    content: title,
                    title: '',
                    animation: false
                });
            }
        });
        
        if (typeof arf_change_modal_slider != 'function') {
            return;
        }
        arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    }
    jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_top_main').slideToggle('500');
	setTimeout(function(){
		arforms_controls_obj.arforms_initialize_form_fields();
		arforms_pro_controls_obj.arforms_init_pro_fields();
	},510);
    if (applycheckstyleprop == 1) {
        var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
        data_open = (data_open !== undefined) ? data_open : true;
        if (checkradio_style_prop != "" && data_open == true) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
        }
        if (data_open == true) {
            
        }
    }
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('canvas.arf_do_canvas_resize').each(function(){
        var $this = jQuery( this );

        $this.css( 'max-width','100%' );

        var parent       = $this.parent();
        
        var parentWidth  = parseInt( parent.css( 'width' ) );
        var parentHeight = parseInt( parent.css( 'height' ) );

        $this.css( 'max-width','' );

        this.width  = parentWidth;
        this.height = parentHeight;
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }
    
    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        arf_pagebreak_startTimer( 'arf_date_time_countdown-' + id + '-' + popup_data_uniq_id );
    }
    
    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function arfmodalcolorpicker(id) {
    if (!id) {
        return;
    }
    jQuery('.arfhiddencolor').on('focus', function() {
        jQuery(this).parents('.arf_colorpicker_control').first().find('.arf_colorpicker, .arf_basic_colorpicker').first().trigger('click');
    });
    if (typeof jQuery().colpick == 'function') {
        jQuery("form.arfshowmainform").each(function() {
            var pcolor_data_id = jQuery(this).attr('data-id');
            var pcolor_curr_form = jQuery("form.arfshowmainform[data-id='" + pcolor_data_id + "']");
            pcolor_curr_form.find('.arf_colorpicker').colpick({
                layout: 'hex',
                submit: 1,
                color: 'ffffff',
                onBeforeShow: function() {
                    var fid = jQuery(this).attr('id');
                    var fid = fid.replace('arfcolorpicker_', '');
                    var color = pcolor_curr_form.find('#field_' + fid).val();
                    var new_color = color.replace('#', '');
                    if (new_color) {
                        jQuery(this).colpickSetColor(new_color);
                    }
                },
                onChange: function(hsb, hex, rgb, el, bySetColor) {
                    var field_key = jQuery(el).attr('id');
                    field_key = field_key.replace('arfcolorpicker_', '');
                    pcolor_curr_form.find('#field_' + field_key).val('#' + hex).trigger('change');
                    jQuery(el).find('.arfcolorvalue').text('#' + hex);
                    jQuery(el).find('.arfcolorvalue').css('background', '#' + hex);
                    var arffontcolor = HextoHsl(hex) > 0.5 ? '#000000' : '#ffffff';
                    jQuery(el).find('.arfcolorvalue').css('color', arffontcolor);
                },
                onSubmit: function() {
                    pcolor_curr_form.find('.arf_colorpicker').colpickHide();
                }
            });
        });
        jQuery('.colpick_hex_field').find('input').bind('paste', function(event) {
            event.preventDefault();
            var clipboardData = event.originalEvent.clipboardData.getData('text');
            clipboardData = clipboardData.replace('#', '');
            jQuery(this).val(clipboardData).trigger('change');
        });
    }
    if (typeof jQuery().simpleColorPicker == 'function') {
        jQuery("form.arfshowmainform").each(function() {
            var pscolor_data_id = jQuery(this).attr('data-id');
            var pscolor_curr_form = jQuery("form.arfshowmainform[data-id='" + pscolor_data_id + "']");
            pscolor_curr_form.find('.arf_basic_colorpicker').simpleColorPicker({
                onChangeColor: function(color) {
                    var field_key = jQuery(this).attr('id');
                    field_key = field_key.replace('colorpicker_div_', '');
                    pscolor_curr_form.find('#field_' + field_key).val(color).trigger('change');
                    jQuery(this).text(color);
                    jQuery(this).css('background', color);
                    var hex = color.replace('#', '');
                    var arffontcolor = HextoHsl(hex) > 0.5 ? '#000000' : '#ffffff';
                    if (hex == "ffff00") {
                        arffontcolor = "#000000";
                    }
                    jQuery(this).css('color', arffontcolor);
                }
            });
        });
    }
    jQuery('#popup-form-' + id).attr('data-open', 'false');
}

function open_modal_box_sitcky_left(id, height, width, checkradio_style_prop, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_sitcky_left_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }
    jQuery('body').addClass("arforms_model_sitcky_left_view_" + id);
    jQuery('.arf_pop_' + popup_data_uniq_id).find('#arf_sitcky_close_btn').remove();
    jQuery(document).ready(function($) {
        jQuery(".vpb_captcha").keypress(function() {
            jQuery(this).parents('.arfformfield').find('.popover').remove();
            jQuery(this).removeClass('control-group');
            jQuery(this).removeClass('arf_error');
        });
    });
    var admin_ajax_url = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="admin_ajax_url"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    admin_ajax_url = is_ssl_replace(admin_ajax_url);
    var _wpnonce = jQuery('#arforms_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: admin_ajax_url,
        data: "action=current_modal&position_modal=arf_modal_sitcky_left+&_wpnonce="+_wpnonce,
        success: function(errObj) {}
    });
    var screenwidth = jQuery(window).width();
    var modal_body_height = Number(height) - 140;
    var screenheight = jQuery(window).height();
    var newheightformainmodal = 0;
    if (height >= screenheight) {
        modal_body_height = screenheight - 55;
        newheightformainmodal = screenheight - 55;
    } else {
        modal_body_height = screenheight - 55;
        newheightformainmodal = Number(height);
    }
    var isMobile = arf_is_mobile();
    var modal_body_width = width;
    if (width >= screenwidth) {
        if( isMobile ){
            modal_body_width = screenwidth - 30;
            screenwidth = modal_body_width;
        } else {
            modal_body_width = screenwidth;
        }
        modal_body_width = screenwidth;
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('width', screenwidth + 'px');
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', screenwidth + 'px');
        var close_btn = '<button id="arf_sitcky_close_btn" onclick="open_modal_box_sitcky_left(' + "'" + id + "'" + ', ' + "'" + height + "'" + ', ' + "'" + width + "'" + ', ' + "'" + checkradio_style_prop + "'" + ', ' + "'" + checked_checkbox_prop + "'" + ', ' + "'" + checked_radio_prop + "'" + ', ' + "'" + popup_data_uniq_id + "'" + ');" style="z-index:99999; cursor:pointer; margin:5px 5px 0;" type="button" class="close" data-dismiss="arfmodal">x</button>';
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).prepend(close_btn);
    } else {
        modal_body_width = width;
        jQuery('.arf_pop_' + popup_data_uniq_id).find('#arf_sitcky_close_btn').remove();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', width + 'px');
    }
    if (height == 'auto') {
        var total_popup_height = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height();
        if (total_popup_height > screenheight) {
            modal_body_height = screenheight - (screenheight * 10 / 100);
            newheightformainmodal = screenheight - (screenheight * 10 / 100);
        }
    }
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (newheightformainmodal) + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (newheightformainmodal) + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('max-height', newheightformainmodal + 'px');
    if (jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_left').hasClass('arform_bottom_fixed_block_open')) {
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_left').removeClass('arform_bottom_fixed_block_open');
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_left').animate({
            'margin-left': '0'
        }, 500);
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_left_main').animate({
            'margin-left': '-' + modal_body_width + 'px'
        }, 500);
    } else {
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_left_main').animate({
            'margin-left': '0'
        }, 500);
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_left').animate({
            'margin-left': modal_body_width + 'px'
        }, 500);
        var form_key = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_key_' + id + '"]').val();
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_left').addClass('arform_bottom_fixed_block_open');
        var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
        data_open = (data_open !== undefined) ? data_open : true;
        if (checkradio_style_prop != "" && data_open == true) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
        }
        if (data_open == true) {
            
        }
        
        var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
        if (typeof is_ssl_replace != 'function') {
            return;
        }
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
        var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
            var id = jQuery(this).attr('id');
            id = id.replace('field_', '');
            jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
            var file_data = jQuery(this)[0].files;
            for (var i = 0; i < file_data.length; i++) {
                var fileName = file_data[i].name;
                fileName = fileName.replace(/C:\\fakepath\\/i, '');
                if (fileName != '') {
                    var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                    if (old_file_name == 'No file selected') {
                        old_file_name = '';
                    }
                    if (old_file_name != '') {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                    } else {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                    }
                }
            }
        });
       
        jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field = field.replace('like_', 'field_');
            if (jQuery("#" + field).is(':disabled')) {
                return false;
            }
            if (!jQuery("#" + field).is(':checked')) {
                jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
            }
        });
        jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
            var title = jQuery(this).attr('data-title');
            if (title !== undefined) {
                jQuery(this).arf_popover({
                    html: true,
                    trigger: 'hover',
                    placement: 'top',
                    content: title,
                    title: '',
                    animation: false
                });
            }
        });
        
        if (typeof arf_change_modal_slider != 'function') {
            return;
        }
        arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    }
    var options1 = {
        direction: 'left'
    };
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();


    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }

    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        arf_pagebreak_startTimer( 'arf_date_time_countdown-' + id + '-' + popup_data_uniq_id );
    }
    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}

function open_modal_box_sitcky_right(id, height, width, checkradio_style_prop, checked_checkbox_prop, checked_radio_prop, popup_data_uniq_id) {
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    if(typeof arf_init_signature_class == 'function') {
        arf_init_signature_class();
    }
    if(typeof Init == 'function') {
        Init();
    }

    var arf_body_class = jQuery('body').attr('class').split(' ');
    var body_class = '';
    for (var i = 0; i < arf_body_class.length; i++) {
        body_class = arf_body_class[i].split('arforms_model_sitcky_right_view_');
        if (body_class[1] != 'undefined' && /[\d+]/.test(body_class[1])) {
            jQuery('body').removeClass(arf_body_class[i]);
        }
    }
    jQuery('body').addClass("arforms_model_sitcky_right_view_" + id);
    jQuery('.arf_pop_' + popup_data_uniq_id).find('#arf_sitcky_close_btn').remove();
    jQuery(document).ready(function($) {
        jQuery(".vpb_captcha").keypress(function() {
            jQuery(this).parents('.arfformfield').find('.popover').remove();
            jQuery(this).removeClass('control-group');
            jQuery(this).removeClass('arf_error');
        });
    });
    var admin_ajax_url = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="admin_ajax_url"]').val();
    if (typeof is_ssl_replace != 'function') {
        return;
    }
    admin_ajax_url = is_ssl_replace(admin_ajax_url);
    var _wpnonce = jQuery('#arforms_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: admin_ajax_url,
        data: "action=current_modal&position_modal=arf_modal_bottom+&_wpnonce="+_wpnonce,
        success: function(errObj) {}
    });
    var screenwidth = jQuery(window).width();
    var modal_body_height = Number(height) - 140;
    var screenheight = jQuery(window).height();
    var newheightformainmodal = 0;
    if (height >= screenheight) {
        modal_body_height = screenheight - 55;
        newheightformainmodal = screenheight - 55;
    } else {
        modal_body_height = screenheight - 55;
        newheightformainmodal = Number(height);
    }
    var isMobile = arf_is_mobile();
    var modal_body_width = width;
    if (width >= screenwidth) {
        if( isMobile ){
            modal_body_width = screenwidth - 30;
            screenwidth = modal_body_width;
        } else {
            modal_body_width = screenwidth;
        }
        jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('width', screenwidth + 'px');
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', screenwidth + 'px');
        var close_btn = '<button id="arf_sitcky_close_btn" onclick="open_modal_box_sitcky_right(' + "'" + id + "'" + ', ' + "'" + height + "'" + ', ' + "'" + width + "'" + ', ' + "'" + checkradio_style_prop + "'" + ', ' + "'" + checked_checkbox_prop + "'" + ', ' + "'" + checked_radio_prop + "'" + ', ' + "'" + popup_data_uniq_id + "'" + ');" style="z-index:99999; float:left; cursor:pointer; margin:5px 5px 0;" type="button" class="close" data-dismiss="arfmodal">x</button>';
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).prepend(close_btn);
    } else {
        modal_body_width = width;
        jQuery('.arf_pop_' + popup_data_uniq_id).find('#arf_sitcky_close_btn').remove();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.arf_form.ar_main_div_' + id).css('max-width', width + 'px');
    }
    if (height == 'auto') {
        var total_popup_height = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).height();
        if (total_popup_height > screenheight) {
            modal_body_height = screenheight - (screenheight * 10 / 100);
            newheightformainmodal = screenheight - (screenheight * 10 / 100);
        }
    }
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('max-height', (newheightformainmodal) + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).css('height', (newheightformainmodal) + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('height', modal_body_height + 'px');
    jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id + ' .arfmodal-body').css('max-height', newheightformainmodal + 'px');
    if (jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_right').hasClass('arform_bottom_fixed_block_open')) {
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_right').removeClass('arform_bottom_fixed_block_open');
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_right').animate({
            'margin-right': '0'
        }, 500);
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_right_main').animate({
            'margin-right': '-' + modal_body_width + 'px'
        }, 500);
    } else {
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_form_block_right_main').animate({
            'margin-right': '0'
        }, 500);
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_right').animate({
            'margin-right': modal_body_width + 'px'
        }, 500);
        var form_key = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_key_' + id + '"]').val();
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).find('.arfmodal-body .arf_content_another_page').empty().hide();
        jQuery('#arf-popup-form-' + id + '.arf_popup_' + popup_data_uniq_id).find('.arform_bottom_fixed_block_right').addClass('arform_bottom_fixed_block_open');
        var data_open = jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open');
        data_open = (data_open !== undefined) ? data_open : true;
        if (checkradio_style_prop != "" && data_open == true) {
            jQuery('#popup-form-' + id + '.arf_pop_' + popup_data_uniq_id).attr('data-open', 'false');
        }
        if (data_open == true) {
        }
        var arfmainformurl = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="arfmainformurl"]').val();
        if (typeof is_ssl_replace != 'function') {
            return;
        }
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        arfmainformurl = is_ssl_replace(arfmainformurl);
        var url = arffiledragurl + '/js/filedrag/filedrag_front.js';
        var submit_type = jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-id="form_submit_type"]').val();
        jQuery('.arf_pop_' + popup_data_uniq_id).find('.original_normal').on('change', function(e) {
            var id = jQuery(this).attr('id');
            id = id.replace('field_', '');
            jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html('');
            var file_data = jQuery(this)[0].files;
            for (var i = 0; i < file_data.length; i++) {
                var fileName = file_data[i].name;
                fileName = fileName.replace(/C:\\fakepath\\/i, '');
                if (fileName != '') {
                    var old_file_name = jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html();
                    if (old_file_name == 'No file selected') {
                        old_file_name = '';
                    }
                    if (old_file_name != '') {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(old_file_name + ', ' + fileName);
                    } else {
                        jQuery('.arf_pop_' + popup_data_uniq_id).find('#file_name_' + id).html(fileName);
                    }
                }
            }
        });
        
        jQuery('.arf_like_btn, .arf_dislike_btn').not('.field_edit, .field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field = field.replace('like_', 'field_');
            if (jQuery("#" + field).is(':disabled')) {
                return false;
            }
            if (!jQuery("#" + field).is(':checked')) {
                jQuery("#" + field).trigger('click').trigger('change').trigger('keyup');
            }
        });
        jQuery('.arf_like_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_dislike_btn').not('.field_in_list').on("click", function() {
            var field = jQuery(this).attr('id');
            var field_data = field.split('-');
            var field_id = field_data[0];
            var field2 = field_id.replace('like_', 'field_');
            var field3 = field_id.replace('like_', '');
            var likeactivecolor = jQuery('.active_dislike_bgcolor_' + field3).val();
            var dislikeactivecolor = jQuery('.active_like_bgcolor_' + field3).val();
            var like = field_data[1];
            if (like == 1) {
                jQuery('#' + field_id + '-0').removeClass('active');
                jQuery('#' + field_id + '-1').addClass('active');
                jQuery('#' + field_id + '-1').css('background', likeactivecolor);
                jQuery('#' + field_id + '-0').css('background', '');
            } else if (like == 0) {
                jQuery('#' + field_id + '-1').removeClass('active');
                jQuery('#' + field_id + '-0').addClass('active');
                jQuery('#' + field_id + '-1').css('background', '');
                jQuery('#' + field_id + '-0').css('background', dislikeactivecolor);
            }
        });
        jQuery('.arf_like_btn, .arf_dislike_btn').each(function() {
            var title = jQuery(this).attr('data-title');
            if (title !== undefined) {
                jQuery(this).arf_popover({
                    html: true,
                    trigger: 'hover',
                    placement: 'top',
                    content: title,
                    title: '',
                    animation: false
                });
            }
        });
        
        if (typeof arf_change_modal_slider != 'function') {
            return;
        }
        arf_change_modal_slider(jQuery('.arf_pop_' + popup_data_uniq_id).find('[data-form-id="form_' + form_key + '"]')); 
    }
    var options_right = {
        direction: 'right'
    };
    arfmodalcolorpicker(popup_data_uniq_id);
    jQuery('.arf_pop_' + popup_data_uniq_id ).find('.arf_phone_utils').each(function(){
        if( jQuery(this).parents('.intl-tel-input').length == 0 ){
            var field_id = jQuery(this).attr('id');
            jQuery(this).unwrap('iti');
            jQuery(this).parent().find('.iti').remove();
            var fkey = 'field_'+field_id;
            window.phone_fields[fkey] = window.intlTelInput(this,{
                preferredCountries:[],
                dropdownContainer:null,
                autoPlaceholder:'aggressive'
            });

            var selected_country = jQuery('#'+field_id+'_default_country').val();
            if( selected_country != '' ){
                window.phone_fields[fkey].setCountry(selected_country);
            }
        }
    });
    if( typeof arf_footer_cl_logic_call == 'function' ){
        window.is_model_form = true;
        setTimeout(function(){
            arf_footer_cl_logic_call();
        },1000);
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();


    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }
    
    var arfpagebreaktimer = form.find('input[name="arfpagebreakaddtimer_' + id  +'"]').val();
    if( arfpagebreaktimer == 1 ){
        arf_pagebreak_startTimer( 'arf_date_time_countdown-' + id + '-' + popup_data_uniq_id );
    }
    if( form.find('.arf_fieldset').hasClass('arf_materialize_form') ){
        arf_material_style_init();
    }
}
jQuery(document).on('click', '.close_btn', function() {
    var form_id = jQuery(this).attr('data-form-id');
    var unique_id = jQuery(this).attr('data-poup-unique-id');
    jQuery('#popup-form-' + form_id + '.arf_pop_' + unique_id + '.arf_active').addClass('fade_out').removeClass('arf_active');
    jQuery(".arfmodal-backdrop").removeClass('arf_active');
    jQuery(".arfmodal-backdrop").css('opacity', '0');
    jQuery('html').css('overflow','');
    var timeout_temp = setTimeout(function() {
        jQuery(".arfmodal-backdrop").remove();
        clearTimeout(timeout_temp);
    }, 700);
    setTimeout( function(){
        jQuery('#popup-form-' + form_id + '.arf_pop_' + unique_id + '.arf_active').removeClass('fade_out')
    },2000);
});
jQuery(document).on('click', '.arfmodal-backdrop:not(.hide_close_btn)', function() {
    jQuery('.arfmodal.arf_active').find('.close_btn').trigger('click');
});
jQuery(document).on('click','.arfmodal-body',function(e){
    if( !jQuery(e.target).hasClass('arf_fieldset') && jQuery(e.target).parents('.arfmodal').length < 1 && !jQuery(e.target).parents('.arfmodal').hasClass('arfmodal-fullscreen') ){
        if( jQuery('.arfmodal.arf_active').find('.close_btn').is(':visible') ){
            jQuery('.arfmodal.arf_active').find('.close_btn').trigger('click');     
        }
    }
});
jQuery(document).on('keydown', function(e) {
    if (e.keyCode == 27 && jQuery('.arfmodal-backdrop:not(.hide_close_btn)').length > 0) {
        jQuery('.arfmodal-backdrop:not(.hide_close_btn)').trigger('click');
    }
});

jQuery(window).on("resize",function(){
    var arf_active_popup = jQuery('.arfmodal.arf_active');
    if( arf_active_popup.length > 0 ){
        var screenheight = jQuery(window).height();
        var popup_body_height = arf_active_popup.find('.arf_form_outer_wrapper').height();
        jQuery('.arf_larger_popup').removeClass('arf_larger_popup');
        if( popup_body_height > screenheight ){
            arf_active_popup.addClass('arf_larger_popup');
        }
    }
});

function arf_is_mobile() { 
    if( navigator.userAgent.match(/Android/i) || navigator.userAgent.match(/webOS/i) || navigator.userAgent.match(/iPhone/i) || navigator.userAgent.match(/iPad/i) || navigator.userAgent.match(/iPod/i) || navigator.userAgent.match(/BlackBerry/i) || navigator.userAgent.match(/Windows Phone/i) ){
        return true;
    } else {
        return false;
    }
}

function arf_display_popup_again(id,popup_data_uniq_id){
    let is_elementor = document.getElementById('elementor_editor') || null;
    if( null != is_elementor && 'yes' == is_elementor.value ){
        return false;
    }
    let is_site_wide_popup = jQuery('#arf_form_site_wide_' + id ).val();

    if( 'yes' != is_site_wide_popup ){
        return true;
    }
    
    var is_exit_intent = jQuery('.arform_modal_link_' + id + '_' + popup_data_uniq_id ).hasClass('show_onexit_window');
    if( is_exit_intent ){
        var getSessionItem = getCookie( 'arf_exit_intent_modal_' + id );
        if( 'displayed' == getSessionItem ){
            return false;
        }
        document.cookie  = 'arf_exit_intent_modal_' + id + '=displayed;path=/';
    }

    var is_onload_popup = jQuery('.arform_modal_link_' + id + '_' + popup_data_uniq_id ).attr('data-onload') || false;

    if( '1' == is_onload_popup ){
        var getSessionItem = getCookie('arf_onload_model_' + id );
        if( 'displayed' == getSessionItem ){
            return false;
        }
        document.cookie = 'arf_onload_model_' + id + '=displayed;path=/';
    }

    var is_onscroll_popup = jQuery('.arform_modal_link_' + id + '_' + popup_data_uniq_id ).attr('data-onscroll') || false;

    if( '1' == is_onscroll_popup ){
        var getSessionItem = getCookie('arf_onscroll_model_' + id );
        if( 'displayed' == getSessionItem ){
            return false;
        }
        document.cookie = 'arf_onscroll_model_' + id + '=displayed;path=/';
    }

    var is_ontimer_popup = jQuery('.arform_modal_link_' + id + '_' + popup_data_uniq_id ).attr('data-ontimer') || false;

    if( '1' == is_ontimer_popup ){
        var getSessionItem = getCookie('arf_ontimer_model_' + id );
        if( 'displayed' == getSessionItem){
            return false;
        }

        document.cookie = 'arf_ontimer_model_' + id + '=displayed;path=/';
    }

    var is_idle_popup = jQuery('.arform_modal_link_' + id + '_' + popup_data_uniq_id ).attr('data-onidle') || false;
    if( '1' == is_idle_popup ){
        var getSessionItem = getCookie('arf_idle_model_' + id );
        if( 'displayed' == getSessionItem ){
            return false;
        }
        document.cookie = 'arf_idle_model_' + id + '=displayed;path=/';
    }

    var form = jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]');
    var id = form.find('input[data-id="form_id"]').val();
    var animation_val = jQuery('#arf_field_animation_style_front_'+id).val();
    var animation_duration = jQuery('#arf_field_animation_duration_front_'+id).val();
    var animation_delay = jQuery('#arf_field_animation_delay_front_'+id).val();

    if( jQuery('form[data-popup-id="'+ popup_data_uniq_id +'"]').hasClass('arfpagebreakform') ){
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('#page_0').find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('#page_0').find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });
        }   
    }else{
        if( '' != animation_val ){
            var arf_field_cntr_total = form.find('.control-group:not(.arfemptyfield)').length;
            var arf_cntr = 0;
            form.find('.control-group:not(.arfemptyfield)').each(function() {
                arf_cntr += 1;
                var animation_element = '#'+jQuery(this).attr('id');
                animateCSS(animation_element, animation_val, animation_duration, animation_delay, arf_cntr, arf_field_cntr_total);
            });            
        }            
    }

    return true;
}