"use strict";
function show_form_settimgs(id1, id2, id3) {

    if (id1 == "analytics") {
        if ( typeof change_graph_new != "function" ) {
            return;
        }
        change_graph_new("monthly");
    }
    document.getElementById(id1).style.display = 'block';
    if( document.getElementById(id2) ){
        document.getElementById(id2).style.display = 'none';
    }
    if( document.getElementById(id3) ){
        document.getElementById(id3).style.display = 'none';
    }
    document.getElementById('arfcurrenttab').value = id1;
    if( 'form_incomplete_entries' == id1 ){
        var dataTables = jQuery.fn.DataTable.fnTables();
        var is_init = false;
        jQuery(dataTables).each(function(){
            if( this.id == 'example2' ){
                is_init = true;
                return false;
            }
        });
        if( !is_init ){
            arf_init_incomplete_form_entries();
        }
    }

    jQuery('.' + id1).addClass('btn_sld').removeClass('tab-unselected');
    jQuery('#' + id1 + '_img').attr('src', '<?php echo ARFIMAGESURL; ?>/' + id1 + '.png');

    jQuery('.' + id2).removeClass('btn_sld').addClass('tab-unselected');
    jQuery('#' + id2 + '_img').attr('src', '<?php echo ARFIMAGESURL; ?>/' + id2 + '_hover.png');

    jQuery('.' + id3).removeClass('btn_sld').addClass('tab-unselected');
    jQuery('#' + id3 + '_img').attr('src', '<?php echo ARFIMAGESURL; ?>/' + id3 + '_hover.png');
}

function change_graph_new(val,change_graph_type) {
    
    jQuery('#arfgraphval').val(val);
    var form = jQuery('#arfredirecttolist3').val();
    var type = val;
    var graph_type = jQuery('input[name=arfgraphtype]:checked').val();
    var main_url = jQuery("[data-id='arfmainformurl']").val();
    if(jQuery("#"+val + "_selected").is(":visible") && change_graph_type != 1){
        return false;
    }
    if (val == "daily") {
        document.getElementById(val + "_unselected").style.display = "none";
        document.getElementById(val + "_selected").style.display = "block";
        document.getElementById("monthly_selected").style.display = "none";
        document.getElementById("monthly_unselected").style.display = "block";
        document.getElementById("yearly_selected").style.display = "none";
        document.getElementById("yearly_unselected").style.display = "block";
    } else if (val == "monthly") {
        console.log( val );
        document.getElementById(val + "_unselected").style.display = "none";
        document.getElementById(val + "_selected").style.display = "block";
        document.getElementById("daily_selected").style.display = "none";
        document.getElementById("daily_unselected").style.display = "block";
        document.getElementById("yearly_selected").style.display = "none";
        document.getElementById("yearly_unselected").style.display = "block";
    } else if (val == "yearly") {
        document.getElementById(val + "_unselected").style.display = "none";
        document.getElementById(val + "_selected").style.display = "block";
        document.getElementById("daily_selected").style.display = "none";
        document.getElementById("daily_unselected").style.display = "block";
        document.getElementById("monthly_selected").style.display = "none";
        document.getElementById("monthly_unselected").style.display = "block";
    }
    var _wpnonce = jQuery('#arforms_wp_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        beforeSend: function() {
            jQuery('div#arf_full_width_loader').hide();
            jQuery('div#arf_graph_changes_loader').show();
        },
        data: "action=updatechart&_wpnonce=" + _wpnonce +"&type=" + type + "&form=" + form+ "&graph_type=" + graph_type,
        success: function(msg) {
            jQuery('div#arf_full_width_loader').hide();
            jQuery('div#arf_graph_changes_loader').hide();
            jQuery('#chart_div').html(msg);
        }
    });
}

jQuery(document).on('click', '#example_wrapper2 .ColVis_Button:not(.ColVis_MasterButton)', function(){

    var colsArray = jQuery('#example_wrapper2 .ColVis_Button:not(.ColVis_MasterButton)').map(function () {
        return [[ encodeURIComponent(jQuery(this).find('.ColVis_title').text()), jQuery(this).hasClass('active') ? 'visibile' : 'hidden']];
    }).get();

    var form = jQuery('#arfredirecttolist2').val();

    if (form == '') {
        return false;
    }
    
    jQuery.ajax({
        type:"POST",
        url: ajaxurl,
        data: "action=manageincompletecolumns&colsArray=" + colsArray + '&form=' + form,
        success: function( msg ){
            var wrapper_width = jQuery(".frm_incomplete_entries_page #example2_wrapper").outerWidth();
            var table_head_width = jQuery(".frm_incomplete_entries_page table#example2 thead").outerWidth();

            if( table_head_width >= wrapper_width ){
                jQuery('.frm_incomplete_entries_page table#example2').css('display','block');
            } else {
                jQuery('.frm_incomplete_entries_page table#example2').css('display','');
            }
        }
    });

});

function arf_init_incomplete_form_entries(){

    var data_array_size = jQuery('#data_array_size').val();
    if (data_array_size > 0) {
        var paginate = true;
    } else {
        var paginate = false;
    }
    jQuery.fn.dataTableExt.oPagination.four_button = arf_dataTable_pagination();

    var form_id = jQuery("#form_id").val();
    
    if( form_id > 0 && data_array_size > 0 ){
        arf_load_incomplete_form_entries_grid( paginate );
    }

    var locale = jQuery("#locale").val();
    var date_format_new = jQuery("#date_format_new").val();
    var start_date_new = jQuery("#start_date_new").val();
    var end_date_new = jQuery("#end_date_new").val();
    var date_format_new1 = jQuery("#date_format_new1").val();

    jQuery("#datepicker_from2").datetimepicker({
        useCurrent: true,
        format: date_format_new,
        locale: locale,
        minDate: moment(start_date_new, date_format_new1),
        maxDate: moment(end_date_new, date_format_new1)
    });

    jQuery("#datepicker_to2").datetimepicker({
        useCurrent: false,
        format: date_format_new,
        locale: locale,
        minDate: moment(start_date_new, date_format_new1),
        maxDate: moment(end_date_new, date_format_new1)
    });

    jQuery("#datepicker_from2").on("dp.change", function (e) {
        jQuery("#datepicker_to2").data("DateTimePicker").minDate(e.date);
    });
    jQuery("#datepicker_to2").on("dp.change", function (e) {
        jQuery("#datepicker_from2").data("DateTimePicker").maxDate(e.date);
    });

    var exclude_sorting = JSON.parse( jQuery("#arf_incomplete_entries_exclude_cols").val() );
    var action_no = jQuery('#action_no').val();
    var exclude = jQuery("#exclude").val();
    var last_col = action_no - 1;
    var last_second_col = action_no - 2;
    var exclude_col = ( exclude != "" ) ? exclude : null;
    if( form_id < 1 || data_array_size < 1 ){
        var dataTableOpt = {
            "oLanguage": {
                "sProcessing": "",
                "sEmptyTable": "There is no entry found",
                "sZeroRecords": "There is no entry found"
            },
            "language":{
                "searchPlaceholder": "Search",
                "search":"",
            },
            "buttons":[{
                "extend":"colvis",
                "columns":[1,2,3,4,5],
                "className":"ColVis_Button TableTools_Button ui-button ui-state-default ColVis_MasterButton",
                "text":"<span class=\"arfshowhideicon\"><svg width=\"30px\" height=\"30px\" viewBox=\"0 0 40 40\" class=\"arfsvgposition\"><path xmlns=\"http://www.w3.org/2000/svg\" fill-rule=\"evenodd\" clip-rule=\"evenodd\" fill=\"#3f74e7\" d=\"M9.489,8.85l0.023-2h6l-0.024,2H9.489z M9.489,2.85l0.023-2h6  l-0.024,2H9.489z M1.489,14.85l0.023-2h5.969l-0.023,2H1.489z M1.489,8.85l0.023-2h5.969l-0.023,2H1.489z M1.489,2.85l0.023-2h5.969  l-0.023,2H1.489z M15.512,12.85l-0.024,2H9.489l0.023-2H15.512z\"></path></svg></span>Show / Hide columns<span class=\"arfshowhideicon_span\" style=\"float: right;width: 15px;height: 15px;margin-top:2px;\"><svg id=\"drop_box_icon\" viewBox=\"0 0 30 30\" style=\"width: 20px;height: 20px;margin: 6px;\"><g id=\"drop_icon\"><path fill=\"black\" d=\"M6.777,6.845c-0.189,0-0.379-0.072-0.523-0.215L1.706,2.107c-0.289-0.288-0.289-0.754,0-1.042c0.29-0.288,0.759-0.288,1.048,0l4.023,4.001L10.8,1.066c0.289-0.287,0.758-0.287,1.047,0c0.289,0.288,0.289,0.754,0,1.042L7.3,6.629C7.156,6.773,6.966,6.845,6.777,6.845z\"></path></g></svg></span></span>",
            }],
            "sDom": '<"H"lCBfr>t<"footer"ip>',
            "sPaginationType": "four_button",
            "bJQueryUI": true,
            "bPaginate": paginate,
            "bInfo": paginate,
            "bAutoWidth": false,
            "bScrollCollapse": true,
            "oColVis": {
                "aiExclude": [0, action_no]
            },
            "aaSorting": [[1, 'desc']],
            "aoColumnDefs": [
                {"sType": "html", "bVisible": false, "aTargets": [exclude_col]},
                {"bSortable": false, "aTargets": exclude_sorting}
            ],
            "fnDrawCallback": function (oSettings) {
                jQuery(".arf_loader_icon_wrapper").hide();
                jQuery('.arfhelptip').tipso('destroy');
                jQuery('.arfhelptip').tipso({
                    position: 'top',
                    maxWidth: '400',
                    useTitle: true,
                    background: '#444444',
                    color: '#ffffff',
                    width: 'auto'
                });
            }
        };

        var oTables = jQuery('#example2').dataTable(dataTableOpt);

    }

    var wrapper_width = jQuery(".frm_incomplete_entries_page #example2_wrapper").outerWidth();
    var table_head_width = jQuery(".frm_incomplete_entries_page table#example2 thead").outerWidth();
    
    if( table_head_width >= wrapper_width ){
        jQuery(".frm_incomplete_entries_page table#example2").css('display','block');
    } else {
        jQuery(".frm_incomplete_entries_page table#example2").css('display','');
    }
}

function apply_bulk_action2(){
    
    var form = jQuery("#arfredirecttolist2").val();
    var start_date = jQuery('#datepicker_from2').val();
    var end_date = jQuery("#datepicker_to2").val();
    var please_select_form = jQuery("#please_select_form").val();
    if( '' == form ){
        alert( please_select_form );
        return false;
    }
    var action1 = jQuery('input[name="action3"]').val();
    var action2 = jQuery('input[name="action4"]').val();
    var action_delete = jQuery('#delete_bulk_entry_flag').val();
    var chk_count = jQuery('input[name="item-action[]"]:checked').length;
    if (action1 == '-1' && action2 == '-1') {
        jQuery("#records_error_message_des").html(__ARF_SELECT_VALIDACTION_MSG);
        error_msg();
        return false;
    } else if ((action1 == 'bulk_delete' || action2 == 'bulk_delete') && chk_count == 0) {
        jQuery("#records_error_message_des").html(__ARF_SELECT_FIELD_TEXT);
        error_msg();
        return false;
    } else if ((action1 == 'bulk_csv' || action2 == 'bulk_csv') && chk_count == 0) {
        jQuery("#records_error_message_des").html(__ARF_SELECT_FIELD_TEXT);
        error_msg();
        return false;
    } else if ((action1 == 'move_to_entry' || action2 == 'move_to_entry') && chk_count == 0) {
        jQuery("#records_error_message_des").html(__ARF_SELECT_FIELD_TEXT);
        error_msg();
        return false;
    }
    if ((action1 == 'bulk_delete' || action2 == 'bulk_delete') && chk_count > 0) {
        if (action_delete == 'false') {
            arfchangedeletemodalwidth('arfdelete_model_box_incomplete');
            jQuery("#delete_bulk_incomplete_entry_message").parents('.arf_modal_overlay').addClass("arfactive");
            jQuery("#delete_bulk_incomplete_entry_message").addClass("arfactive");
            return false;
        }
    }
    jQuery('#delete_bulk_entry_flag').val('false');
    var str = jQuery("form#list_incomplete_entry_form").serialize();
    var _wpnonce = jQuery("#arforms_wp_nonce").val();
    jQuery.ajax({
        url: ajaxurl,
        type: 'POST',
        dataType: 'json',
        data: "action=arfchangebulkincompleteentries&form_id=" + form + "&start_date=" + start_date + "&end_date=" + end_date + "&" + str+ '&_wpnonce=' + _wpnonce,
        success: function(response) {
          
            if (response.error == false) {
                jQuery("#records_suc_message_des").html(response.message);
                success_msg();
                jQuery("#delete_bulk_incomplete_entry_message").parents('.arf_popup_container').removeClass('arfactive');
                jQuery('#frm_errors').delay(5000).fadeOut('slow');
                jQuery('#example2').DataTable().destroy();
                if (response.arftotrec != '') {
                    arf_load_incomplete_form_entries_grid(true, response.arftotrec);
                    jQuery('span.arf_incomplete_total_entry_'+form).html( response.arftotrec );
                    var li_element = jQuery('.arf_total_incomplete_li_'+form).html();
                    jQuery('.arf_total_incomplete_li_'+form).attr( 'data-label' ,li_element );
                    jQuery('.arf_total_incomplete_li_'+form).attr( 'data-label' , li_element );
                } else {
                    arf_load_incomplete_form_entries_grid(true);
                }
            } else {
                
                if ((action1 == 'bulk_csv' || action2 == 'bulk_csv') && response == false ) {
                    window.location.href = response;
                } else {
                    jQuery("#records_error_message_des").html(response.message);
                    error_msg();
                }
            }
            setTimeout(function() {
                var wrapper_width = jQuery(".frm_entries_page #example_wrapper").outerWidth();
                var table_width = jQuery(".frm_entries_page table#example").outerWidth();
                var table_head_width = jQuery(".frm_entries_page table#example thead").outerWidth();
                if (table_width >= wrapper_width && table_head_width >= wrapper_width) {
                    jQuery(".frm_entries_page table#example").css('display', 'block');
                } else {
                    jQuery(".frm_entries_page table#example").css('display', '');
                }
            }, 500);
        }
    });
    return false;
}
function arf_load_incomplete_form_entries_grid( paginate, arftotalrecords ){

    var form = jQuery("#arfredirecttolist2").val();
    var start_date = jQuery("#datepicker_from2").val();
    var end_date = jQuery("#datepicker_to2").val();
    var please_select_form = jQuery("#please_select_form").val();
    var action_column_width = jQuery("#action_column_width").val();
    var per_page_rec = (document.querySelector('[name="example_length"]') != null) ? document.querySelector('[name="example_length"]').value : 10;
    var current_page = document.getElementsByClassName('current_page_no')[0] || 1;
    if (form == '' || typeof form == 'undefined') {
        alert(please_select_form);
        return false;
    }
    var action_no = jQuery('#action_no').val();
    console.log( action_no );
    var exclude = jQuery("#exclude").val();
    action_no = parseInt( action_no );
    var last_col = action_no - 1;
    var last_second_col = action_no - 2;
    exclude = parseInt( exclude );
    var exclude_col = ( exclude != '' ) ? exclude : null;

    var nColVisCols = [];
    for( var cv = 1; cv < action_no; cv++ ){
        nColVisCols.push( cv );
    }

    var exclude_sorting = JSON.parse( jQuery("#arf_incomplete_entries_exclude_cols").val() );
    
    var oTableOpt = {
        "oLanguage": {
            "sProcessing": "",
            "sEmptyTable": "There is no entry found",
            "sZeroRecords": "There is no entry found"
        },
        "language":{
            "searchPlaceholder":"Search",
            "search":""
        },
        "buttons":[{
            "extend":"colvis",
            "columns":nColVisCols,
            "className":"ColVis_Button TableTools_Button ui-button ui-state-default ColVis_MasterButton",
            "text":"<span class=\"arfshowhideicon\"><svg width=\"30px\" height=\"30px\" viewBox=\"0 0 40 40\" class=\"arfsvgposition\"><path xmlns=\"http://www.w3.org/2000/svg\" fill-rule=\"evenodd\" clip-rule=\"evenodd\" fill=\"#3f74e7\" d=\"M9.489,8.85l0.023-2h6l-0.024,2H9.489z M9.489,2.85l0.023-2h6  l-0.024,2H9.489z M1.489,14.85l0.023-2h5.969l-0.023,2H1.489z M1.489,8.85l0.023-2h5.969l-0.023,2H1.489z M1.489,2.85l0.023-2h5.969  l-0.023,2H1.489z M15.512,12.85l-0.024,2H9.489l0.023-2H15.512z\"></path></svg></span>Show / Hide columns<span class=\"arfshowhideicon_span\" style=\"float: right;width: 15px;height: 15px;margin-top:2px;\"><svg id=\"drop_box_icon\" viewBox=\"0 0 30 30\" style=\"width: 20px;height: 20px;margin: 6px;\"><g id=\"drop_icon\"><path fill=\"black\" d=\"M6.777,6.845c-0.189,0-0.379-0.072-0.523-0.215L1.706,2.107c-0.289-0.288-0.289-0.754,0-1.042c0.29-0.288,0.759-0.288,1.048,0l4.023,4.001L10.8,1.066c0.289-0.287,0.758-0.287,1.047,0c0.289,0.288,0.289,0.754,0,1.042L7.3,6.629C7.156,6.773,6.966,6.845,6.777,6.845z\"></path></g></svg></span></span>",
        }],
        "bProcessing": true,
        "bServerSide": true,
        "sAjaxSource": ajaxurl,
        "sServerMethod": "POST",
        "fnServerParams": function (aoData) {
            aoData.push({'name': 'action', 'value': 'arf_retrieve_form_incomplete_entry'});
            aoData.push({'name': 'form', 'value': form});
            aoData.push({'name': 'start_date', 'value': start_date});
            aoData.push({'name': 'end_date', 'value': end_date});
        },
        "bRetrieve": false,
        "sDom": '<"H"lCBfr>t<"footer"ip>',
        "sPaginationType": "four_button",
        "bJQueryUI": true,
        "bPaginate": paginate,
        "bAutoWidth": false,
        "bInfo": paginate,
        "bScrollCollapse": true,
        "oColVis": {
            "aiExclude": [0, action_no]
        },
        "aaSorting": [[1, 'desc']],
        "aLengthMenu": [10, 25, 50, 100, 200],
        "aoColumnDefs": [
            { "sType": "html", "bVisible": false, "aTargets": [exclude_col] }, 
            { "sClass": "box", "aTargets": [0] }, 
            { "sClass": "arf_col_action arf_action_cell", "aTargets": [action_no] }, 
            { "bSortable": false, "aTargets": exclude_sorting }
        ],
        
        "fnPreDrawCallback": function () {
            jQuery(".arf_loader_icon_wrapper").show();
        },
        "fnDrawCallback": function (oSettings) {

            jQuery(".arf_loader_icon_wrapper").hide();
            jQuery("#cb-select-all-1").prop("checked", false);
            if(arftotalrecords != '' && arftotalrecords != undefined){
                var form_list_item = jQuery('ul[data-id="arfredirecttolist2"]').find('li[data-value="'+form+'"]');
                var label = form_list_item.attr('data-label');
                var text = form_list_item.html();

                var pattern = /\(\d+\)/gi;
                var matches, matches2;
                if( matches = label.match(pattern) ){
                    var match_len = matches.length;
                    for( var m1 = 0; m1 < match_len; m1++ ){
                        var temp_counter = matches[m1];
                        label = label.replace(temp_counter,'('+arftotalrecords+')');
                    }
                    form_list_item.attr('data-label',label);
                }
                if( matches2 = text.match(pattern) ){
                    var match_len = matches2.length;
                    for( var m1 = 0; m1 < match_len; m1++ ){
                        var temp_counter = matches2[m1];
                        text = text.replace(temp_counter,'('+arftotalrecords+')');
                    }
                    form_list_item.html(text);
                    jQuery('dl[data-name="arfredirecttolist"] dt span').html(text);
                }
            }

            var wrapper_width = jQuery(".frm_incomplete_entries_page #example2_wrapper").outerWidth();
            var table_head_width = jQuery(".frm_incomplete_entries_page table#example2 thead").outerWidth();

            if( table_head_width >= wrapper_width ){
                jQuery(".frm_incomplete_entries_page table#example2").css('display','block');
            } else {
                jQuery(".frm_incomplete_entries_page table#example2").css('display','');
            }

            jQuery('.arf_status_unread').parents('tr').addClass( 'arf_unread_entry' );

            jQuery('.arfhelptip').tipso('destroy');
            jQuery('.arfhelptip').tipso({
                position: 'top',
                maxWidth: '400',
                useTitle: true,
                background: '#444444',
                color: '#ffffff',
                width: 'auto'
            });
        }
    };
    var oTables = jQuery('#example2').dataTable(oTableOpt);
}

function arf_delete_single_incompelete_entry( entry_id ){
    var _wpnonce = jQuery("#arforms_wp_nonce").val();
    var form = jQuery("#arfredirecttolist2").val();
    jQuery.ajax({
        url: ajaxurl,
        type: 'POST',
        dataType:'json',
        data: 'action=arf_delete_single_incompelete_entry&entry_id=' + entry_id + '&form_id=' + form + '&_wpnonce=' + _wpnonce,
        success: function(response){
            
            if (response.error == false) {
                jQuery("#records_suc_message_des").html(response.message);
                success_msg();
                jQuery("#delete_form_message").parents('.arf_popup_container').removeClass('arfactive');
                jQuery('#frm_errors').delay(5000).fadeOut('slow');
                jQuery("#delete_form_message").parents('.arf_modal_overlay').removeClass('arfactive');
                jQuery("#delete_form_message").removeClass('arfactive');
                if (response.arftotrec != '' && response.arftotrec > 0) {
                    jQuery(".arfentry_delete_div_" + entry_id).parents('tr').remove();
                    jQuery('span.arf_incomplete_total_entry_'+form).html( response.arftotrec );
                    var li_element = jQuery('.arf_total_incomplete_li_'+form).html();
                    jQuery('.arf_total_incomplete_li_'+form).attr( 'data-label' , li_element );
                } else {
                    jQuery('#example2').DataTable().destroy();
                    arf_load_incomplete_form_entries_grid(true, 0);
                }
            } else {
                jQuery("#records_error_message_des").html(response.message);
                error_msg();
            }
        }
    });
}

jQuery(document).on('click','#arf_move_single_incomplete_entry', function(){
    var entry_id = jQuery(this).attr('data-id');;
    var form_id = jQuery(this).attr('data-form-id');
    var _wpnonce = jQuery("#arforms_wp_nonce").val();
    jQuery.ajax({
        url:ajaxurl,
        type:'POST',
        dataType:'json',
        data:'action=arf_move_incomplete_entry&id=' + entry_id + '&form_id=' + form_id + '&_wpnonce=' + _wpnonce,
        success:function(response){
            if( response.error == true ){
                jQuery("#records_error_message_des").html( response.message );
                error_msg();
            } else {
                var dataTables = jQuery.fn.DataTable.fnTables();
                var is_init = false;
                jQuery(dataTables).each(function(){
                    if( this.id == 'example2' ){
                       is_init = true;
                        return false;
                    }
                });
                if( is_init ){
                    jQuery('#example2').DataTable().destroy();
                    arf_init_incomplete_form_entries();
                } else {
                    arf_init_incomplete_form_entries();
                }
            }
        }
    });
});

jQuery(document).on('click', '#arf_delete_single_incomplete_entry', function(){
    var id = jQuery(this).attr('data-id');

    if (id == null || id == 'undefined') {
        return;
    }

    var delete_popup_html = '';
    delete_popup_html += '<div class="delete_popup delete_entry_popup arfactive delete_entry_message_' + id + '" id="delete_form_message">';
    delete_popup_html += '<input type="hidden" value="' + id + '" id="delete_entry_id"/>';
    delete_popup_html += '<div class="delete_column_arrow" style="position:absolute;"></div>';
    delete_popup_html += '<div class="delete_title"><div class="delete_confirm_message">'+__ARF_DEL_ENTRY_MSG+'</div>';
    delete_popup_html += '<div class="delete_popup_footer">';
    delete_popup_html += '<button type="button" class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arfincompleteentryactionfunc(\'delete\', ' + id + ');">'+__ARF_DELETE_TEXT+'</button>&nbsp;&nbsp;';
    delete_popup_html += '<button type="button" class="rounded_button delete_button arfdelete_color_gray" onclick="arf_delete_close_popup_entry(' + id + ');">'+__ARF_CANCEL_TEXT+'</button>';
    delete_popup_html += '</div>';
    delete_popup_html += '</div>';
    delete_popup_html += '</div>';
    var select_content = jQuery(this).parent('.arfentry_delete_div_' + id).find('#arf_delete_single_incomplete_entry');
    jQuery(delete_popup_html).insertAfter(select_content);
    jQuery('.delete_entry_message_' + id).show();
});
jQuery(document).on('click', '.arf_view_entry', function(){
    var old_active_row = jQuery(".active_row");
    old_active_row.removeClass('active_row');
    jQuery(this).closest('tr').addClass('active_row');
    var current_row = jQuery(".active_row");
    var arf_first_entry_id = current_row.prev('tr').find("td:eq(1)").html();
    var arf_last_entry_id = current_row.next('tr').find("td:eq(1)").html();    
    if ( arf_first_entry_id == '' || arf_first_entry_id == undefined ) {
        jQuery('#arf_prev_entry_button').css('cursor', 'no-drop');
        jQuery('#arf_prev_entry_button').css('opacity', '0.5');
        jQuery('#arf_prev_entry_button').attr('disabled', true);
    } else {
        jQuery('#arf_prev_entry_button').css('cursor', '');
        jQuery('#arf_prev_entry_button').css('opacity', '');
        jQuery('#arf_prev_entry_button').attr('disabled', false);
    }

    if ( arf_last_entry_id == '' || arf_last_entry_id == undefined ) {
        jQuery('#arf_next_entry_button').css('cursor', 'no-drop');
        jQuery('#arf_next_entry_button').css('opacity', '0.5');
        jQuery('#arf_next_entry_button').attr('disabled', true);
    } else {
        jQuery('#arf_next_entry_button').css('cursor', '');
        jQuery('#arf_next_entry_button').css('opacity', '');
        jQuery('#arf_next_entry_button').attr('disabled', false);
    }
});

jQuery(document).on('click', '.arf_incomplete_view_entry', function(){
    var old_active_row = jQuery(".active_row");
    old_active_row.removeClass('active_row');

    jQuery(this).closest('tr').addClass('active_row');
    var current_row = jQuery(".active_row");
    var arf_first_entry_id = current_row.prev('tr').find("td:eq(1)").html();
    var arf_last_entry_id = current_row.next('tr').find("td:eq(1)").html();
    
    if ( arf_first_entry_id == '' || arf_first_entry_id == undefined ) {
        jQuery('#arf_prev_incomplete_entry_button').css('cursor', 'no-drop');
        jQuery('#arf_prev_incomplete_entry_button').css('opacity', '0.5');
        jQuery('#arf_prev_incomplete_entry_button').attr('disabled', true);
    } else {
        jQuery('#arf_prev_incomplete_entry_button').css('cursor', '');
        jQuery('#arf_prev_incomplete_entry_button').css('opacity', '');
        jQuery('#arf_prev_incomplete_entry_button').attr('disabled', false);
    }

    if ( arf_last_entry_id == '' || arf_last_entry_id == undefined ) {
        jQuery('#arf_next_incomplete_entry_button').css('cursor', 'no-drop');
        jQuery('#arf_next_incomplete_entry_button').css('opacity', '0.5');
        jQuery('#arf_next_incomplete_entry_button').attr('disabled', true);
    } else {
        jQuery('#arf_next_incomplete_entry_button').css('cursor', '');
        jQuery('#arf_next_incomplete_entry_button').css('opacity', '');
        jQuery('#arf_next_incomplete_entry_button').attr('disabled', false);
    }
});
jQuery(document).on('click', ".frm_incomplete_entries_page #cb-select-all-1", function () {
    jQuery('input[name="item-action[]"]').prop('checked', this.checked);
});
jQuery(document).on('click', '.frm_incomplete_entries_page input[name="item-action[]"]', function () {
    if (jQuery('input[name="item-action[]"]').length == jQuery('input[name="item-action[]"]:checked').length) {
        jQuery("#cb-select-all-1").prop("checked", true);
    } else {
        jQuery("#cb-select-all-1").prop("checked", false);
    }
});

jQuery(document).on('click', '.frm_incomplete_entries_page .ColVis_Button:not(.ColVis_MasterButton)', function () {
    var colsArray = jQuery('.frm_incomplete_entries_page .ColVis_Button:not(.ColVis_MasterButton)').map(function () {
        return [[jQuery(this).find('.ColVis_title').text(), jQuery(this).hasClass('active') ? 'visibile' : 'hidden']];
    }).get();
    var form = jQuery('#arfredirecttolist').val();
    if (form == '') {
        return false;
    }
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: "action=manageincompleteentrycolumns&colsArray=" + colsArray + "&form=" + form,
        success: function (msg) {
            var wrapper_width = jQuery(".frm_entries_page #example_wrapper").outerWidth();
            var table_head_width = jQuery(".frm_entries_page table#example thead").outerWidth();
            
            if( table_head_width >= wrapper_width ){
                jQuery(".frm_entries_page table#example").css('display','block');
            } else {
                jQuery(".frm_entries_page table#example").css('display','');
            }
        }
    });
});
jQuery(document).on('click','#arf_prev_incomplete_entry_button',function(){
    var title = jQuery('#arf_view_incomplete_entry_modal_form_title').text();

    var current_row = jQuery(".active_row");
    var arf_prev_entry_id = current_row.prev('tr').find("td:eq(1)").html();
    var arf_first_entry_id = current_row.prev().prev('tr').find("td:eq(1)").html();
    jQuery('#arf_next_incomplete_entry_button').css('cursor', '');
    jQuery('#arf_next_incomplete_entry_button').css('opacity', '');
    jQuery('#arf_next_incomplete_entry_button').attr('disabled', false);

    if ( arf_first_entry_id == '' || arf_first_entry_id == undefined ) {
        jQuery('#arf_prev_incomplete_entry_button').css('cursor', 'no-drop');
        jQuery('#arf_prev_incomplete_entry_button').css('opacity', '0.5');
        jQuery('#arf_prev_incomplete_entry_button').attr('disabled', true);
    }

    if ( arf_prev_entry_id != '' && arf_prev_entry_id != undefined) {
        jQuery(".active_row").removeClass('active_row');
        current_row.prev('tr').addClass('active_row');
    }

   open_partial_entry_thickbox(arf_prev_entry_id, title.slice(1,-1));
});
jQuery(document).on('click','#arf_next_incomplete_entry_button',function(){
    var title = jQuery('#arf_view_incomplete_entry_modal_form_title').text();
    
    var current_row = jQuery(".active_row");
    var arf_next_entry_id = current_row.next('tr').find("td:eq(1)").html();
    var arf_last_entry_id = current_row.next().next('tr').find("td:eq(1)").html();
    jQuery('#arf_prev_incomplete_entry_button').css('cursor', '');
    jQuery('#arf_prev_incomplete_entry_button').css('opacity', '');
    jQuery('#arf_prev_incomplete_entry_button').attr('disabled', false);

    if ( arf_last_entry_id == '' || arf_last_entry_id == undefined ) {
        jQuery('#arf_next_incomplete_entry_button').css('cursor', 'no-drop');
        jQuery('#arf_next_incomplete_entry_button').css('opacity', '0.5');
        jQuery('#arf_next_incomplete_entry_button').attr('disabled', true);
    }
    
    if ( arf_next_entry_id != '' && arf_next_entry_id != undefined) {
        jQuery(".active_row").removeClass('active_row');
        current_row.next('tr').addClass('active_row');
    }
    
    open_partial_entry_thickbox(arf_next_entry_id, title.slice(1,-1));
});
jQuery(document).on('click','#arf_update_entry_button',function(){

    var is_edit_entries = jQuery('input#arf_is_edit_entries').val();
    
    if (is_edit_entries == 'yes') {
        jQuery("#arf_full_width_loader").show();

        var form = jQuery('#arfredirecttolist').val();
        var entry_id = jQuery('input#arf_is_edit_entries').attr('data-entry-id');
        var arf_row = jQuery('#view_entry_detail_container_' + entry_id).closest('tr').index();
        var new_values_fields = [];
        var new_values = [];
        var field_types = [];

        jQuery("input[name='arf_edit_form_field_values_"+entry_id+"[]']").each(function() {
            if(jQuery(this).hasClass('arf_changed_value')) {
                var field_id = jQuery(this).attr('data-id');
                var field_value = jQuery(this).val();
                var field_type = jQuery(this).parent().find('a[data-id='+field_id+']').attr('data-field-type');

                if (field_type === undefined) {
                    field_type = '';
                }

                if (jQuery.inArray(field_id, new_values_fields) == -1) {
                    new_values_fields.push(field_id);
                    new_values.push(field_value);
                    field_types.push(field_type);
                }
            }
        });

        jQuery("input[name^='arf_edit_matrix_field_values["+entry_id+"]']").each(function(){
            if( jQuery(this).hasClass('arf_changed_value') ){
                var field_id = jQuery(this).attr('data-id');
                var field_value = jQuery(this).val();
                var field_name = jQuery(this).attr('name');
                var field_attr_id = jQuery(this).attr('id');
                var fattrid = field_attr_id.split('_');
                var fcounter = fattrid[ fattrid.length - 1 ];
                var field_type = jQuery(this).parent().find('a[data-id="' + field_id +'"]').attr('data-field-type');
                
                if( typeof field_type == 'undefined' ){
                    field_type = '';
                }

                if( jQuery.inArray( field_id, new_values_fields ) == -1 ){
                    new_values_fields.push( field_id+'~|~'+ fcounter );
                    new_values.push(field_value);
                    field_types.push(field_type);
                }
            }
        });

        new_values_fields = new_values_fields.join("||");
        new_values = new_values.join("||");
        field_types = field_types.join("||");
        var _wpnonce = jQuery("#arforms_wp_nonce").val();
        jQuery.ajax({
            type: "POST",
            dataType: 'json',
            url: ajaxurl,
            data: "action=arf_edit_entry_values&arf_form=" + form + "&entry_id=" + entry_id + "&updatedfields="+new_values_fields + "&newvalues="+new_values+ "&field_types="+field_types+"&_wpnonce="+_wpnonce,
            success: function(response) {

                jQuery("input[name='arf_edit_form_field_values_"+entry_id+"[]']").removeClass('arf_changed_value');

                if(response.status == 'success'){
                    jQuery('#example').DataTable().destroy();
                    arf_load_form_entries_grid(true);
                    jQuery('input#arf_is_edit_entries').val('no').removeAttr('data-entry-id');
                    jQuery("#records_suc_message_des").html(response.message);
                    success_msg();

                } else {

                    jQuery("#arf_full_width_loader").hide();
                    jQuery('input#arf_is_edit_entries').val('no').removeAttr('data-entry-id');
                    jQuery("#records_error_message_des").html(response.message);
                    error_msg();

                }


            }
        });
    }

    var is_repeater_edit_entries = jQuery('input#arf_is_repeater_edit_entries').val();
    if( 'yes' == is_repeater_edit_entries ){
        jQuery("#arf_full_width_loader").show();
        var form = jQuery('#arfredirecttolist').val();
        var entry_id = jQuery('input#arf_is_repeater_edit_entries').attr('data-entry-id');
        var arf_row = jQuery('#view_entry_detail_container_' + entry_id).closest('tr').index();
        var total_inner_rows = jQuery('.arf_popup_container_view_entry_modal.arfactive table tbody tr:not(.arf_entry_verticle_view)').length;

        var new_values_fields = [];
        var new_values = [];
        var field_types = [];
        var data_counter = [];
        jQuery("input[name^='arf_edit_form_field_values_"+entry_id+"']").each(function() {
            if(jQuery(this).hasClass('arf_changed_value')) {
                var field_id = jQuery(this).attr('data-id');
                var field_value = jQuery(this).val();
                var counter_id = jQuery(this).attr('data-counter');
                var field_type = jQuery(this).parent().find('a[data-id='+field_id+']').attr('data-field-type');

                if (field_type === undefined) {
                    field_type = '';
                }

                if (jQuery.inArray(field_id, new_values_fields) == -1 || jQuery.inArray(counter_id, data_counter) == -1 ) {
                    new_values_fields.push(field_id);
                    new_values.push(field_value);
                    field_types.push(field_type);
                    data_counter.push(counter_id);
                }
            }
        });
        
        new_values_fields = new_values_fields.join("||");
        new_values = new_values.join("||");
        field_types = field_types.join("||");
        data_counter = data_counter.join('||');
        var _wpnonce = jQuery('#arforms_wp_nonce').val();
        jQuery.ajax({
            type:'POST',
            dataType:'json',
            url:ajaxurl,
            data: "action=arf_edit_repeater_entry_values&arf_form=" + form + "&entry_id=" + entry_id + "&updatedfields="+new_values_fields + "&newvalues="+new_values+ "&field_types="+field_types + "&counter=" + data_counter + "&total_rows=" + total_inner_rows + "&_wpnonce=" + _wpnonce,
            success:function(response){
                var ExampleData = jQuery("#example").DataTable();
                jQuery("#arf_full_width_loader").hide();
                jQuery('input#arf_is_repeater_edit_entries').val('no').removeAttr('data-entry-id');
                if(response.status == 'success'){
                    jQuery('#example').DataTable().destroy();
                    arf_load_form_entries_grid(true);
                    jQuery("#records_suc_message_des").html(response.message);
                    success_msg();
                } else {
                    jQuery("#records_error_message_des").html(response.message);
                    error_msg();
                }
            }
        });
    }

    var is_matrix_edit_entries = jQuery('input#arf_is_matrix_edit_entries').val();

    if( 'yes' == is_matrix_edit_entries ){
        jQuery("#arf_full_width_loader").show();

        var form = jQuery('#arfredirecttolist').val();
        var entry_id = jQuery('input#arf_is_matrix_edit_entries').attr('data-entry-id');
        var arf_row = jQuery('#view_entry_detail_container_' + entry_id).closest('tr').index();
        var new_values_fields = [];
        var new_values = [];
        var field_types = [];

        jQuery("input[name^='arf_edit_matrix_field_values["+entry_id+"]']").each(function(){
            if( jQuery(this).hasClass('arf_changed_value') ){
                var field_id = jQuery(this).attr('data-id');
                var field_value = jQuery(this).val();
                var field_name = jQuery(this).attr('name');
                var field_attr_id = jQuery(this).attr('id');
                var fattrid = field_attr_id.split('_');
                var fcounter = fattrid[ fattrid.length - 1 ];
                var field_type = jQuery(this).parent().find('a[data-id="' + field_id +'"]').attr('data-field-type');
                
                if( typeof field_type == 'undefined' ){
                    field_type = '';
                }

                if( jQuery.inArray( field_id, new_values_fields ) == -1 ){
                    new_values_fields.push( field_id+'~|~'+ fcounter );
                    new_values.push(field_value);
                    field_types.push(field_type);
                }
            }
        });

        new_values_fields = new_values_fields.join("||");
        new_values = new_values.join("||");
        field_types = field_types.join("||");
        _wpnonce = jQuery( "#arforms_wp_nonce" ).val();
        jQuery.ajax({
            type: "POST",
            dataType: 'json',
            url: ajaxurl,
            data: "action=arf_edit_entry_values&arf_form=" + form + "&entry_id=" + entry_id + "&updatedfields="+new_values_fields + "&newvalues="+new_values+ "&field_types="+field_types+"&_wpnonce="+_wpnonce,
            success: function(response) {

                jQuery("input[name='arf_edit_form_field_values_"+entry_id+"[]']").removeClass('arf_changed_value');

                if(response.status == 'success'){
                    jQuery('#example').DataTable().destroy();
                    arf_load_form_entries_grid(true);
                    jQuery('input#arf_is_matrix_edit_entries').val('no').removeAttr('data-entry-id');
                    jQuery("#records_suc_message_des").html(response.message);
                    success_msg();
                } else {

                    jQuery("#arf_full_width_loader").hide();
                    jQuery('input#arf_is_matrix_edit_entries').val('no').removeAttr('data-entry-id');
                    jQuery("#records_error_message_des").html(response.message);
                    error_msg();

                }


            }
        });
    }

    var is_file_upload_edit_entries = jQuery('input#arf_is_file_upload_edit_entries').val();

    if( 'yes' == is_file_upload_edit_entries && 'yes' != is_edit_entries && 'yes' != is_repeater_edit_entries && 'yes' != is_matrix_edit_entries ){
        jQuery("#arf_full_width_loader").show();
        setTimeout(function(){
            jQuery("#arf_full_width_loader").hide();
            jQuery('input#arf_is_file_upload_edit_entries').val('no').removeAttr('data-entry-id');
            jQuery('#example').DataTable().destroy();
            arf_load_form_entries_grid(true);
            jQuery("#records_suc_message_des").html('Record is updated successfully.');
            success_msg();
        }, 300);
    }

    jQuery('.arf_view_entry_modal.arfactive').parents('.arf_modal_overlay.arfactive').removeClass('arfactive');
    jQuery('.arf_view_entry_modal.arfactive').removeClass('arfactive');
    jQuery('.arf_repeater_view_entry_modal.arfactive').parents('.arf_modal_overlay.arfactive').removeClass('arfactive');
    jQuery('.arf_repeater_view_entry_modal.arfactive').removeClass('arfactive');
    jQuery('.arf_matrix_view_entry_modal.arfactive').parents('.arf_modal_overlay.arfactive').removeClass('arfactive');
    jQuery('.arf_matrix_view_entry_modal.arfactive').removeClass('arfactive');
    jQuery('.arf_matrix_view_incomplete_entry_modal.arfactive').parents('.arf_modal_overlay.arfactive').removeClass('arfactive');
    jQuery('.arf_matrix_view_incomplete_entry_modal.arfactive').removeClass('arfactive');
    jQuery('html').css('overflow',''); 
});
jQuery(document).on('click','#arf_incomplete_entry_modal_ok_btn', function(){
    jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive').parents('.arf_modal_overlay.arfactive').removeClass('arfactive');
    jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive').removeClass('arfactive');
    jQuery('html').css('overflow','');
});

function arf_edit_entries_in_viewmodel(entry_id) {

    jQuery('.arfentry_modal_content .arf_editable_entry_icon_wrapper').each(function(){
        jQuery(this).addClass('arfhelptip');
        jQuery(this).attr('title','Click to edit');
    });

    if (jQuery.isFunction(jQuery().tipso)) {
        jQuery('.arfentry_modal_content .arfhelptip').tipso({
            position: 'top',
            maxWidth: '400',
            useTitle: true,
            background: '#444444',
            color: '#ffffff',
            width: 'auto',
            tooltipHover: true,
        });
    }

    jQuery('.arf_edit_type_text').editable({
        type: 'text',
        pk: 1,
        inputclass: 'input-large',
        placement:'bottom',
        toggle:'manual',
        success: function(response, newValue) {

            var field_id = jQuery(this).attr('data-id');
            var field_type = jQuery(this).attr('data-ftype');
            var entry_id = jQuery(this).attr('data-entry-id');

            jQuery("input#arf_edit_new_values_"+field_id+"_"+entry_id).val(newValue);
            jQuery("input#arf_edit_new_values_"+field_id+"_"+entry_id).addClass('arf_changed_value');

            if( 'date' == field_type ){
                var formatted_value = jQuery(this).attr('data-formatted-value');
                if( '' != newValue ){
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id + '_date').val(formatted_value);
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id + '_date').addClass('arf_changed_value');
                } else {
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id + '_date').val();
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id + '_date').addClass('arf_changed_value');
                }
            }
            if( 'time' == field_type ){
                var formatted_value = jQuery(this).attr('data-time-formatted-value');
                if( '' != newValue ){
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id ).val(formatted_value);
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id ).addClass('arf_changed_value');
                } else {
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id ).val();
                    jQuery('input#arf_edit_new_values_' + field_id + '_' + entry_id ).addClass('arf_changed_value');
                }
            }

            jQuery('input#arf_is_edit_entries').val('yes').attr('data-entry-id',entry_id);
        }
    });

    jQuery('.arf_edit_type_text').on('shown', function(e, editable) {
        jQuery(this).parent().find('.arf_editable_entry_icon_wrapper').addClass('arfactive');
    });
    jQuery('.arf_edit_type_text').on('hidden', function(e, editable) {
        jQuery(this).parent().find('.arf_editable_entry_icon_wrapper').removeClass('arfactive');
    });

    var select_obj = [];
    var select_arr = jQuery('input#arf_edit_select_value_array_'+entry_id).val();

    var temp_obj = jQuery('#arf_edit_select_array_'+entry_id).val();
    
    if (typeof(temp_obj) != 'undefined' && temp_obj != '') {
        select_obj = arf_parse_json(temp_obj);
    } else {
        if (typeof(select_arr) != 'undefined') {
            select_obj = arf_parse_json(select_arr);
        }
    }
    var select_val_obj = [];
    var select_val_arr = jQuery('input#arf_edit_select_value_array_'+entry_id).val();
    
    if (typeof(select_val_arr) != 'undefined') {
        select_val_obj = arf_parse_json(select_val_arr);
    } else {
        if (typeof(__ARF_edit_select_value_array) != 'undefined' && __ARF_edit_select_value_array != null) {
            select_val_obj = __ARF_edit_select_value_array;
        }
    }
    
    jQuery.each(select_obj, function(idx, obj) {

        jQuery.each(obj, function(i, o) {

            var value = '';
            if (typeof(select_val_obj[i]) != 'undefined') {
                value = select_val_obj[i];
            }

            jQuery('.arf_edit_type_select_option_' + i).editable({
                type: 'text',
                value: value,
                source: o,
                toggle:'manual',
                success: function(response, newValue) {
                    var field_id = jQuery(this).attr('data-id');
                    var field_type = jQuery(this).attr('data-field-type');
                    var entry_id = jQuery(this).attr('data-entry-id');
                    jQuery("input#arf_edit_new_values_"+field_id+"_"+entry_id).val(newValue).attr('data-field-type',field_type);
                    jQuery("input#arf_edit_new_values_"+field_id+"_"+entry_id).addClass('arf_changed_value');
                    jQuery('input#arf_is_edit_entries').val('yes').attr('data-entry-id',entry_id);
                }
            });

            jQuery('.arf_edit_type_select_option_' + i).on('shown', function(e, editable) {
                jQuery(this).parent().find('.arf_editable_entry_icon_wrapper').addClass('arfactive');
                if (typeof editable != 'undefined' ){
                    var selected_val = editable.value;
                    jQuery('.editable-input').find('dl ul').find('li[data-value="'+selected_val+'"]').trigger('click');
                    jQuery('.editable-input').find('dl').removeClass('open');
                    jQuery('.editable-input').find('dl').removeClass('open_from_top');
                }
            });
            jQuery('.arf_edit_type_select_option_' + i).on('hidden', function(e, editable) {
                jQuery(this).parent().find('.arf_editable_entry_icon_wrapper').removeClass('arfactive');
            });

        });
    });

    arf_init_matrix_entries_for_editable( entry_id, 'view_entry' );
}

function arf_init_matrix_entries_for_editable( entry_id, wrapper ){
    var matrix_obj = [];
    var matrix_val_arr = jQuery('input#arf_edit_matrix_value_array_' + entry_id).val();

    if( typeof matrix_val_arr != 'undefined' ){
        matrix_obj = arf_parse_json( matrix_val_arr );
    } else {
        if( typeof __ARF_edit_matrix_value_array != 'undefined' && null != __ARF_edit_matrix_value_array ){
            matrix_obj = __ARF_edit_matrix_value_array;
        }
    }

    jQuery.each(matrix_obj, function(idx, obj){
        
        jQuery.each(obj, function(i,o){
            var value = '';
            
            if (typeof(obj[i]) != 'undefined') {
                value = obj[i];
            }

            jQuery('.arf_edit_type_matrix_option_' + idx + '_' + i).editable({
                type: 'text',
                value: value,
                source: o,
                toggle:'manual',
                success: function(response, newValue) {
                    var field_id = jQuery(this).attr('data-id');
                    var field_type = jQuery(this).attr('data-field-type');
                    var entry_id = jQuery(this).attr('data-entry-id');
                    if( 'view_entry' == wrapper ){
                        jQuery('.arf_popup_container.arf_view_entry_modal.arfactive').find("input#arf_edit_new_matrix_values_"+field_id+"_"+entry_id+"_"+i).val(newValue).attr('data-field-type',field_type);
                        jQuery('.arf_popup_container.arf_view_entry_modal.arfactive').find("input#arf_edit_new_matrix_values_"+field_id+"_"+entry_id+"_"+i).addClass('arf_changed_value');
                        jQuery('input#arf_is_edit_entries').val('yes').attr('data-entry-id',entry_id);
                    } else if( 'view_matrix_entry' == wrapper ) {
                        jQuery('.arf_popup_container.arf_matrix_view_entry_modal.arfactive').find("input#arf_edit_new_matrix_values_"+field_id+"_"+entry_id+"_"+i).val(newValue).attr('data-field-type',field_type);
                        jQuery('.arf_popup_container.arf_matrix_view_entry_modal.arfactive').find("input#arf_edit_new_matrix_values_"+field_id+"_"+entry_id+"_"+i).addClass('arf_changed_value');
                        jQuery('input#arf_is_matrix_edit_entries').val('yes').attr('data-entry-id',entry_id);
                    }
                }
            });

            jQuery('.arf_edit_type_matrix_option_' + i).on('shown', function(e, editable) {
                jQuery(this).parent().find('.arf_editable_entry_icon_wrapper').addClass('arfactive');
                if (typeof editable != 'undefined' ){
                    var selected_val = editable.value;
                    
                }
            });
            jQuery('.arf_edit_type_matrix_option_' + i).on('hidden', function(e, editable) {
                jQuery(this).parent().find('.arf_editable_entry_icon_wrapper').removeClass('arfactive');
            });

        });
    })
}
function open_entry_thickbox(id,title) {
    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_view_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_view_entry_modal').addClass('arfactive');
    jQuery('.arf_view_entry_modal').find('#arf_view_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_entry_detail_container_' + id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arf_popup_container.arf_view_entry_modal').find('.arfentry_modal_content').html(view_entry_data);
    jQuery('.arf_view_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_view_entry_modal').addClass('arf_popup_container_view_entry_modal');
    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_view_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_view_entry_modal').addClass('arf_entry_model_larger');
    }
    if (jQuery.isFunction(jQuery().editable)) {
        arf_edit_entries_in_viewmodel(id);
    }
    
    if( !jQuery('.arf_view_entry_modal.arfactive').parent().hasClass('arf_entry_popup_container_wrapper') ){
        jQuery('.arf_view_entry_modal.arfactive').wrap('<div class="arf_entry_popup_container_wrapper" />');
    }

    var _wpnonce_arflite = jQuery("#arforms_wp_nonce").val();
	var form_id = jQuery( "#arfredirecttolist" ).val();

    jQuery('#status_' + id).parents('tr').removeClass('arf_unread_entry');

	jQuery.ajax(
		{
			url: ajaxurl,
			type: 'POST',
			dataType: 'json',
			data: "action=arf_read_unread_flag&entry_id=" + id + '&form_id='+ form_id + "&_wpnonce_arflite=" + _wpnonce_arflite,
			success: function(response) {
				if(response.error == true)
				{
					jQuery( "#records_error_message_des" ).html( response.message );
					arforms_error_msg();
				}
				else
				{
					if(response.message ==0)
					{
						jQuery(".arf_entries_flag").hide();
					}
					else
					{
						jQuery(".arf_entries_flag").html(response.message);
					}
				}
			}
		});
}

function open_partial_entry_thickbox(id,title) {

    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').find('#arf_view_incomplete_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_partial_entry_detail_container_' + id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arfincompleteentry_modal_content').html(view_entry_data);
    jQuery('.arf_view_incomplete_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arf_popup_container_view_entry_modal');

    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_view_incomplete_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_view_incomplete_entry_modal').addClass('arf_entry_model_larger');
    }
    
    if( !jQuery('.arf_view_incomplete_entry_modal.arfactive').parent().hasClass('arf_incomplete_entry_popup_container_wrapper') ){
        jQuery('.arf_view_incomplete_entry_modal.arfactive').wrap('<div class="arf_incomplete_entry_popup_container_wrapper" />');
    }
}

function open_incomplete_repeater_entry_thickbox( id, repeater_id, title ){
    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_repeater_incomplete_view_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_repeater_incomplete_view_entry_modal').addClass('arfactive');
    jQuery('.arf_repeater_incomplete_view_entry_modal').addClass('arfwidthauto');
    jQuery('.arf_repeater_incomplete_view_entry_modal').find('#arf_view_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_repeater_incomplete_entry_detail_container_' + id + '_' + repeater_id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arfentry_modal_content').html(view_entry_data);
    
    jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive table.form-table').css('width','auto');
    var modal_width = jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive table.form-table').width();
    jQuery('.arf_repeater_incomplete_view_entry_modal').removeClass('arfwidthauto');
    var parent_width = jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive .arf_popup_content_container')[0].clientWidth;
    
    if( parent_width > modal_width ){
        jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive table.form-table').css('width', '100%');
    } else {
        jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive table.form-table').css('width',( parseInt(modal_width) + 100 ) + 'px');
    }
    jQuery('.arf_repeater_incomplete_view_entry_modal .arf_popup_content_container').css('overflow-x','auto');

    jQuery('.arf_repeater_incomplete_view_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_repeater_incomplete_view_entry_modal').addClass('arf_popup_container_view_entry_modal');
    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_repeater_incomplete_view_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_repeater_incomplete_view_entry_modal').addClass('arf_entry_model_larger');
    }
}

function open_repeater_entry_thickbox( id, repeater_id, title ){
 

    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_repeater_view_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_repeater_view_entry_modal').addClass('arfactive');
    jQuery('.arf_repeater_view_entry_modal').addClass('arfwidthauto');
    jQuery('.arf_repeater_view_entry_modal').find('#arf_view_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_repeater_entry_detail_container_' + id + '_' + repeater_id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arfentry_modal_content').html(view_entry_data);
    jQuery('.arf_repeater_view_entry_modal.arfactive table.form-table').css('width','auto');
    var modal_width = jQuery('.arf_repeater_view_entry_modal.arfactive table.form-table').width();
    jQuery('.arf_repeater_view_entry_modal').removeClass('arfwidthauto');
    var parent_width = jQuery('.arf_repeater_view_entry_modal.arfactive .arf_popup_content_container')[0].clientWidth;
    if( parent_width > modal_width ){
        jQuery('.arf_repeater_view_entry_modal.arfactive table.form-table').css('width', '100%');
    } else {
        jQuery('.arf_repeater_view_entry_modal.arfactive table.form-table').css('width',( parseInt(modal_width) + 100 ) + 'px');
    }
    jQuery('.arf_repeater_view_entry_modal .arf_popup_content_container').css('overflow-x','auto');
    jQuery('.arf_repeater_view_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_repeater_view_entry_modal').addClass('arf_popup_container_view_entry_modal');
    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_repeater_view_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_repeater_view_entry_modal').addClass('arf_entry_model_larger');
    }
    if( jQuery.isFunction( jQuery().editable) ){
        arf_edit_repeater_entries_in_viewmodel( id, repeater_id );
    }
}

function open_matrix_entry_thickbox( id, matrix_id, title ){
    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_matrix_view_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_matrix_view_entry_modal').addClass('arfactive');
    jQuery('.arf_matrix_view_entry_modal').addClass('arfwidthauto');
    jQuery('.arf_matrix_view_entry_modal').find('#arf_view_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_matrix_entry_detail_container_' + id + '_' + matrix_id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arfentry_modal_content').html(view_entry_data);
    jQuery('.arf_matrix_view_entry_modal').removeClass('arfwidthauto');
    jQuery('.arf_matrix_view_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_matrix_view_entry_modal').addClass('arf_popup_container_view_entry_modal');
    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_matrix_view_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_matrix_view_entry_modal').addClass('arf_entry_model_larger');
    }
    if (jQuery.isFunction(jQuery().editable)) {
        arf_init_matrix_entries_for_editable(id, 'view_matrix_entry');
    }
}

function open_matrix_incomplete_entry_thickbox( id, matrix_id, title ){
    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arfwidthauto');
    jQuery('.arf_view_incomplete_entry_modal').find('#arf_view_incomplete_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_matrix_entry_detail_container_' + id + '_' + matrix_id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arfincompleteentry_modal_content').html(view_entry_data);
    jQuery('.arf_view_incomplete_entry_modal').removeClass('arfwidthauto');
    jQuery('.arf_view_incomplete_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arf_popup_container_view_entry_modal');
    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_view_incomplete_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_view_incomplete_entry_modal').addClass('arf_entry_model_larger');
    }
    if (jQuery.isFunction(jQuery().editable)) {
        arf_init_matrix_entries_for_editable(id, 'view_matrix_incomplete_entry');
    }
}

function open_incomplete_entry_thickbox(id,title){
    jQuery('.arf_modal_overlay').removeClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').parents('.arf_modal_overlay').addClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arfactive');
    jQuery('.arf_view_incomplete_entry_modal').find('#arf_view_incomplete_entry_modal_form_title').html('('+title+')');
    var view_entry_data = jQuery('#view_incomplete_entry_detail_container_' + id).html();
    jQuery('html').css('overflow','hidden');
    jQuery('.arf_incomplete_entry_modal_content').html(view_entry_data);
    jQuery('.arf_view_incomplete_entry_modal').removeClass('arf_entry_model_larger');
    jQuery('.arf_view_incomplete_entry_modal').addClass('arf_popup_container_view_entry_modal');
    var screenHeight = jQuery(window).height();
    var modalHeight = jQuery('.arf_view_incomplete_entry_modal.arfactive').height();
    if( modalHeight > (screenHeight - 50) ){
        jQuery('.arf_view_incomplete_entry_modal').addClass('arf_entry_model_larger');
    }
    if (jQuery.isFunction(jQuery().editable)) {
        arf_edit_incomplete_entries_in_viewmodel(id);
    }
    
    if( !jQuery('.arf_view_incomplete_entry_modal.arfactive').parent().hasClass('arf_entry_popup_container_wrapper') ){
        jQuery('.arf_view_incomplete_entry_modal.arfactive').wrap('<div class="arf_entry_popup_container_wrapper" />');
    }   
}

function change_graph() {
    
    var form = jQuery('#arfredirecttolist3').val();
    var type = jQuery('#chart_type').val();
    var _wpnonce = jQuery('#arforms_wp_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        data: "action=updatechart&type=" + type + "&form=" + form +"&_wpnonce=" + _wpnonce,
        success: function(msg) {
            jQuery('#chart_div').html(msg);
        }
    });
}

function change_graph_pre(type,enable) {

    if(enable == 0){
        return false;
    }
    var form = jQuery('#arfredirecttolist3').val();
    var graph_type = jQuery('input[name=arfgraphtype]:checked').val();
    if (type == "yearly") {
        var val = jQuery('#current_year').val();
        var new_year = val - 1;
        jQuery('#current_year').val(new_year);
        var last_arg = "&new_year=" + new_year;
    } else if (type == "monthly") {
        var val = jQuery('#current_month').val();
        var val_year = jQuery('#current_month_year').val();
        var new_month = parseInt(val);
        var new_month_year = parseInt(val_year);
        if (new_month == 1) {
            new_month_year = new_month_year - 1;
            new_month = 12;
        } else {
            new_month = new_month - 1;
        }
        jQuery('#current_month').val(new_month);
        jQuery('#current_month_year').val(new_month_year);
        var last_arg = "&new_month=" + new_month + "&new_month_year=" + new_month_year;
    } else if (type == "daily") {
        var val = jQuery('#current_day').val();
        var val_day_month = jQuery('#current_day_month').val();
        var val_day_year = jQuery('#current_day_year').val();
        var new_day = parseInt(val);
        var new_day_month = parseInt(val_day_month);
        var new_day_year = parseInt(val_day_year);
        if (val == 1) {
            new_day_month = new_day_month - 1;
            if (new_day_month == 0) {
                new_day_month = 12;
            }
            var d = new Date(new_day_year, new_day_month, 0);
            new_day = d.getDate();
        } else {
            new_day = parseInt(val) - 1;
        }
        if (val_day_month == 1 && val == 1) {
            new_day_year = new_day_year - 1;
        } else {
            new_day_year = new_day_year;
        }
        jQuery('#current_day').val(new_day);
        jQuery('#current_day_month').val(new_day_month);
        jQuery('#current_day_year').val(new_day_year);
        var last_arg = "&new_day=" + new_day + "&new_day_month=" + new_day_month + "&new_day_year=" + new_day_year;
    }
    var _wpnonce = jQuery('#arforms_wp_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        beforeSend: function() {
            jQuery('div#arf_full_width_loader').hide();
            jQuery('div#arf_graph_changes_loader').show();
        },
        data: "action=updatechart&type=" + type + "&form=" + form + "&calculate=pre" + last_arg+"&graph_type=" + graph_type + "&_wpnonce=" + _wpnonce,
        success: function(msg) {
            jQuery('div#arf_full_width_loader').hide();
            jQuery('div#arf_graph_changes_loader').hide();
            jQuery('#chart_div').html(msg);

        }
    });
}

function change_graph_next(type,enable) {
    if(enable == 0)
    {
        return false;
    }
    var form = jQuery('#arfredirecttolist3').val();
    var last_arg;
    var graph_type = jQuery('input[name=arfgraphtype]:checked').val();
    if (type == "yearly") {
        var val = jQuery('#current_year').val();
        var new_year = parseInt(val) + 1;
        jQuery('#current_year').val(new_year);
        var last_arg = "&new_year=" + new_year;
    } else if (type == "monthly") {
        var val = jQuery('#current_month').val();
        var val_year = jQuery('#current_month_year').val();
        var new_month = parseInt(val);
        var new_month_year = parseInt(val_year);
        if (new_month == 12) {
            new_month_year = new_month_year + 1;
            new_month = 1;
        } else {
            new_month = new_month + 1;
        }
        jQuery('#current_month').val(new_month);
        jQuery('#current_month_year').val(new_month_year);
        var last_arg = "&new_month=" + new_month + "&new_month_year=" + new_month_year;
    } else if (type == "weekly") {
        var val = jQuery('#current_week').val();
        var new_week = parseInt(val) + 1;
        jQuery('#current_month').val(new_week);
        var last_arg = "&new_week=" + new_week;
    } else if (type == "daily") {
        var val = jQuery('#current_day').val();
        var val_day_month = jQuery('#current_day_month').val();
        var val_day_year = jQuery('#current_day_year').val();
        var new_day = parseInt(val);
        var new_day_month = parseInt(val_day_month);
        var new_day_year = parseInt(val_day_year);
        var d = new Date(new_day_year, new_day_month, 0);
        var old_day = d.getDate();
        if (val == old_day) {
            var new_day_month = new_day_month + 1;
            var new_day = 1;
        } else {
            var new_day = parseInt(val) + 1;
        }
        if (val_day_month == 12 && (val == old_day)) {
            var new_day_year = new_day_year + 1;
            var new_day = 1;
            var new_day_month = 1;
        } else {
            new_day_year = new_day_year;
        }
        jQuery('#current_day').val(new_day);
        jQuery('#current_day_month').val(new_day_month);
        jQuery('#current_day_year').val(new_day_year);
        var last_arg = "&new_day=" + new_day + "&new_day_month=" + new_day_month + "&new_day_year=" + new_day_year;
    }
    var _wpnonce = jQuery('#arforms_wp_nonce').val();
    jQuery.ajax({
        type: "POST",
        url: ajaxurl,
        beforeSend: function() {
            jQuery('div#arf_full_width_loader').hide();
            jQuery('div#arf_graph_changes_loader').show();
        },
        data: "action=updatechart&type=" + type + "&form=" + form + "&calculate=next" + last_arg+"&graph_type=" + graph_type +"&_wpnonce=" + _wpnonce,
        success: function(msg) {
            jQuery('div#arf_full_width_loader').hide();
            jQuery('div#arf_graph_changes_loader').hide();
            jQuery('#chart_div').html(msg);
        }
    });
}
function arfincompleteentryactionfunc(act,id){
    if( 'delete' == act ){
        id = document.getElementById('delete_entry_id').value;
    }
    
    var form = jQuery('#arfredirecttolist').val();
    var srart_date = jQuery('#datepicker_from').val();
    var end_date = jQuery('#datepicker_to').val();
    if (act == 'delete') {
        arf_delete_single_incompelete_entry(id);
        return false;
    }
    
    if (act == 'delete') {
        jQuery('[data-dismiss="arfmodal"]').trigger("click");
    }
    return false;
}

jQuery(document).on( 'click', '.arf_bulk_delete_incomplete_entry_close_btn', function(){
    jQuery( "#delete_bulk_incomplete_entry_message" ).removeClass( 'arfactive' );
    jQuery( "#delete_bulk_incomplete_entry_message" ).parents( '.arf_modal_overlay' ).removeClass( 'arfactive' );
});
jQuery(document).on('click', '#example_wrapper .ColVis_Button:not(.ColVis_MasterButton)',function(){    

	var _wpnonce = jQuery("#arforms_wp_nonce").val();
	var colsArray = jQuery('#example_wrapper .ColVis_Button:not(.ColVis_MasterButton)').map(function () {
		return [[ encodeURIComponent(jQuery(this).find('.ColVis_title').text()), jQuery(this).hasClass('active') ? 'visibile' : 'hidden']];
	}).get();
	var form = jQuery('#arfredirecttolist').val();

	if (form == '') {
		return false;
	}

	jQuery.ajax({
		type: "POST",
		url: ajaxurl,
		data: "action=managecolumns&colsArray=" + colsArray + "&form=" + form +"&_wpnonce=" + _wpnonce,
		success: function (msg) {
			var wrapper_width = jQuery(".frm_entries_page #example_wrapper").outerWidth();
			var table_head_width = jQuery(".frm_entries_page table#example thead").outerWidth();
			
			if( table_head_width >= wrapper_width ){
				jQuery(".frm_entries_page table#example").css('display','block');
			} else {
				jQuery(".frm_entries_page table#example").css('display','');
			}
		}
	});

});
